/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_mmxmem_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern16 (x1); /* [-1, 1] */
}

int
pattern21 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern6 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern6 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern25 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern25 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern25 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern25 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern25 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern25 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern25 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern25 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern25 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V32QImode:
      if (pattern5 (x3, 
E_V32QImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern5 (x3, 
E_V16HImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern5 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16SImode:
      if (pattern5 (x3, 
E_V16SImode) != 0)
        return -1;
      return 12;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 13;

    case E_V8DImode:
      if (pattern5 (x3, 
E_V8DImode) != 0)
        return -1;
      return 14;

    case E_V4DImode:
      if (pattern5 (x3, 
E_V4DImode) != 0)
        return -1;
      return 15;

    case E_V2DImode:
      if (pattern5 (x3, 
E_V2DImode) != 0)
        return -1;
      return 16;

    case E_V64QImode:
      if (pattern5 (x3, 
E_V64QImode) != 0)
        return -1;
      return 17;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 18;

    case E_V32HImode:
      if (pattern5 (x3, 
E_V32HImode) != 0)
        return -1;
      return 19;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern14 (x3, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern14 (x3, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern14 (x3, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!mask_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !mask_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mask_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !mask_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!mask_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !mask_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !mask_reg_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 1;

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 3;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 5;

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 6;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT
      || GET_MODE (x3) != E_V8HImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_V4HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_CONCAT
      || GET_MODE (x10) != E_V8HImode)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 4)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || !register_operand (operands[0], E_V4HImode)
      || GET_MODE (x1) != E_V4HImode
      || pattern53 (x1) != 0)
    return -1;
  return 0;
}

int
pattern119 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || pattern41 (x1, 
E_SImode, 
E_DImode) != 0)
    return -1;
  return 0;
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern124 (x2, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern124 (x2, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return 0;

        case E_V16HImode:
          return 1;

        case E_V32HImode:
          return 2;

        case E_V8SImode:
          return 3;

        case E_V16SImode:
          return 4;

        case E_V8DImode:
          return 5;

        case E_V4SImode:
          return 6;

        case E_V4DImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (XVECLEN (x6, 0))
        {
        case 4:
          x8 = XVECEXP (x6, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x6, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || GET_MODE (x5) != E_V4HFmode
              || !register_operand (operands[1], E_V8HFmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern135 (x1, 
E_V4SImode) != 0)
                return -1;
              return 9;

            case E_V4DImode:
              if (pattern135 (x1, 
E_V4DImode) != 0)
                return -1;
              return 10;

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x6, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x6, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              return 11;

            case E_V2SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode))
                return -1;
              return 12;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      return pattern166 (x3, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SFmode:
      if (pattern166 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SFmode:
      if (pattern166 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4HFmode:
          if (!const0_operand (operands[2], E_V4HFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!vector_operand (operands[1], E_V4SImode))
                return -1;
              return 0;

            case E_V4DImode:
              if (!vector_operand (operands[1], E_V4DImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2HFmode:
          if (!vector_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V6HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern177 (x1, 
E_V2SFmode, 
E_V2DImode, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern191 (x1, 
E_V16SImode, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern191 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x5) != E_V2DImode
          || GET_MODE (x6) != E_V2SImode
          || !vector_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return pattern221 (x1); /* [-1, 1] */
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern126 (x1); /* [-1, 1] */
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern234 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern234 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern234 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern234 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern260 (); /* [-1, 2] */
}

int
pattern266 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (pnum_clobbers == NULL
          || maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          return pattern265 (x1); /* [-1, 1] */

        case PLUS:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern265 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern2 (x1);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        default:
          return -1;
        }

    case CONST_INT:
      return 6;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LTU:
    case UNLT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!flags_reg_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_mmxmem_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern307 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !nonimmediate_operand (operands[1], E_HImode)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern315 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !float_vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern320 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern327 (x1, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern327 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern339 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  return pattern342 (x6); /* [-1, 5] */
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  return pattern347 (x6); /* [-1, 5] */
}

int
pattern354 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ZERO_EXTEND)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  return pattern353 (x3); /* [-1, 3] */
}

int
pattern359 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return pattern358 (x2); /* [-1, 3] */
}

int
pattern366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !ix86_comparison_operator (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern376 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern381 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern380 (x6, 
37); /* [-1, 0] */
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 21
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != CONST
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[1] = x13;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x14 = XVECEXP (x4, 0, 1);
  operands[2] = x14;
  if (!constant_call_address_operand (operands[2], E_VOIDmode))
    return -1;
  x15 = XVECEXP (x7, 0, 0);
  operands[3] = x15;
  if (!tls_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x16 = XEXP (x8, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x17 = XEXP (x9, 0);
  operands[5] = x17;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern414 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LTU)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode
      || !nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || GET_MODE (x2) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern256 (x5, 
E_DImode, 
E_TImode); /* [-1, 1] */
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern439 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      operands[3] = x3;
      x4 = XEXP (x1, 0);
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      return pattern437 (x1); /* [-1, 1] */

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_QImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      x6 = XEXP (x4, 1);
      if (!nonmemory_operand (x6, E_QImode))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 64L:
          if (pattern438 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case 32L:
          if (pattern438 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern460 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern453 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern453 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern453 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern486 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern486 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern486 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern486 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern486 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern486 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern486 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern486 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern486 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern486 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SFmode
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[3], E_V2SFmode)
      || !const0_operand (operands[4], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern502 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!nonimmediate_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!nonimmediate_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern521 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!memory_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XINT (x2, 1) != 151)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (XVECLEN (x5, 0))
    {
    case 16:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          return pattern526 (x1, 
E_V32HImode, 
E_V16HImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern526 (x1, 
E_V32QImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 8:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern526 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V8SImode:
          if (pattern526 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 32:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x22 = XVECEXP (x5, 0, 16);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x23 = XVECEXP (x5, 0, 17);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x24 = XVECEXP (x5, 0, 18);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
        return -1;
      x25 = XVECEXP (x5, 0, 19);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
        return -1;
      x26 = XVECEXP (x5, 0, 20);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
        return -1;
      x27 = XVECEXP (x5, 0, 21);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
        return -1;
      x28 = XVECEXP (x5, 0, 22);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
        return -1;
      x29 = XVECEXP (x5, 0, 23);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
        return -1;
      x30 = XVECEXP (x5, 0, 24);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x31 = XVECEXP (x5, 0, 25);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x32 = XVECEXP (x5, 0, 26);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x33 = XVECEXP (x5, 0, 27);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x34 = XVECEXP (x5, 0, 28);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x35 = XVECEXP (x5, 0, 29);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x36 = XVECEXP (x5, 0, 30);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x37 = XVECEXP (x5, 0, 31);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern526 (x1, 
E_V64QImode, 
E_V32QImode) != 0)
        return -1;
      return 4;

    case 4:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern526 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern604 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[3] = x4;
  if (!nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern618 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern626 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern631 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[3] = x3;
      return pattern636 (x1); /* [-1, 28] */

    case NEG:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      return 29;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern650 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern661 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      return pattern659 (x1, 
E_V8SImode, 
E_V8SFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern659 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V4DFmode:
      if (pattern659 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
        return -1;
      return 2;

    case E_V2DFmode:
      if (pattern659 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
        return -1;
      return 3;

    case E_V32QImode:
      if (pattern660 (x1, 
E_V32QImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern660 (x1, 
E_V16QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern671 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  return 0;
}

int
pattern707 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return 0;
}

int
pattern714 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern721 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != i2
      || XINT (x7, 1) != i1
      || pattern720 (x6, 
E_CCmode, 
17) != 0)
    return -1;
  return 0;
}

int
pattern729 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x2, 0);
  operands[4] = x4;
  if (!register_operand (operands[4], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  return pattern727 (x6, 
i1); /* [-1, 0] */
}

int
pattern739 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode))
        return -1;
      return 3;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern759 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern283 (x1); /* [-1, 1] */
}

int
pattern769 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  x9 = XEXP (x1, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern768 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern768 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern768 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern781 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern788 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x2, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern787 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern787 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern787 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern787 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern787 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern787 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern787 (x1, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern787 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern787 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern787 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern787 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern787 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      if (pattern787 (x1, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_V16HFmode:
      if (pattern787 (x1, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      return 13;

    case E_V8HFmode:
      if (pattern787 (x1, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      return 14;

    case E_V32BFmode:
      if (pattern787 (x1, 
E_V32BFmode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_V16BFmode:
      if (pattern787 (x1, 
E_V16BFmode, 
E_HImode) != 0)
        return -1;
      return 16;

    case E_V8BFmode:
      if (pattern787 (x1, 
E_V8BFmode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V16SFmode:
      if (pattern787 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 18;

    case E_V8SFmode:
      if (pattern787 (x1, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4SFmode:
      if (pattern787 (x1, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8DFmode:
      if (pattern787 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern787 (x1, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V2DFmode:
      if (pattern787 (x1, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern831 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_TFmode
      || !vector_operand (operands[1], E_TFmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!vector_operand (operands[2], E_TFmode))
    return -1;
  return 0;
}

int
pattern839 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[0]))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      return 0;

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern846 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != EQ)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != EQ)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 1);
  operands[5] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4HImode:
          return pattern845 (x4, 
E_V4HImode); /* [-1, 0] */

        case E_V2SImode:
          if (pattern845 (x4, 
E_V2SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !register_operand (operands[2], E_V4QImode)
          || GET_MODE (x2) != E_V4QImode
          || GET_MODE (x3) != E_V2HImode
          || pattern845 (x4, 
E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern863 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern872 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern880 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (XWINT (x2, 0) != 1L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern626 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern626 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern888 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern898 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern906 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern913 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern918 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != CONST_VECTOR
      || XVECLEN (x4, 0) != 2
      || GET_MODE (x4) != E_V2SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return pattern500 (x2); /* [-1, 1] */
}

int
pattern924 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern929 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  return 0;
}

int
pattern947 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != AND)
        return -1;
      return 0;

    case CLOBBER:
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern964 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern966 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern971 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 3;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 4;

    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[2], E_V8HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 5;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[2], E_V8SFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 6;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[2], E_V4SFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 7;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[2], E_V8DFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 8;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[2], E_V4DFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 9;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[2], E_V2DFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 10;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern997 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1001 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!nonimmediate_operand (x5, i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (!nonimmediate_operand (x6, i1))
    return -1;
  return 0;
}

int
pattern1014 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1023 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1028 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1037 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern1036 (x6) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1096 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2DImode
      || !nonimm_or_0_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1101 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1114 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (XWINT (x3, 0) != 1L)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const48_operand (operands[5], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1121 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1121 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1121 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1140 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      switch (XWINT (x3, 0))
        {
        case 1L:
          return 0;

        case 2L:
          return 1;

        default:
          return -1;
        }

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (XWINT (x4, 0) != 5L)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (XWINT (x5, 0) != 7L)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 19
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern203 (x1); /* [-1, 3] */
}

int
pattern1171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1179 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[4], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case REG:
      if (peep2_current_count < 4)
        return -1;
      operands[5] = x3;
      if (!general_reg_operand (operands[5], i1))
        return -1;
      x4 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[5]))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1198 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_unset_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1237 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (!const_0_to_63_operand (x6, E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (!const_0_to_31_operand (x6, E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4QImode:
      if (GET_MODE (x1) != E_V4QImode)
        return -1;
      return 0;

    case E_V2QImode:
      if (GET_MODE (x1) != E_V2QImode)
        return -1;
      return 1;

    case E_V2HImode:
      if (GET_MODE (x1) != E_V2HImode)
        return -1;
      return 2;

    case E_QImode:
      if (pattern1250 (x1, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_HImode:
      if (pattern1250 (x1, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_SImode:
      if (pattern1250 (x1, 
E_SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern1250 (x1, 
E_DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern1265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return pattern1264 (x1); /* [-1, 5] */

    default:
      return -1;
    }
}

int
pattern1275 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1285 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern1296 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SFmode)
      || GET_MODE (x1) != E_V8SFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SFmode
      || !nonimm_or_0_operand (operands[2], E_V8SFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      return 0;

    case E_V8DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1313 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1318 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !const_1_to_31_operand (operands[2], E_QImode)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern1321 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern1321 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1331 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern559 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  return pattern403 (x1); /* [-1, 1] */
}

int
pattern1340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CALL)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  return 0;
}

int
pattern1348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1361 (); /* [-1, 3] */
}

int
pattern1365 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1382 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1369 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1391 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1400 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1410 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1425 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern1435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1442 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1447 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1467 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[2], i1)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1472 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1482 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1497 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 64L:
      return pattern1496 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

    case 32L:
      if (pattern1496 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1508 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1515 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[2], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != i1)
        return -1;
      x7 = XEXP (x5, 0);
      if (!rtx_equal_p (x7, operands[0]))
        return -1;
      x8 = PATTERN (peep2_next_insn (2));
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      x10 = XEXP (x3, 0);
      switch (GET_CODE (x10))
        {
        case REG:
          return pattern1187 (x1, 
i1); /* [-1, 0] */

        case PLUS:
          if (pattern1188 (x1, 
i1) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case PLUS:
      res = pattern1190 (x1, 
i1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      res = pattern1191 (x1, 
i1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1550 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x13, 1);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern1563 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !general_reg_operand (operands[4], i1)
      || !general_reg_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1581 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1599 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1598 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1598 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1610 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return pattern1042 (x1); /* [-1, 5] */

    default:
      return -1;
    }
}

int
pattern1629 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1640 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1649 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1648 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1648 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1663 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 2);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1673 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_0_to_63_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x1, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1685 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

int
pattern1693 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode)
          || !register_operand (operands[6], E_HImode)
          || !register_operand (operands[3], E_V16SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode)
          || !register_operand (operands[6], E_QImode)
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1705 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1714 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1714 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1726 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1733 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1732 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1732 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1742 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1)
      || !scratch_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1741 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1741 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1755 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  operands[2] = x1;
  x2 = PATTERN (peep2_next_insn (1));
  return pattern1754 (x2, 
i1); /* [-1, 0] */
}

int
pattern1762 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode)
          || !register_operand (operands[6], E_HImode)
          || !register_operand (operands[3], E_V16SImode)
          || !scratch_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (pattern1761 (
E_QImode, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1770 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1782 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[4], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1789 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[2], i1)
      || pattern1787 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1805 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  return 0;
}

int
pattern1816 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[7], i1)
      || !register_operand (operands[3], i2)
      || !scratch_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1822 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6L)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 22L)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7L)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 23L)
    return -1;
  return 0;
}

int
pattern1825 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1829 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6L)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 22L)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7L)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 23L)
    return -1;
  return 0;
}

int
pattern1838 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  operands[5] = x1;
  if (!register_operand (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != COMPARE)
    return -1;
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17)
    return -1;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[5]))
    return -1;
  return 0;
}

int
pattern1847 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_scalar_int_operand (operands[6], i2)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern1855 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_reg_operand (operands[0], i1)
      || !memory_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2
      || !ix86_carry_flag_operator (operands[3], i2))
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = PATTERN (peep2_next_insn (1));
  x13 = XEXP (x12, 1);
  switch (GET_CODE (x13))
    {
    case REG:
      if (!rtx_equal_p (x13, operands[0]))
        return -1;
      x14 = XEXP (x12, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case LTU:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x13) != E_QImode)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 17
          || GET_MODE (x15) != E_CCCmode)
        return -1;
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x12, 0);
      operands[5] = x14;
      if (!general_reg_operand (operands[5], E_QImode))
        return -1;
      x17 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != ZERO_EXTEND
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x17, 0);
      operands[6] = x19;
      if (!general_reg_operand (operands[6], i1))
        return -1;
      x20 = XEXP (x18, 0);
      if (!rtx_equal_p (x20, operands[5]))
        return -1;
      x21 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x21) != SET)
        return -1;
      x22 = XEXP (x21, 1);
      if (!rtx_equal_p (x22, operands[0]))
        return -1;
      x23 = XEXP (x21, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1882 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 24);
  if (XWINT (x2, 0) != 28L)
    return -1;
  x3 = XVECEXP (x1, 0, 25);
  if (XWINT (x3, 0) != 60L)
    return -1;
  x4 = XVECEXP (x1, 0, 26);
  if (XWINT (x4, 0) != 29L)
    return -1;
  x5 = XVECEXP (x1, 0, 27);
  if (XWINT (x5, 0) != 61L)
    return -1;
  x6 = XVECEXP (x1, 0, 28);
  if (XWINT (x6, 0) != 30L)
    return -1;
  x7 = XVECEXP (x1, 0, 29);
  if (XWINT (x7, 0) != 62L)
    return -1;
  x8 = XVECEXP (x1, 0, 30);
  if (XWINT (x8, 0) != 31L)
    return -1;
  x9 = XVECEXP (x1, 0, 31);
  if (XWINT (x9, 0) != 63L)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      return recog_8 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 59)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[2] = x7;
      x8 = XVECEXP (x4, 0, 2);
      operands[3] = x8;
      x9 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[4] = x10;
          operands[5] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern1533 (x2, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode)
                      || !nonimmediate_operand (operands[2], E_V16SImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 3278; /* avx512f_cmpv16si3_mask_round */

                case E_V16HFmode:
                  if (!register_operand (operands[1], E_V16HFmode)
                      || !nonimmediate_operand (operands[2], E_V16HFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 310 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
                    return -1;
                  return 3302; /* avx512vl_cmpv16hf3_mask_round */

                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode)
                      || !nonimmediate_operand (operands[2], E_V16SFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 3308; /* avx512f_cmpv16sf3_mask_round */

                default:
                  return -1;
                }

            case E_QImode:
              if (pattern1533 (x2, 
E_QImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !nonimmediate_operand (operands[2], E_V8SImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                    return -1;
                  return 3282; /* avx512vl_cmpv8si3_mask_round */

                case E_V8DImode:
                  if (!register_operand (operands[1], E_V8DImode)
                      || !nonimmediate_operand (operands[2], E_V8DImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 3288; /* avx512f_cmpv8di3_mask_round */

                case E_V4DImode:
                  if (!register_operand (operands[1], E_V4DImode)
                      || !nonimmediate_operand (operands[2], E_V4DImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                    return -1;
                  return 3292; /* avx512vl_cmpv4di3_mask_round */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !nonimmediate_operand (operands[2], E_V8SFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                    return -1;
                  return 3312; /* avx512vl_cmpv8sf3_mask_round */

                case E_V8DFmode:
                  if (!register_operand (operands[1], E_V8DFmode)
                      || !nonimmediate_operand (operands[2], E_V8DFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 3318; /* avx512f_cmpv8df3_mask_round */

                case E_V4DFmode:
                  if (!register_operand (operands[1], E_V4DFmode)
                      || !nonimmediate_operand (operands[2], E_V4DFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                    return -1;
                  return 3322; /* avx512vl_cmpv4df3_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x10, 0) != 1L
              || pattern1449 (x2) != 0)
            return -1;
          operands[4] = x9;
          switch (pattern1686 ())
            {
            case 0:
              if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4818 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3653; /* avx512f_vmcmpv8hf3_round */

            case 1:
              if (!
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3655; /* avx512f_vmcmpv4sf3_round */

            case 2:
              if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4818 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3657; /* avx512f_vmcmpv2df3_round */

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x10) != E_QImode)
            return -1;
          x11 = XEXP (x10, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern1449 (x2) != 0)
            return -1;
          x12 = XEXP (x10, 0);
          operands[4] = x12;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          operands[5] = x9;
          switch (pattern1686 ())
            {
            case 0:
              if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4836 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3659; /* avx512f_vmcmpv8hf3_mask_round */

            case 1:
              if (!
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3661; /* avx512f_vmcmpv4sf3_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4836 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3663; /* avx512f_vmcmpv2df3_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCFPmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != VEC_SELECT
          || pattern600 (x3) != 0
          || pattern44 (x1, 
E_CCFPmode) != 0)
        return -1;
      x13 = XEXP (x4, 0);
      operands[0] = x13;
      x10 = XEXP (x3, 1);
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x9 = XVECEXP (x2, 0, 1);
      operands[2] = x9;
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x10) != E_HFmode
              || !register_operand (operands[1], E_V8HFmode)
              || !(
#line 296 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4868 "../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3677; /* avx512fp16_comi_round */

        case E_SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x10) != E_SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 296 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4868 "../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode)))
            return -1;
          return 3681; /* sse_comi_round */

        case E_DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x10) != E_DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !(
#line 296 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4868 "../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode)))
            return -1;
          return 3685; /* sse2_comi_round */

        default:
          return -1;
        }

    case FMA:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != NEG)
        return -1;
      x14 = XEXP (x3, 2);
      if (GET_CODE (x14) != NEG)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x13 = XEXP (x4, 0);
      operands[1] = x13;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      x15 = XEXP (x14, 0);
      operands[3] = x15;
      x9 = XVECEXP (x2, 0, 1);
      operands[4] = x9;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern1349 (x2, 
E_SFmode) != 0
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6226 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
            return -1;
          return 4002; /* *fma_fnmsub_sf */

        case E_DFmode:
          if (pattern1349 (x2, 
E_DFmode) != 0
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6226 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
            return -1;
          return 4004; /* *fma_fnmsub_df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  res = recog_20 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 8L
      || XWINT (x3, 0) != 8L
      || pattern418 (x5) != 0)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x2;
      switch (GET_MODE (x5))
        {
        case E_HImode:
          if (!extract_operator (operands[2], E_HImode))
            return -1;
          return 134; /* *insvqi_2 */

        case E_SImode:
          if (!extract_operator (operands[2], E_SImode))
            return -1;
          return 135; /* *insvqi_2 */

        case E_DImode:
          if (!extract_operator (operands[2], E_DImode)
              || !
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 136; /* *insvqi_2 */

        default:
          return -1;
        }

    case AND:
      switch (pattern1197 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 800; /* *andqi_exthi_3 */

        case 1:
          if (!
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 803; /* *andqi_extsi_3 */

        case 2:
          if (!(
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 806; /* *andqi_extdi_3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern1197 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 801; /* *iorqi_exthi_3 */

        case 1:
          if (!
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 804; /* *iorqi_extsi_3 */

        case 2:
          if (!(
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 807; /* *iorqi_extdi_3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern1197 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 802; /* *xorqi_exthi_3 */

        case 1:
          if (!
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 805; /* *xorqi_extsi_3 */

        case 2:
          if (!(
#line 13228 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 808; /* *xorqi_extdi_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (pattern1081 (x3))
            {
            case 0:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3325; /* *avx512f_cmpv16si3_zero_extendhi */

            case 1:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 310 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3346; /* *avx512vl_cmpv16hf3_zero_extendhi */

            case 2:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3352; /* *avx512f_cmpv16sf3_zero_extendhi */

            case 3:
              if (!(
#line 4501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V16QImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3445; /* *avx512vl_cmpv16qi3_zero_extendhi */

            case 4:
              if (!(
#line 4501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V16HImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3454; /* *avx512vl_cmpv16hi3_zero_extendhi */

            case 5:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3328; /* *avx512vl_cmpv8si3_zero_extendhi */

            case 6:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3331; /* *avx512vl_cmpv4si3_zero_extendhi */

            case 7:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3334; /* *avx512f_cmpv8di3_zero_extendhi */

            case 8:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3337; /* *avx512vl_cmpv4di3_zero_extendhi */

            case 9:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3340; /* *avx512vl_cmpv2di3_zero_extendhi */

            case 10:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 311 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3349; /* *avx512fp16_cmpv8hf3_zero_extendhi */

            case 11:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3355; /* *avx512vl_cmpv8sf3_zero_extendhi */

            case 12:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3358; /* *avx512vl_cmpv4sf3_zero_extendhi */

            case 13:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3361; /* *avx512f_cmpv8df3_zero_extendhi */

            case 14:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3364; /* *avx512vl_cmpv4df3_zero_extendhi */

            case 15:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3367; /* *avx512vl_cmpv2df3_zero_extendhi */

            case 16:
              if (!(
#line 4501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V8HImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3457; /* *avx512vl_cmpv8hi3_zero_extendhi */

            case 17:
              if (!(
#line 4411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 309 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3343; /* *avx512bw_cmpv32hf3_zero_extendhi */

            case 18:
              if (!(
#line 4501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V32QImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3448; /* *avx512vl_cmpv32qi3_zero_extendhi */

            case 19:
              if (!(
#line 4501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V32HImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3451; /* *avx512bw_cmpv32hi3_zero_extendhi */

            case 20:
              if (!(
#line 4501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V64QImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3442; /* *avx512bw_cmpv64qi3_zero_extendhi */

            default:
              return -1;
            }

        case 157:
          switch (pattern1083 (x3))
            {
            case 0:
              if (!(
#line 4611 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3526; /* *avx512bw_ucmpv64qi3_zero_extendhi */

            case 1:
              if (!(
#line 4611 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3529; /* *avx512vl_ucmpv16qi3_zero_extendhi */

            case 2:
              if (!(
#line 4611 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3538; /* *avx512vl_ucmpv16hi3_zero_extendhi */

            case 3:
              if (!(
#line 4700 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3598; /* *avx512f_ucmpv16si3_zero_extendhi */

            case 4:
              if (!(
#line 4611 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3532; /* *avx512vl_ucmpv32qi3_zero_extendhi */

            case 5:
              if (!(
#line 4611 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3535; /* *avx512bw_ucmpv32hi3_zero_extendhi */

            case 6:
              if (!(
#line 4611 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3541; /* *avx512vl_ucmpv8hi3_zero_extendhi */

            case 7:
              if (!(
#line 4700 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3599; /* *avx512vl_ucmpv8si3_zero_extendhi */

            case 8:
              if (!(
#line 4700 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3600; /* *avx512vl_ucmpv4si3_zero_extendhi */

            case 9:
              if (!(
#line 4700 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3601; /* *avx512f_ucmpv8di3_zero_extendhi */

            case 10:
              if (!(
#line 4700 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3602; /* *avx512vl_ucmpv4di3_zero_extendhi */

            case 11:
              if (!(
#line 4700 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3603; /* *avx512vl_ucmpv2di3_zero_extendhi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 158:
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !nonimmediate_operand (operands[2], E_V64QImode)
                  || !(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 504 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 8157; /* *avx512bw_testmv64qi3_zext */

            case E_SImode:
              switch (pattern867 ())
                {
                case 0:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 505 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8160; /* *avx512vl_testmv32qi3_zext */

                case 1:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8166; /* *avx512bw_testmv32hi3_zext */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern738 ())
                {
                case 0:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 506 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8163; /* *avx512vl_testmv16qi3_zext */

                case 1:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 508 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8169; /* *avx512vl_testmv16hi3_zext */

                case 2:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8175; /* *avx512f_testmv16si3_zext */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern739 ())
                {
                case 0:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 509 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8172; /* *avx512vl_testmv8hi3_zext */

                case 1:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8178; /* *avx512vl_testmv8si3_zext */

                case 2:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8181; /* *avx512vl_testmv4si3_zext */

                case 3:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8184; /* *avx512f_testmv8di3_zext */

                case 4:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8187; /* *avx512vl_testmv4di3_zext */

                case 5:
                  if (!(
#line 19088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8190; /* *avx512vl_testmv2di3_zext */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 159:
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !nonimmediate_operand (operands[2], E_V64QImode)
                  || !(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 504 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 8229; /* *avx512bw_testnmv64qi3_zext */

            case E_SImode:
              switch (pattern867 ())
                {
                case 0:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 505 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8232; /* *avx512vl_testnmv32qi3_zext */

                case 1:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8238; /* *avx512bw_testnmv32hi3_zext */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern738 ())
                {
                case 0:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 506 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8235; /* *avx512vl_testnmv16qi3_zext */

                case 1:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 508 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8241; /* *avx512vl_testnmv16hi3_zext */

                case 2:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8247; /* *avx512f_testnmv16si3_zext */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern739 ())
                {
                case 0:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 509 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8244; /* *avx512vl_testnmv8hi3_zext */

                case 1:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8250; /* *avx512vl_testnmv8si3_zext */

                case 2:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8253; /* *avx512vl_testnmv4si3_zext */

                case 3:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8256; /* *avx512f_testnmv8di3_zext */

                case 4:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8259; /* *avx512vl_testnmv4di3_zext */

                case 5:
                  if (!(
#line 19118 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8262; /* *avx512vl_testnmv2di3_zext */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      switch (pattern233 (x2))
        {
        case 0:
          if (
#line 3873 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
            return 2194; /* *mmx_ashrv4hi3_1 */
          break;

        case 1:
          if (
#line 3873 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
            return 2195; /* *mmx_ashrv2si3_1 */
          break;

        case 2:
          if (
#line 3962 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return 2207; /* *mmx_ashrv2hi3_1 */
          break;

        default:
          break;
        }
      break;

    case GT:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern847 (x2, 
E_V8QImode) == 0
              && 
#line 4170 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 2217; /* mmx_gtv8qi3 */
          break;

        case E_V4HImode:
          if (pattern847 (x2, 
E_V4HImode) == 0
              && 
#line 4170 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 2218; /* mmx_gtv4hi3 */
          break;

        case E_V2SImode:
          if (pattern847 (x2, 
E_V2SImode) == 0
              && 
#line 4170 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 2219; /* mmx_gtv2si3 */
          break;

        case E_V4QImode:
          if (pattern7 (x2, 
E_V4QImode) == 0
              && 
#line 4185 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2220; /* *gtv4qi3 */
          break;

        case E_V2QImode:
          if (pattern7 (x2, 
E_V2QImode) == 0
              && 
#line 4185 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2221; /* *gtv2qi3 */
          break;

        case E_V2HImode:
          if (pattern7 (x2, 
E_V2HImode) == 0
              && 
#line 4185 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2222; /* *gtv2hi3 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern848 (
E_V8QImode) != 0
          || !
#line 4198 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 2223; /* *xop_maskcmpv8qi3 */

    case E_V4HImode:
      if (pattern848 (
E_V4HImode) != 0
          || !
#line 4198 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 2224; /* *xop_maskcmpv4hi3 */

    case E_V2SImode:
      if (pattern848 (
E_V2SImode) != 0
          || !
#line 4198 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 2225; /* *xop_maskcmpv2si3 */

    case E_V4QImode:
      if (pattern848 (
E_V4QImode) != 0
          || !
#line 4208 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 2226; /* *xop_maskcmpv4qi3 */

    case E_V2QImode:
      if (pattern848 (
E_V2QImode) != 0
          || !
#line 4208 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 2227; /* *xop_maskcmpv2qi3 */

    case E_V2HImode:
      if (pattern848 (
E_V2HImode) != 0
          || !
#line 4208 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 2228; /* *xop_maskcmpv2hi3 */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_55 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x2, 1);
          if (pattern599 (x7) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (pattern1264 (x1))
            {
            case 0:
              if (!
#line 8248 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8248 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8248 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x11 = XEXP (x1, 0);
      operands[0] = x11;
      switch (pattern288 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1355 (x2, 
E_QImode) != 0
                  || !
#line 9277 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1355 (x2, 
E_HImode) != 0
                  || !
#line 9277 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 488; /* subhi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1269 (x2, 
E_QImode) != 0
                  || !
#line 10230 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1269 (x2, 
E_HImode) != 0
                  || !
#line 10230 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *subhi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern91 (x1))
        {
        case 0:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (pattern972 (x2) != 0)
            return -1;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1507 (x2, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 1058 "../../gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()))
                return -1;
              return 2061; /* *mmx_hsubv2sf3_low */

            case E_DFmode:
              if (pattern1507 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3768 "../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_V2DF_REDUCTION_PREFER_HADDPD))
                return -1;
              return 3184; /* *sse3_hsubv2df3_low */

            default:
              return -1;
            }

        case 1:
          switch (pattern852 (x2))
            {
            case 0:
              if (!
#line 22628 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8595; /* ssse3_phsubwv4hi3 */

            case 1:
              if (!
#line 22715 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8602; /* ssse3_phsubdv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1722 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2083; /* *vec_dupv2sf */

        case E_V4HFmode:
          if (!register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 5674 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2338; /* *vec_dupv4hf */

        case E_V4BFmode:
          if (!register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 5674 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2339; /* *vec_dupv4bf */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 5674 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2340; /* *vec_dupv4hi */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 5685 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2341; /* *vec_dupv2si */

        case E_V2HFmode:
          if (!register_operand (operands[0], E_V2HFmode)
              || GET_MODE (x3) != E_V2HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 6266 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2369; /* *vec_dupv2hf */

        case E_V2BFmode:
          if (!register_operand (operands[0], E_V2BFmode)
              || GET_MODE (x3) != E_V2BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 6266 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2370; /* *vec_dupv2bf */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 6266 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2371; /* *vec_dupv2hi */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !
#line 5659 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 2337; /* *vec_dupv4hi */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !
#line 6256 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2368; /* *vec_dupv2hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern433 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 266; /* *adddi3_doubleword */
            }
          if (x86_64_general_operand (operands[2], E_DImode))
            {
              if ((
#line 6615 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 284; /* *adddi_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 6615 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 285; /* *adddi_1 */
                }
            }
          break;

        case 1:
          if (
#line 6615 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 282; /* *addsi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 6615 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            {
              *pnum_clobbers = 1;
              return 283; /* *addsi_1 */
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_SImode)
          || pattern434 (x3, 
22) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!tls_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 23124 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
        return -1;
      return 1658; /* *tls_dynamic_gnu2_lea_32 */

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      switch (pattern276 (x3, pnum_clobbers, 
E_DImode, 
E_SImode))
        {
        case 0:
          if (!(
#line 6511 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* *adddi3_doubleword_zext */

        case 1:
          if (!(
#line 14077 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 898; /* *concatsidi3_2 */

        case 2:
          if (!(
#line 14121 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 916; /* *concatsidi3_4 */

        case 3:
          if (!(
#line 14121 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 919; /* *concatsidi3_4 */

        case 4:
          if (!(
#line 14198 "../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 946; /* *concatsidi3_7 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ZERO_EXTEND
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          switch (pattern84 (x3, 
E_DImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 270; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 276; /* *adddi3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x8;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1270 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 455; /* addsi3_carry */

            case E_DImode:
              if (pattern1270 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 456; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1200 (x3, 
E_SImode) != 0
                  || !
#line 10136 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 556; /* *addsi3_eq */

            case E_DImode:
              if (pattern1200 (x3, 
E_DImode) != 0
                  || !(
#line 10136 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 557; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1201 (x3, 
E_SImode) != 0
                  || !
#line 10157 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 560; /* *addsi3_ne */

            case E_DImode:
              if (pattern1201 (x3, 
E_DImode) != 0
                  || !(
#line 10157 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 561; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 271; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 277; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 272; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 278; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1075 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 459; /* *addsi3_carry_0 */

        case 1:
          if (pattern1075 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 460; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1076 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 463; /* *addsi3_carry_0r */

        case 1:
          if (pattern1076 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 464; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern105 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10183 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 564; /* *addsi3_eq_0 */

        case 1:
          if (!(
#line 10183 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 565; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern105 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10204 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 568; /* *addsi3_ne_0 */

        case 1:
          if (!(
#line 10204 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 569; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case NE:
          switch (pattern748 (x3))
            {
            case 0:
              if (!
#line 10252 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 576; /* *subsi3_ne */

            case 1:
              if (!(
#line 10252 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 577; /* *subdi3_ne */

            default:
              return -1;
            }

        case EQ:
          switch (pattern748 (x3))
            {
            case 0:
              if (!
#line 10281 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 580; /* *subsi3_eq_1 */

            case 1:
              if (!(
#line 10281 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 581; /* *subdi3_eq_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (pattern256 (x5, 
E_SImode, 
E_DImode))
            {
            case 0:
              if (!(
#line 14060 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 892; /* *concatsidi3_1 */

            case 1:
              if (!(
#line 14137 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 928; /* *concatsidi3_5 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern978 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 904; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 934; /* *concatsidi3_6 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern978 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 907; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 937; /* *concatsidi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern414 (x5, 
E_CCCmode, 
ASHIFT) != 0)
        return -1;
      x12 = XEXP (x5, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      switch (XWINT (x12, 0))
        {
        case 31L:
          if (pattern1450 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1385; /* rcrsi2 */

        case 63L:
          if (pattern1450 (x3, 
E_DImode) != 0
              || !
#line 18754 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1386; /* rcrdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x13 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 7)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 6)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (!tls_symbolic_operand (x7, E_VOIDmode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 21:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x14 = XVECEXP (x4, 0, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x15 = XVECEXP (x4, 0, 1);
              operands[2] = x15;
              if (!constant_call_address_operand (operands[2], E_VOIDmode)
                  || GET_MODE (x13) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || GET_MODE (x6) != E_SImode)
                return -1;
              operands[3] = x7;
              *pnum_clobbers = 3;
              return 1651; /* *tls_local_dynamic_32_once */

            case 22:
              x14 = XVECEXP (x4, 0, 0);
              operands[2] = x14;
              if (!tls_modbase_operand (operands[2], E_VOIDmode))
                return -1;
              x15 = XVECEXP (x4, 0, 1);
              operands[3] = x15;
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern1628 (x3, 
E_SImode) != 0
                      || !(
#line 23217 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1665; /* *tls_dynamic_gnu2_combine_64_si */

                case E_DImode:
                  if (pattern1628 (x3, 
E_DImode) != 0
                      || !(
#line 23217 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1666; /* *tls_dynamic_gnu2_combine_64_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 19)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern750 (x3))
            {
            case 0:
              if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1655; /* *add_tp_si */

            case 1:
              if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1656; /* *add_tp_di */

            default:
              return -1;
            }

        case 4:
          if (XINT (x4, 1) != 22
              || GET_MODE (x4) != E_SImode)
            return -1;
          x16 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 7
              || GET_MODE (x16) != E_SImode
              || pattern434 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[3] = x14;
          if (!tls_modbase_operand (operands[3], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[4] = x15;
          x13 = XVECEXP (x4, 0, 2);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[1] = x7;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 23158 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          *pnum_clobbers = 1;
          return 1660; /* *tls_dynamic_gnu2_combine_32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern617 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 10604 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF))
            return 592; /* *mulsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 10604 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 593; /* *mulsi3_1 */

        case E_DImode:
          if (pattern617 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 10604 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 594; /* *muldi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 10604 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 595; /* *muldi3_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
ZERO_EXTEND) != 0
          || !(
#line 10994 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 617; /* *umulsidi3_1 */

    case SIGN_EXTEND:
      if (pattern114 (x3, 
SIGN_EXTEND) != 0)
        return -1;
      if ((
#line 11040 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 619; /* *mulsidi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 11040 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 620; /* *mulsidi3_1 */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern760 (x3, 
E_SImode) != 0
              || !
#line 13607 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 836; /* *notxorsi_1 */

        case E_DImode:
          if (pattern760 (x3, 
E_DImode) != 0
              || !(
#line 13607 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 837; /* *notxordi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern115 (x3))
        {
        case 0:
          if ((
#line 14976 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 1030; /* *one_cmpldi2_doubleword */
          if (!(
#line 14989 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1034; /* *one_cmpldi2_1 */

        case 1:
          if (!
#line 14989 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 1033; /* *one_cmplsi2_1 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      switch (XINT (x4, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern986 (x3))
                {
                case 0:
                  if (!(
#line 4468 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 309 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return -1;
                  return 3421; /* *avx512bw_cmpv32hf3 */

                case 1:
                  if (!(
#line 4563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3482; /* *avx512vl_cmpv32qi3 */

                case 2:
                  if (!(
#line 4563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3484; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            case E_DImode:
              if (pattern987 (x3) != 0
                  || !(
#line 4563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3478; /* *avx512bw_cmpv64qi3 */

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1087 (x3, 
E_V64QImode, 
E_DImode) != 0
                  || !(
#line 4563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3479; /* *avx512bw_cmpv64qi3 */

            case E_SImode:
              switch (pattern1088 (x3))
                {
                case 0:
                  if (!(
#line 4563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3483; /* *avx512vl_cmpv32qi3 */

                case 1:
                  if (!(
#line 4563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3485; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (pnum_clobbers != NULL
          && GET_CODE (x4) == SUBREG
          && pattern420 (x1, 
E_DImode) == 0
          && (
#line 16582 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1122; /* *lshrdi3_doubleword_mask */
        }
      operands[2] = x4;
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers != NULL)
        {
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              if (XWINT (x4, 0) == 32L)
                {
                  x5 = XEXP (x1, 0);
                  if (GET_CODE (x5) == SUBREG
                      && known_eq (SUBREG_BYTE (x5), 0)
                      && GET_MODE (x5) == E_DImode)
                    {
                      x6 = XEXP (x5, 0);
                      operands[0] = x6;
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x2) == E_DImode
                          && nonimmediate_operand (operands[1], E_DImode)
                          && 
#line 17361 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                        {
                          *pnum_clobbers = 1;
                          return 1179; /* *highpartdisi2 */
                        }
                    }
                }
              break;

            case SUBREG:
              switch (pattern444 (x1, 
E_SImode))
                {
                case 0:
                  if (
#line 17840 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1245; /* *lshrsi3_mask */
                    }
                  break;

                case 1:
                  if (
#line 17888 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1257; /* *lshrsi3_add */
                    }
                  break;

                case 2:
                  if (
#line 17934 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1269; /* *lshrsi3_sub */
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x4;
      if (nonmemory_operand (operands[2], E_QImode))
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && nonimmediate_operand (operands[1], E_DImode))
            {
              if ((
#line 17385 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1182; /* *lshrdi3_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 17385 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1183; /* *lshrdi3_1 */
                }
            }
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x4) != SUBREG)
        return -1;
      switch (pattern444 (x1, 
E_DImode))
        {
        case 0:
          if (!(
#line 17840 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1248; /* *lshrdi3_mask */

        case 1:
          if (!(
#line 17888 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1260; /* *lshrdi3_add */

        case 2:
          if (!(
#line 17934 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1272; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern116 (x2))
        {
        case 0:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 16643 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1126; /* *lshrdi3_doubleword_mask_1 */
            }
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17865 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1254; /* *lshrdi3_mask_1 */

        case 1:
          if (!
#line 17865 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1251; /* *lshrsi3_mask_1 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern18 (x2))
        {
        case 0:
          if (!
#line 17912 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1263; /* *lshrsi3_add_1 */

        case 1:
          if (!(
#line 17912 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1266; /* *lshrdi3_add_1 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern117 (x2))
        {
        case 0:
          if (!
#line 17964 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1275; /* *lshrsi3_sub_1 */

        case 1:
          if (!(
#line 17964 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1278; /* *lshrdi3_sub_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (call_insn_operand (operands[1], E_SImode)
      && (
#line 20326 "../../gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1475; /* *call_value */
  if (call_insn_operand (operands[1], E_DImode)
      && (
#line 20326 "../../gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
    return 1476; /* *call_value */
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) == E_DImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (GOT_memory_operand (operands[1], E_SImode))
            {
              operands[2] = x6;
              if (
#line 20337 "../../gcc/config/i386/i386.md"
(TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER))
                return 1477; /* *call_value_got_x32 */
            }
        }
      break;

    case MEM:
      if (GET_MODE (x5) == E_SImode)
        {
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) == PLUS
              && GET_MODE (x7) == E_SImode)
            {
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (register_no_elim_operand (operands[1], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  if (GOT32_symbol_operand (operands[2], E_SImode))
                    {
                      operands[3] = x6;
                      if (
#line 20353 "../../gcc/config/i386/i386.md"
(!TARGET_MACHO
   && !TARGET_64BIT && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (insn)))
                        return 1478; /* *sibcall_value_GOT_32 */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x5;
  operands[2] = x6;
  if (sibcall_insn_operand (operands[1], E_SImode)
      && (
#line 20367 "../../gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1479; /* *sibcall_value */
  if (!sibcall_insn_operand (operands[1], E_DImode)
      || !(
#line 20367 "../../gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
    return -1;
  return 1480; /* *sibcall_value */
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern301 (x3))
            {
            case 0:
              if (!(
#line 27048 "../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 1853; /* allocate_stack_worker_probe_si */

            case 1:
              if (!(
#line 27048 "../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              *pnum_clobbers = 1;
              return 1854; /* allocate_stack_worker_probe_di */

            default:
              return -1;
            }

        case 11:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 28921 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1889; /* rdpmc */

        case 9:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || !
#line 28940 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1891; /* rdtsc */

        case 36:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 29164 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_XSAVE))
            return -1;
          return 1919; /* xgetbv */

        case 13:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!(
#line 29258 "../../gcc/config/i386/i386.md"
(TARGET_LWP) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1927; /* lwp_slwpcbsi */

            case 1:
              if (!(
#line 29258 "../../gcc/config/i386/i386.md"
(TARGET_LWP) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1928; /* lwp_slwpcbdi */

            default:
              return -1;
            }

        case 16:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!
#line 29306 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE))
                return -1;
              return 1933; /* rdfsbasesi */

            case 1:
              if (!(
#line 29306 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1935; /* rdfsbasedi */

            default:
              return -1;
            }

        case 17:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!
#line 29306 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE))
                return -1;
              return 1934; /* rdgsbasesi */

            case 1:
              if (!(
#line 29306 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1936; /* rdgsbasedi */

            default:
              return -1;
            }

        case 59:
          switch (pattern301 (x3))
            {
            case 0:
              if (!
#line 29374 "../../gcc/config/i386/i386.md"
(TARGET_SHSTK || (flag_cf_protection & CF_RETURN)))
                return -1;
              return 1950; /* rdsspsi */

            case 1:
              if (!(
#line 29374 "../../gcc/config/i386/i386.md"
(TARGET_SHSTK || (flag_cf_protection & CF_RETURN)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1951; /* rdsspdi */

            default:
              return -1;
            }

        case 57:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!
#line 29614 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_RDPID))
                return -1;
              return 1976; /* rdpid */

            case 1:
              if (!
#line 29621 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_RDPID))
                return -1;
              return 1977; /* rdpid_rex64 */

            default:
              return -1;
            }

        case 85:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!x86_64_szext_nonmemory_operand (operands[1], E_DImode)
              || !
#line 29897 "../../gcc/config/i386/i386.md"
(TARGET_USER_MSR && TARGET_64BIT))
            return -1;
          return 2005; /* urdmsr */

        case 89:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !memory_operand (operands[1], E_SImode)
                  || !
#line 29935 "../../gcc/config/i386/i386.md"
(TARGET_MOVRS && TARGET_64BIT))
                return -1;
              return 2011; /* movrssi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 29935 "../../gcc/config/i386/i386.md"
(TARGET_MOVRS && TARGET_64BIT))
                return -1;
              return 2012; /* movrsdi */

            default:
              return -1;
            }

        case 93:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !memory_operand (operands[0], E_SImode)
              || !
#line 22508 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8580; /* sse_stmxcsr */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x3, 1))
        {
        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern878 (x3, 
E_SImode) != 0
                  || !
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1859; /* probe_stack_range_si */

            case E_DImode:
              if (pattern878 (x3, 
E_DImode) != 0
                  || !
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1860; /* probe_stack_range_di */

            default:
              return -1;
            }

        case 113:
          x5 = XVECEXP (x3, 0, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11039; /* rao_aandsi */

                case 1:
                  if (!(
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11043; /* rao_aanddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11040; /* rao_aorsi */

                case 1:
                  if (!(
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11044; /* rao_aordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11041; /* rao_axorsi */

                case 1:
                  if (!(
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11045; /* rao_axordi */

                default:
                  return -1;
                }

            case PLUS:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11042; /* rao_aaddsi */

                case 1:
                  if (!(
#line 821 "../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11046; /* rao_aadddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 111:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11049; /* atomic_addsi */

                case 1:
                  if (!
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11050; /* atomic_adddi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11053; /* atomic_subsi */

                case 1:
                  if (!
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11054; /* atomic_subdi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11061; /* atomic_andsi */

                case 1:
                  if (!
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11064; /* atomic_anddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11062; /* atomic_orsi */

                case 1:
                  if (!
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11065; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11063; /* atomic_xorsi */

                case 1:
                  if (!
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11066; /* atomic_xordi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1363 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4089; /* fma_fmaddsub_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1363 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4093; /* fma_fmaddsub_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1363 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4097; /* fma_fmaddsub_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1363 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4099; /* fma_fmaddsub_v16sf_maskz_1 */

            case E_V8SFmode:
              if (pattern1363 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4103; /* fma_fmaddsub_v8sf_maskz_1 */

            case E_V4SFmode:
              if (pattern1363 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4107; /* fma_fmaddsub_v4sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1363 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4109; /* fma_fmaddsub_v8df_maskz_1 */

            case E_V4DFmode:
              if (pattern1363 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4113; /* fma_fmaddsub_v4df_maskz_1 */

            case E_V2DFmode:
              if (pattern1363 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4117; /* fma_fmaddsub_v2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1273 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V32HFmode)
                  && vector_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 4118; /* avx512bw_fmaddsub_v32hf_mask */
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4133; /* avx512bw_fmaddsub_v32hf_mask3 */

            case E_V16HFmode:
              if (pattern1273 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16HFmode)
                  && vector_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4120; /* avx512vl_fmaddsub_v16hf_mask */
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4135; /* avx512vl_fmaddsub_v16hf_mask3 */

            case E_V8HFmode:
              if (pattern1273 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8HFmode)
                  && vector_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4122; /* avx512fp16_fmaddsub_v8hf_mask */
              if (!nonimmediate_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4137; /* avx512fp16_fmaddsub_v8hf_mask3 */

            case E_V16SFmode:
              if (pattern1273 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16SFmode)
                  && vector_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4123; /* avx512f_fmaddsub_v16sf_mask */
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4138; /* avx512f_fmaddsub_v16sf_mask3 */

            case E_V8SFmode:
              if (pattern1273 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8SFmode)
                  && vector_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4125; /* avx512vl_fmaddsub_v8sf_mask */
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4140; /* avx512vl_fmaddsub_v8sf_mask3 */

            case E_V4SFmode:
              if (pattern1273 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4SFmode)
                  && vector_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4127; /* avx512vl_fmaddsub_v4sf_mask */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4142; /* avx512vl_fmaddsub_v4sf_mask3 */

            case E_V8DFmode:
              if (pattern1273 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8DFmode)
                  && vector_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4128; /* avx512f_fmaddsub_v8df_mask */
              if (!nonimmediate_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4143; /* avx512f_fmaddsub_v8df_mask3 */

            case E_V4DFmode:
              if (pattern1273 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4DFmode)
                  && vector_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4130; /* avx512vl_fmaddsub_v4df_mask */
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4145; /* avx512vl_fmaddsub_v4df_mask3 */

            case E_V2DFmode:
              if (pattern1273 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V2DFmode)
                  && vector_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4132; /* avx512vl_fmaddsub_v2df_mask */
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4147; /* avx512vl_fmaddsub_v2df_mask3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1364 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4153; /* fma_fmsubadd_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1364 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4157; /* fma_fmsubadd_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1364 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4161; /* fma_fmsubadd_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1364 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4163; /* fma_fmsubadd_v16sf_maskz_1 */

            case E_V8SFmode:
              if (pattern1364 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4167; /* fma_fmsubadd_v8sf_maskz_1 */

            case E_V4SFmode:
              if (pattern1364 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4171; /* fma_fmsubadd_v4sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1364 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4173; /* fma_fmsubadd_v8df_maskz_1 */

            case E_V4DFmode:
              if (pattern1364 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4177; /* fma_fmsubadd_v4df_maskz_1 */

            case E_V2DFmode:
              if (pattern1364 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4181; /* fma_fmsubadd_v2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1274 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 4182; /* avx512bw_fmsubadd_v32hf_mask */
              if (!nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4200; /* avx512bw_fmsubadd_v32hf_mask3 */

            case E_V16HFmode:
              if (pattern1274 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4184; /* avx512vl_fmsubadd_v16hf_mask */
              if (!nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4202; /* avx512vl_fmsubadd_v16hf_mask3 */

            case E_V8HFmode:
              if (pattern1274 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4186; /* avx512fp16_fmsubadd_v8hf_mask */
              if (!nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4204; /* avx512fp16_fmsubadd_v8hf_mask3 */

            case E_V16SFmode:
              if (pattern1274 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4188; /* avx512f_fmsubadd_v16sf_mask */
              if (!nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4206; /* avx512f_fmsubadd_v16sf_mask3 */

            case E_V8SFmode:
              if (pattern1274 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4190; /* avx512vl_fmsubadd_v8sf_mask */
              if (!nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4208; /* avx512vl_fmsubadd_v8sf_mask3 */

            case E_V4SFmode:
              if (pattern1274 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4192; /* avx512vl_fmsubadd_v4sf_mask */
              if (!nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4210; /* avx512vl_fmsubadd_v4sf_mask3 */

            case E_V8DFmode:
              if (pattern1274 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4194; /* avx512f_fmsubadd_v8df_mask */
              if (!nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4212; /* avx512f_fmsubadd_v8df_mask3 */

            case E_V4DFmode:
              if (pattern1274 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4196; /* avx512vl_fmsubadd_v4df_mask */
              if (!nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4214; /* avx512vl_fmsubadd_v4df_mask3 */

            case E_V2DFmode:
              if (pattern1274 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4198; /* avx512vl_fmsubadd_v2df_mask */
              if (!nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4216; /* avx512vl_fmsubadd_v2df_mask3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_155 (x1, insn, pnum_clobbers);

        case CONST_INT:
          if (XWINT (x4, 0) == 1L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (GET_MODE (x2) == E_V2DImode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DImode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DImode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DImode)
                                  && 
#line 1857 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2550; /* *sse2_movq128_v2di_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DImode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DImode)
                                  && 
#line 14859 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7214; /* sse2_movsd_v2di */
                            }
                        }
                    }
                  break;

                case E_V2DFmode:
                  if (GET_MODE (x2) == E_V2DFmode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DFmode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DFmode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DFmode)
                                  && 
#line 1857 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2551; /* *sse2_movq128_v2df_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DFmode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DFmode)
                                  && 
#line 14859 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7215; /* sse2_movsd_v2df */
                            }
                        }
                    }
                  break;

                case E_V4SImode:
                  if (pattern888 (x2, 
E_V4SImode) == 0
                      && 
#line 11710 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5278; /* sse_movss_v4si */
                  break;

                case E_V4SFmode:
                  if (pattern888 (x2, 
E_V4SFmode) == 0
                      && 
#line 11710 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5279; /* sse_movss_v4sf */
                  break;

                case E_V8HImode:
                  if (pattern888 (x2, 
E_V8HImode) == 0
                      && 
#line 12128 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2_256 && const0_operand (operands[1], V8HImode))))
                    return 5317; /* avx512fp16_movv8hi */
                  break;

                case E_V8HFmode:
                  if (pattern888 (x2, 
E_V8HFmode) == 0
                      && 
#line 12128 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2_256 && const0_operand (operands[1], V8HFmode))))
                    return 5318; /* avx512fp16_movv8hf */
                  break;

                case E_V8BFmode:
                  if (pattern888 (x2, 
E_V8BFmode) == 0
                      && 
#line 12128 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2_256 && const0_operand (operands[1], V8BFmode))))
                    return 5319; /* avx512fp16_movv8bf */
                  break;

                default:
                  break;
                }
            }
          operands[3] = x4;
          x5 = XEXP (x2, 0);
          operands[2] = x5;
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SFmode:
              if (pattern1110 (x2, 
E_V8SFmode) != 0
                  || !(
#line 23509 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8677; /* avx_blendps256 */

            case E_V4SFmode:
              if (pattern1111 (x2, 
E_V4SFmode) != 0
                  || !
#line 23509 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8678; /* sse4_1_blendps */

            case E_V4DFmode:
              if (pattern1111 (x2, 
E_V4DFmode) != 0
                  || !(
#line 23509 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8679; /* avx_blendpd256 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !vector_operand (operands[2], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !const_0_to_3_operand (operands[3], E_SImode)
                  || !(
#line 23509 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8680; /* sse4_1_blendpd */

            case E_V8HImode:
              if (pattern1110 (x2, 
E_V8HImode) != 0
                  || !
#line 24014 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8742; /* sse4_1_pblendw */

            case E_V8HFmode:
              if (pattern1110 (x2, 
E_V8HFmode) != 0
                  || !
#line 24014 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8743; /* sse4_1_pblendph */

            case E_V8BFmode:
              if (pattern1110 (x2, 
E_V8BFmode) != 0
                  || !
#line 24014 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8744; /* sse4_1_pblendbf */

            case E_V16HImode:
              if (pattern1112 (x2, 
E_V16HImode) != 0
                  || !
#line 24087 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8745; /* *avx2_pblendw */

            case E_V16HFmode:
              if (pattern1112 (x2, 
E_V16HFmode) != 0
                  || !
#line 24087 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8746; /* *avx2_pblendph */

            case E_V16BFmode:
              if (pattern1112 (x2, 
E_V16BFmode) != 0
                  || !
#line 24087 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8747; /* *avx2_pblendbf */

            case E_V8SImode:
              if (pattern1113 (x2, 
E_V8SImode) != 0
                  || !
#line 24105 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8748; /* avx2_pblenddv8si */

            case E_V4SImode:
              if (pattern1113 (x2, 
E_V4SImode) != 0
                  || !
#line 24105 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8749; /* avx2_pblenddv4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 3
              || XINT (x4, 1) != 59)
            return -1;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (pattern1010 (x2))
            {
            case 0:
              x6 = XVECEXP (x4, 0, 0);
              operands[3] = x6;
              switch (pattern1463 (x2))
                {
                case 0:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return 3048; /* *minmaxv32hf3_1 */
                  break;

                case 1:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3049; /* *minmaxv16hf3_1 */
                  break;

                case 2:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3050; /* *minmaxv8hf3_1 */
                  break;

                case 3:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3051; /* *minmaxv16sf3_1 */
                  break;

                case 4:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3052; /* *minmaxv8sf3_1 */
                  break;

                case 5:
                  if (
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)))
                    return 3053; /* *minmaxv4sf3_1 */
                  break;

                case 6:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3054; /* *minmaxv8df3_1 */
                  break;

                case 7:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3055; /* *minmaxv4df3_1 */
                  break;

                case 8:
                  if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3056; /* *minmaxv2df3_1 */
                  break;

                case 9:
                  if ((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3251; /* *avx_cmpv8sf3_lt */
                  break;

                case 10:
                  if (
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3252; /* *avx_cmpv4sf3_lt */
                  break;

                case 11:
                  if ((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3253; /* *avx_cmpv4df3_lt */
                  break;

                case 12:
                  if ((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3254; /* *avx_cmpv2df3_lt */
                  break;

                case 13:
                  if (
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3255; /* *avx_cmpv4si3_ltint */
                  break;

                case 14:
                  if (
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3256; /* *avx_cmpv2di3_ltint */
                  break;

                case 15:
                  if ((
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3257; /* *avx_cmpv8si3_ltint */
                  break;

                case 16:
                  if ((
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3258; /* *avx_cmpv4di3_ltint */
                  break;

                case 17:
                  if ((
#line 18040 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return 7904; /* *avx2_pcmpv32qi3_3 */
                  break;

                case 18:
                  if (
#line 18040 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))))
                    return 7905; /* *avx2_pcmpv16qi3_3 */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x6) != SUBREG)
                return -1;
              switch (pattern1466 (x2))
                {
                case 0:
                  if (!
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3259; /* *avx_cmpv4si3_ltint_not */

                case 1:
                  if (!
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3260; /* *avx_cmpv2di3_ltint_not */

                case 2:
                  if (!(
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3261; /* *avx_cmpv8si3_ltint_not */

                case 3:
                  if (!(
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3262; /* *avx_cmpv4di3_ltint_not */

                case 4:
                  if (!(
#line 18069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7906; /* *avx2_pcmpv32qi3_4 */

                case 5:
                  if (!
#line 18069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                    return -1;
                  return 7907; /* *avx2_pcmpv16qi3_4 */

                default:
                  return -1;
                }

            case 1:
              if (!(
#line 18101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7908; /* *avx2_pcmpv32qi3_5 */

            case 2:
              if (!
#line 18101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                return -1;
              return 7909; /* *avx2_pcmpv16qi3_5 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1114 (x2, 
E_V2DFmode, 
E_V8DFmode) != 0
              || !(
#line 20052 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12406 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8387; /* *avx512dq_vinsertf64x2_1 */

        case E_V8DImode:
          if (pattern1114 (x2, 
E_V2DImode, 
E_V8DImode) != 0
              || !(
#line 20052 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12407 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8389; /* *avx512dq_vinserti64x2_1 */

        case E_V16SFmode:
          if (pattern1114 (x2, 
E_V4SFmode, 
E_V16SFmode) != 0
              || !(
#line 20052 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12408 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8391; /* *avx512f_vinsertf32x4_1 */

        case E_V16SImode:
          if (pattern1114 (x2, 
E_V4SImode, 
E_V16SImode) != 0
              || !(
#line 20052 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12408 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8393; /* *avx512f_vinserti32x4_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  res = recog_168 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XEXP (x2, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 0L:
      if (XWINT (x6, 0) != 1L
          || XWINT (x7, 0) != 2L
          || XWINT (x8, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || pattern1543 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !(
#line 12635 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5343; /* vec_extract_lo_v8df_mask */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || pattern1543 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 12635 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5344; /* vec_extract_lo_v8di_mask */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || pattern1543 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 12969 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5367; /* vec_extract_lo_v8si_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || pattern1543 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 12969 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5368; /* vec_extract_lo_v8sf_mask */

        default:
          return -1;
        }

    case 4L:
      if (XWINT (x6, 0) != 5L
          || XWINT (x7, 0) != 6L
          || XWINT (x8, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || pattern1543 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !(
#line 12672 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5347; /* vec_extract_hi_v8df_mask */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || pattern1543 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 12672 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5348; /* vec_extract_hi_v8di_mask */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || pattern1543 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 13001 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5371; /* vec_extract_hi_v8si_mask */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || pattern1543 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 13001 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5372; /* vec_extract_hi_v8sf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 2683 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2749; /* *avx512fp16_vmaddv8hf3 */

        case 1:
          if (!
#line 2683 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2751; /* *sse_vmaddv4sf3 */

        case 2:
          if (!(
#line 2683 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2753; /* *sse2_vmaddv2df3 */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 2683 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2750; /* *avx512fp16_vmsubv8hf3 */

        case 1:
          if (!
#line 2683 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2752; /* *sse_vmsubv4sf3 */

        case 2:
          if (!(
#line 2683 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2754; /* *sse2_vmsubv2df3 */

        default:
          return -1;
        }

    case MULT:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 2773 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2815; /* *avx512fp16_vmmulv8hf3 */

        case 1:
          if (!
#line 2773 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2817; /* *sse_vmmulv4sf3 */

        case 2:
          if (!(
#line 2773 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2819; /* *sse2_vmmulv2df3 */

        default:
          return -1;
        }

    case DIV:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 2773 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2816; /* *avx512fp16_vmdivv8hf3 */

        case 1:
          if (!
#line 2773 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2818; /* *sse_vmdivv4sf3 */

        case 2:
          if (!(
#line 2773 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2820; /* *sse2_vmdivv2df3 */

        default:
          return -1;
        }

    case UNSPEC:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (XINT (x4, 1))
            {
            case 54:
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1109 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 2948 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 2878; /* *sse_vmrcpv4sf2 */

                case E_V8HFmode:
                  if (pattern1109 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                      || !
#line 2992 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 2887; /* *avx512fp16_vmrcpv8hf2 */

                default:
                  return -1;
                }

            case 55:
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1109 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 3219 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 2983; /* *sse_vmrsqrtv4sf2 */

                case E_V8HFmode:
                  if (pattern1109 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                      || !
#line 3250 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 2986; /* *avx512fp16_vmrsqrtv8hf2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          switch (XINT (x4, 1))
            {
            case 63:
              switch (pattern769 (x2))
                {
                case 0:
                  if (!(
#line 3419 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3121; /* *ieee_maxv8hf3 */

                case 1:
                  if (!
#line 3419 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 3123; /* *ieee_maxv4sf3 */

                case 2:
                  if (!(
#line 3419 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 3125; /* *ieee_maxv2df3 */

                default:
                  return -1;
                }

            case 62:
              switch (pattern769 (x2))
                {
                case 0:
                  if (!(
#line 3419 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3122; /* *ieee_minv8hf3 */

                case 1:
                  if (!
#line 3419 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 3124; /* *ieee_minv4sf3 */

                case 2:
                  if (!(
#line 3419 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 3126; /* *ieee_minv2df3 */

                default:
                  return -1;
                }

            case 94:
              x6 = XVECEXP (x4, 0, 0);
              operands[2] = x6;
              x8 = XVECEXP (x4, 0, 1);
              operands[3] = x8;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HFmode:
                  if (pattern1211 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
                    return -1;
                  if (vector_operand (operands[2], E_HFmode)
                      && const_0_to_255_operand (operands[3], E_SImode)
                      && (
#line 14268 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return 7181; /* *avx512f_rndscalev8hf */
                  if (!nonimmediate_operand (operands[2], E_HFmode)
                      || !const_0_to_15_operand (operands[3], E_SImode)
                      || !(
#line 25622 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 8972; /* *sse4_1_roundsh */

                case E_V4SFmode:
                  if (pattern1211 (x2, 
E_V4SFmode, 
E_SFmode) != 0)
                    return -1;
                  if (vector_operand (operands[2], E_SFmode)
                      && const_0_to_255_operand (operands[3], E_SImode)
                      && 
#line 14268 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                    return 7183; /* *avx512f_rndscalev4sf */
                  if (!nonimmediate_operand (operands[2], E_SFmode)
                      || !const_0_to_15_operand (operands[3], E_SImode)
                      || !
#line 25622 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return -1;
                  return 8973; /* *sse4_1_roundss */

                case E_V2DFmode:
                  if (pattern1211 (x2, 
E_V2DFmode, 
E_DFmode) != 0)
                    return -1;
                  if (vector_operand (operands[2], E_DFmode)
                      && const_0_to_255_operand (operands[3], E_SImode)
                      && (
#line 14268 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 7185; /* *avx512f_rndscalev2df */
                  if (!nonimmediate_operand (operands[2], E_DFmode)
                      || !const_0_to_15_operand (operands[3], E_SImode)
                      || !(
#line 25622 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 8974; /* *sse4_1_roundsd */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern882 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 3101 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2946; /* *avx512fp16_vmsqrtv8hf2 */

        case E_V4SFmode:
          if (pattern882 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 3101 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2950; /* *sse_vmsqrtv4sf2 */

        case E_V2DFmode:
          if (pattern882 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 3101 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2954; /* *sse2_vmsqrtv2df2 */

        default:
          return -1;
        }

    case FLOAT:
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (XWINT (x5, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              switch (pattern883 (x2, 
E_V8HFmode, 
E_HFmode))
                {
                case 0:
                  if (!
#line 7851 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4552; /* avx512fp16_vcvtsi2sh */

                case 1:
                  if (!(
#line 7851 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4556; /* avx512fp16_vcvtsi2shq */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern883 (x2, 
E_V4SFmode, 
E_SFmode))
                {
                case 0:
                  if (!
#line 8530 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 4784; /* sse_cvtsi2ss */

                case 1:
                  if (!(
#line 8530 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4786; /* sse_cvtsi2ssq */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern883 (x2, 
E_V2DFmode, 
E_DFmode))
                {
                case 0:
                  if (!
#line 8992 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4902; /* sse2_cvtsi2sd */

                case 1:
                  if (!
#line 9014 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT))
                    return -1;
                  return 4903; /* sse2_cvtsi2sdq */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3L:
          if (pnum_clobbers == NULL
              || pattern770 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !register_mmxmem_operand (operands[2], E_V2SImode)
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 8375 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
            return -1;
          *pnum_clobbers = 1;
          return 4780; /* sse_cvtpi2ps */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern883 (x2, 
E_V8HFmode, 
E_HFmode))
            {
            case 0:
              if (!
#line 7851 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4554; /* avx512fp16_vcvtusi2sh */

            case 1:
              if (!(
#line 7851 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 4558; /* avx512fp16_vcvtusi2shq */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern883 (x2, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!
#line 8626 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1))
                return -1;
              return 4802; /* cvtusi2ss32 */

            case 1:
              if (!
#line 8640 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_64BIT))
                return -1;
              return 4805; /* cvtusi2ss64 */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern883 (x2, 
E_V2DFmode, 
E_DFmode))
            {
            case 0:
              if (!(
#line 8626 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 4804; /* cvtusi2sd32 */

            case 1:
              if (!(
#line 8640 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_64BIT) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 4807; /* cvtusi2sd64 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      switch (GET_CODE (x9))
        {
        case VEC_SELECT:
          if (GET_MODE (x9) != E_HFmode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern1459 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 8311 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4756; /* avx512fp16_vcvtsh2sd */

            case E_V4SFmode:
              if (pattern1459 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 8311 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4760; /* avx512fp16_vcvtsh2ss */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern770 (x2, 
E_DFmode, 
E_V2DFmode) != 0)
                return -1;
              x7 = XEXP (x2, 1);
              if (!register_operand (x7, E_V2DFmode))
                return -1;
              switch (GET_MODE (x9))
                {
                case E_HFmode:
                  operands[1] = x9;
                  if (!memory_operand (operands[1], E_HFmode))
                    return -1;
                  operands[2] = x7;
                  if (!
#line 8325 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4764; /* avx512fp16_vcvtsh2sd_mem */

                case E_SFmode:
                  operands[2] = x9;
                  if (!nonimmediate_operand (operands[2], E_SFmode))
                    return -1;
                  operands[1] = x7;
                  if (!
#line 10081 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 5171; /* *sse2_vd_cvtss2sd */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern770 (x2, 
E_SFmode, 
E_V4SFmode) != 0)
                return -1;
              operands[1] = x9;
              if (!memory_operand (operands[1], E_HFmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 8325 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4766; /* avx512fp16_vcvtsh2ss_mem */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      switch (GET_CODE (x9))
        {
        case VEC_SELECT:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern770 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          switch (GET_MODE (x9))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 8341 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4768; /* avx512fp16_vcvtsd2sh */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 8341 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4772; /* avx512fp16_vcvtss2sh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || GET_MODE (x3) != E_V8HFmode
                  || GET_MODE (x4) != E_HFmode)
                return -1;
              operands[1] = x9;
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              if (!register_operand (operands[2], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!memory_operand (operands[1], E_SFmode)
                      || !
#line 8355 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4776; /* avx512fp16_vcvtss2sh_mem */

                case E_DFmode:
                  if (!memory_operand (operands[1], E_DFmode)
                      || !
#line 8355 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4778; /* avx512fp16_vcvtsd2sh_mem */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || GET_MODE (x3) != E_V4SFmode)
                return -1;
              operands[2] = x9;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              if (!register_operand (operands[1], E_V4SFmode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2SFmode:
                  if (!nonimmediate_operand (operands[2], E_V2DFmode)
                      || !
#line 10016 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 5162; /* sse2_cvtsd2ss */

                case E_SFmode:
                  if (!nonimmediate_operand (operands[2], E_DFmode)
                      || !
#line 10037 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 5166; /* *sse2_vd_cvtsd2ss */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_148 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_149 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern309 (x2))
        {
        case 0:
          if (!(
#line 12090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 803 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5310; /* *vec_setv16si_0_zero_extendhi */

        case 1:
          if (!
#line 12090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 5311; /* *vec_setv8si_0_zero_extendhi */

        case 2:
          if (!
#line 12090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 5312; /* *vec_setv4si_0_zero_extendhi */

        case 3:
          if (!(
#line 12090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 804 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5313; /* *vec_setv8di_0_zero_extendhi */

        case 4:
          if (!(
#line 12204 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5325; /* *vec_setv8di_0_zero_extendsi */

        case 5:
          if (!
#line 12090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 5314; /* *vec_setv4di_0_zero_extendhi */

        case 6:
          if (!(
#line 12204 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5326; /* *vec_setv4di_0_zero_extendsi */

        case 7:
          if (!
#line 12090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 5315; /* *vec_setv2di_0_zero_extendhi */

        case 8:
          if (!
#line 12204 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 5327; /* *vec_setv2di_0_zero_extendsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern136 (x2))
    {
    case 0:
      if (pattern772 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4607; /* avx512fp16_fixuns_truncv8hi2_mask */

    case 1:
      if (pattern772 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4614; /* avx512fp16_fixuns_truncv16hi2_mask */

    case 2:
      if (pattern772 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4622; /* avx512fp16_fixuns_truncv32hi2_mask */

    case 3:
      switch (pattern894 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4630; /* avx512fp16_fixuns_truncv8si2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5036; /* fixuns_truncv8dfv8si2_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9926 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 5154; /* fixuns_truncv8sfv8si2_mask */

        default:
          return -1;
        }

    case 4:
      switch (pattern893 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4638; /* avx512fp16_fixuns_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4883; /* fixuns_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern894 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4646; /* avx512fp16_fixuns_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5081; /* fixuns_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5134; /* fixuns_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern771 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4671; /* *avx512fp16_fixuns_truncv4si2_load_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 5054; /* fixuns_truncv4dfv4si2_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9926 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5156; /* fixuns_truncv4sfv4si2_mask */

        default:
          return -1;
        }

    case 7:
      switch (pattern895 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4675; /* *avx512fp16_fixuns_truncv4di2_load_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5089; /* fixuns_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5138; /* fixuns_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case 8:
      switch (pattern896 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7978 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4687; /* *avx512fp16_fixuns_truncv2di2_load_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5094; /* fixuns_truncv2dfv2di2_mask */

        default:
          return -1;
        }

    case 9:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4663; /* avx512fp16_fixuns_truncv4si2_mask */

    case 10:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4667; /* avx512fp16_fixuns_truncv4di2_mask */

    case 11:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7968 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4683; /* avx512fp16_fixuns_truncv2di2_mask */

    case 12:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 5146; /* avx512dq_fixuns_truncv2sfv2di2_mask */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern320 (x2))
    {
    case 0:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4420; /* avx512fp16_vcvtph2w_v32hi */

    case 1:
      switch (pattern640 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4428; /* avx512fp16_vcvtph2dq_v16si */

        case 1:
          if (!
#line 8708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4835; /* avx512f_fix_notruncv16sfv16si */

        default:
          return -1;
        }

    case 2:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4436; /* avx512fp16_vcvtph2qq_v8di */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 8729 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4849; /* *avx512dq_cvtps2qqv8di */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 9723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5095; /* fix_notruncv8dfv8di2 */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4444; /* avx512fp16_vcvtph2w_v16hi */

    case 4:
      switch (pattern639 (x2))
        {
        case 0:
          if (!(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4452; /* avx512fp16_vcvtph2dq_v8si */

        case 1:
          if (!(
#line 8692 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4829; /* avx_fix_notruncv8sfv8si */

        case 2:
          if (!
#line 9411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4999; /* avx512f_cvtpd2dq512 */

        default:
          return -1;
        }

    case 5:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4460; /* avx512fp16_vcvtph2qq_v4di */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 8729 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4853; /* *avx512dq_cvtps2qqv4di */

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !(
#line 9723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5099; /* fix_notruncv4dfv4di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4466; /* avx512fp16_vcvtph2w_v8hi */

    case 7:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4470; /* avx512fp16_vcvtph2dq_v4si */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8692 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 4833; /* sse2_fix_notruncv4sfv4si */

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !
#line 9421 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!false || TARGET_AVX10_2_256)))
            return -1;
          return 5003; /* avx_cvtpd2dq256 */

        default:
          return -1;
        }

    case 8:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4474; /* avx512fp16_vcvtph2qq_v2di */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !(
#line 9723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5103; /* fix_notruncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 8742 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4857; /* *avx512dq_cvtps2qqv2di */

    default:
      return -1;
    }
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (XINT (x4, 1))
    {
    case 63:
      switch (pattern910 (x2))
        {
        case 0:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 3064; /* ieee_maxv32hf3_mask_round */

        case 1:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 3072; /* ieee_maxv16hf3_mask_round */

        case 2:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3084; /* ieee_maxv16sf3_mask_round */

        case 3:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3092; /* ieee_maxv8sf3_mask_round */

        case 4:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3104; /* ieee_maxv8df3_mask_round */

        case 5:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3112; /* ieee_maxv4df3_mask_round */

        case 6:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3153; /* avx512fp16_ieee_vmmaxv8hf3_round */

        case 7:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3485 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3161; /* sse_ieee_vmmaxv4sf3_round */

        case 8:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3169; /* sse2_ieee_vmmaxv2df3_round */

        default:
          return -1;
        }

    case 62:
      switch (pattern910 (x2))
        {
        case 0:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 3068; /* ieee_minv32hf3_mask_round */

        case 1:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 3076; /* ieee_minv16hf3_mask_round */

        case 2:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3088; /* ieee_minv16sf3_mask_round */

        case 3:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3096; /* ieee_minv8sf3_mask_round */

        case 4:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3108; /* ieee_minv8df3_mask_round */

        case 5:
          if (!(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3116; /* ieee_minv4df3_mask_round */

        case 6:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3157; /* avx512fp16_ieee_vmminv8hf3_round */

        case 7:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3485 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3165; /* sse_ieee_vmminv4sf3_round */

        case 8:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3173; /* sse2_ieee_vmminv2df3_round */

        default:
          return -1;
        }

    case 192:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[5] = x9;
      if (!const48_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1547 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 3192; /* reducepv32hf_mask_round */

        case E_V16HFmode:
          if (pattern1547 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 3196; /* reducepv16hf_mask_round */

        case E_V16SFmode:
          if (pattern1547 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 3202; /* reducepv16sf_mask_round */

        case E_V8SFmode:
          if (pattern1547 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 3206; /* reducepv8sf_mask_round */

        case E_V8DFmode:
          if (pattern1547 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 3212; /* reducepv8df_mask_round */

        case E_V4DFmode:
          if (pattern1547 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 3216; /* reducepv4df_mask_round */

        default:
          return -1;
        }

    case 221:
      switch (pattern912 (x2))
        {
        case 0:
          if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 106 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4379; /* avx512bw_fmulc_v32hf_mask_round */

        case 1:
          if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 106 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4387; /* avx512vl_fmulc_v16hf_mask_round */

        case 2:
          if (!(
#line 460 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7522 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4409; /* avx512fp16_fmulcsh_v8hf_round */

        default:
          return -1;
        }

    case 222:
      switch (pattern912 (x2))
        {
        case 0:
          if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 106 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4383; /* avx512bw_fcmulc_v32hf_mask_round */

        case 1:
          if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 106 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4391; /* avx512vl_fcmulc_v16hf_mask_round */

        case 2:
          if (!(
#line 460 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7522 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4413; /* avx512fp16_fcmulcsh_v8hf_round */

        default:
          return -1;
        }

    case 58:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x9 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x9, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          operands[3] = x9;
          switch (pattern1403 (x2))
            {
            case 0:
              if (!(
#line 444 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13625 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 5416; /* avx512f_vmscalefv8hf_round */

            case 1:
              if (!
#line 444 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 5420; /* avx512f_vmscalefv4sf_round */

            case 2:
              if (!(
#line 444 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13625 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 5424; /* avx512f_vmscalefv2df_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[4] = x8;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          operands[5] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1548 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 5430; /* avx512bw_scalefv32hf_mask_round */

            case E_V16HFmode:
              if (pattern1548 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
                return -1;
              return 5434; /* avx512vl_scalefv16hf_mask_round */

            case E_V16SFmode:
              if (pattern1548 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5440; /* avx512f_scalefv16sf_mask_round */

            case E_V8SFmode:
              if (pattern1548 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5444; /* avx512vl_scalefv8sf_mask_round */

            case E_V8DFmode:
              if (pattern1548 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5450; /* avx512f_scalefv8df_mask_round */

            case E_V4DFmode:
              if (pattern1548 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5454; /* avx512vl_scalefv4df_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 165:
      x8 = XEXP (x3, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const48_operand (operands[3], E_SImode))
        return -1;
      switch (pattern1403 (x2))
        {
        case 0:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14058 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 7067; /* avx512f_sgetexpv8hf_round */

        case 1:
          if (!
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
            return -1;
          return 7071; /* avx512f_sgetexpv4sf_round */

        case 2:
          if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14058 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 7075; /* avx512f_sgetexpv2df_round */

        default:
          return -1;
        }

    case 94:
      x6 = XVECEXP (x4, 0, 1);
      if (!const_0_to_255_operand (x6, E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x9, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[4] = x8;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          operands[5] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1549 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 7142; /* avx512bw_rndscalev32hf_mask_round */

            case E_V16HFmode:
              if (pattern1549 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
                return -1;
              return 7146; /* avx512vl_rndscalev16hf_mask_round */

            case E_V16SFmode:
              if (pattern1549 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 7152; /* avx512f_rndscalev16sf_mask_round */

            case E_V8SFmode:
              if (pattern1549 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 7156; /* avx512vl_rndscalev8sf_mask_round */

            case E_V8DFmode:
              if (pattern1549 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 7162; /* avx512f_rndscalev8df_mask_round */

            case E_V4DFmode:
              if (pattern1549 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 7166; /* avx512vl_rndscalev4df_mask_round */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          operands[3] = x6;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1580 (x2, 
E_V8HFmode) != 0
                  || !(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14252 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 7171; /* avx512f_rndscalev8hf_round */

            case E_V4SFmode:
              if (pattern1580 (x2, 
E_V4SFmode) != 0
                  || !
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 7175; /* avx512f_rndscalev4sf_round */

            case E_V2DFmode:
              if (pattern1580 (x2, 
E_V2DFmode) != 0
                  || !(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14252 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 7179; /* avx512f_rndscalev2df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 150:
      if (GET_MODE (x4) != E_V16HImode
          || !register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!nonimm_or_0_operand (operands[3], E_V16HImode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      operands[5] = x9;
      if (!const48_operand (operands[5], E_SImode)
          || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29231 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9666; /* avx512f_vcvtps2ph512_mask_round */

    case 166:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      if (!const_0_to_15_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[5] = x9;
      if (!const48_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1549 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 10012; /* avx512bw_getmantv32hf_mask_round */

        case E_V16HFmode:
          if (pattern1549 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 10016; /* avx512vl_getmantv16hf_mask_round */

        case E_V16SFmode:
          if (pattern1549 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 10022; /* avx512f_getmantv16sf_mask_round */

        case E_V8SFmode:
          if (pattern1549 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 10026; /* avx512vl_getmantv8sf_mask_round */

        case E_V8DFmode:
          if (pattern1549 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 10032; /* avx512f_getmantv8df_mask_round */

        case E_V4DFmode:
          if (pattern1549 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 10036; /* avx512vl_getmantv4df_mask_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3189; /* *reducepv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3193; /* *reducepv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3197; /* *reducepv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3199; /* *reducepv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3203; /* *reducepv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))) && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3207; /* *reducepv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3209; /* *reducepv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3213; /* *reducepv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 4024 "../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3217; /* *reducepv2df */

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern784 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9483; /* avx_maskloadps */

    case E_V2DFmode:
      if (pattern784 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9484; /* avx_maskloadpd */

    case E_V4DImode:
      if (pattern785 (x3, 
E_V4DImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9485; /* avx2_maskloadq256 */

    case E_V2DImode:
      if (pattern785 (x3, 
E_V2DImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9486; /* avx2_maskloadq */

    case E_V8SFmode:
      if (pattern784 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9487; /* avx_maskloadps256 */

    case E_V4DFmode:
      if (pattern784 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9488; /* avx_maskloadpd256 */

    case E_V8SImode:
      if (pattern785 (x3, 
E_V8SImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9489; /* avx2_maskloadd256 */

    case E_V4SImode:
      if (pattern785 (x3, 
E_V4SImode) != 0
          || !
#line 28634 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9490; /* avx2_maskloadd */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      if (pattern150 (x3, 
E_V32QImode) != 0
          || !(
#line 23197 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 752 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8629; /* avx2_psignv32qi3 */

    case E_V16QImode:
      if (pattern150 (x3, 
E_V16QImode) != 0
          || !
#line 23197 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8630; /* ssse3_psignv16qi3 */

    case E_V16HImode:
      if (pattern150 (x3, 
E_V16HImode) != 0
          || !(
#line 23197 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 753 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8631; /* avx2_psignv16hi3 */

    case E_V8HImode:
      if (pattern150 (x3, 
E_V8HImode) != 0
          || !
#line 23197 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8632; /* ssse3_psignv8hi3 */

    case E_V8SImode:
      if (pattern150 (x3, 
E_V8SImode) != 0
          || !(
#line 23197 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 754 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8633; /* avx2_psignv8si3 */

    case E_V4SImode:
      if (pattern150 (x3, 
E_V4SImode) != 0
          || !
#line 23197 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8634; /* ssse3_psignv4si3 */

    default:
      return -1;
    }
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6403 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4084; /* *fma_fmaddsub_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4102; /* *fma_fmaddsub_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6403 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 4085; /* *fma_fmaddsub_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4106; /* *fma_fmaddsub_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6403 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4086; /* *fma_fmaddsub_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4112; /* *fma_fmaddsub_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6403 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 4087; /* *fma_fmaddsub_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4116; /* *fma_fmaddsub_v2df */

        case E_V32HFmode:
          if (pattern664 (x3, 
E_V32HFmode) != 0
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4088; /* *fma_fmaddsub_v32hf */

        case E_V16HFmode:
          if (pattern664 (x3, 
E_V16HFmode) != 0
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4092; /* *fma_fmaddsub_v16hf */

        case E_V8HFmode:
          if (pattern664 (x3, 
E_V8HFmode) != 0
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4096; /* *fma_fmaddsub_v8hf */

        case E_V16SFmode:
          if (pattern664 (x3, 
E_V16SFmode) != 0
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4098; /* *fma_fmaddsub_v16sf */

        case E_V8DFmode:
          if (pattern664 (x3, 
E_V8DFmode) != 0
              || !(
#line 6421 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4108; /* *fma_fmaddsub_v8df */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x6) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6472 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4148; /* *fma_fmsubadd_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4166; /* *fma_fmsubadd_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x6) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6472 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 4149; /* *fma_fmsubadd_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4170; /* *fma_fmsubadd_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || GET_MODE (x6) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6472 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4150; /* *fma_fmsubadd_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4176; /* *fma_fmsubadd_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x6) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6472 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 4151; /* *fma_fmsubadd_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4180; /* *fma_fmsubadd_v2df */

        case E_V32HFmode:
          if (pattern1024 (x3, 
E_V32HFmode) != 0
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4152; /* *fma_fmsubadd_v32hf */

        case E_V16HFmode:
          if (pattern1024 (x3, 
E_V16HFmode) != 0
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4156; /* *fma_fmsubadd_v16hf */

        case E_V8HFmode:
          if (pattern1024 (x3, 
E_V8HFmode) != 0
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4160; /* *fma_fmsubadd_v8hf */

        case E_V16SFmode:
          if (pattern1024 (x3, 
E_V16SFmode) != 0
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4162; /* *fma_fmsubadd_v16sf */

        case E_V8DFmode:
          if (pattern1024 (x3, 
E_V8DFmode) != 0
              || !(
#line 6491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4172; /* *fma_fmsubadd_v8df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1026 (x3, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9921; /* expandv16si_mask */

        case E_V16SFmode:
          if (pattern1026 (x3, 
E_HImode, 
E_V16SFmode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9922; /* expandv16sf_mask */

        case E_V8DImode:
          if (pattern1026 (x3, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9923; /* expandv8di_mask */

        case E_V8DFmode:
          if (pattern1026 (x3, 
E_QImode, 
E_V8DFmode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9924; /* expandv8df_mask */

        case E_V8SImode:
          if (pattern1026 (x3, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9925; /* expandv8si_mask */

        case E_V8SFmode:
          if (pattern1026 (x3, 
E_QImode, 
E_V8SFmode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9926; /* expandv8sf_mask */

        case E_V4DImode:
          if (pattern1026 (x3, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9927; /* expandv4di_mask */

        case E_V4DFmode:
          if (pattern1026 (x3, 
E_QImode, 
E_V4DFmode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9928; /* expandv4df_mask */

        case E_V4SImode:
          if (pattern1026 (x3, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9929; /* expandv4si_mask */

        case E_V4SFmode:
          if (pattern1026 (x3, 
E_QImode, 
E_V4SFmode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9930; /* expandv4sf_mask */

        case E_V2DImode:
          if (pattern1026 (x3, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9931; /* expandv2di_mask */

        case E_V2DFmode:
          if (pattern1026 (x3, 
E_QImode, 
E_V2DFmode) != 0
              || !(
#line 29731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9932; /* expandv2df_mask */

        case E_V64QImode:
          if (pattern1026 (x3, 
E_DImode, 
E_V64QImode) != 0
              || !(
#line 29745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9933; /* expandv64qi_mask */

        case E_V16QImode:
          if (pattern1026 (x3, 
E_HImode, 
E_V16QImode) != 0
              || !(
#line 29745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9934; /* expandv16qi_mask */

        case E_V32QImode:
          if (pattern1026 (x3, 
E_SImode, 
E_V32QImode) != 0
              || !(
#line 29745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9935; /* expandv32qi_mask */

        case E_V32HImode:
          if (pattern1026 (x3, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 29745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9936; /* expandv32hi_mask */

        case E_V16HImode:
          if (pattern1026 (x3, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 29745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9937; /* expandv16hi_mask */

        case E_V8HImode:
          if (pattern1026 (x3, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 29745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9938; /* expandv8hi_mask */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern916 (x3))
        {
        case 0:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16SImode)) >= 4)) && 
#line 1016 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9939; /* *expandv16si_mask */

        case 1:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16SFmode)) >= 4)) && 
#line 1017 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9940; /* *expandv16sf_mask */

        case 2:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8DImode)) >= 4)) && 
#line 1018 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9941; /* *expandv8di_mask */

        case 3:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8DFmode)) >= 4)) && 
#line 1019 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9942; /* *expandv8df_mask */

        case 4:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8SImode)) >= 4)) && 
#line 1020 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9943; /* *expandv8si_mask */

        case 5:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8SFmode)) >= 4)) && 
#line 1020 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9944; /* *expandv8sf_mask */

        case 6:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4DImode)) >= 4)) && 
#line 1021 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9945; /* *expandv4di_mask */

        case 7:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4DFmode)) >= 4)) && 
#line 1021 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9946; /* *expandv4df_mask */

        case 8:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4SImode)) >= 4)) && 
#line 1022 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9947; /* *expandv4si_mask */

        case 9:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4SFmode)) >= 4)) && 
#line 1022 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9948; /* *expandv4sf_mask */

        case 10:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V2DImode)) >= 4)) && 
#line 1023 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9949; /* *expandv2di_mask */

        case 11:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V2DFmode)) >= 4)) && 
#line 1023 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9950; /* *expandv2df_mask */

        case 12:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V64QImode)) >= 4)) && 
#line 1024 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9951; /* *expandv64qi_mask */

        case 13:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16QImode)) >= 4)) && 
#line 1024 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9952; /* *expandv16qi_mask */

        case 14:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V32QImode)) >= 4)) && 
#line 1024 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9953; /* *expandv32qi_mask */

        case 15:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V32HImode)) >= 4)) && 
#line 1025 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9954; /* *expandv32hi_mask */

        case 16:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16HImode)) >= 4)) && 
#line 1025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9955; /* *expandv16hi_mask */

        case 17:
          if (!(
#line 29759 "../../gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8HImode)) >= 4)) && 
#line 1025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9956; /* *expandv8hi_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern174 (x1))
    {
    case 0:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10243; /* vpshldv_v32hi */

    case 1:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10244; /* vpshldv_v16si */

    case 2:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10245; /* vpshldv_v8di */

    case 3:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10246; /* vpshldv_v16hi */

    case 4:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10247; /* vpshldv_v8si */

    case 5:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10248; /* vpshldv_v4di */

    case 6:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10249; /* vpshldv_v8hi */

    case 7:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10250; /* vpshldv_v4si */

    case 8:
      if (!(
#line 30488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10251; /* vpshldv_v2di */

    default:
      return -1;
    }
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern152 (x3, 
E_V8SFmode) != 0
          || !(
#line 23768 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8711; /* avx_dpps256 */

    case E_V4SFmode:
      if (pattern152 (x3, 
E_V4SFmode) != 0
          || !
#line 23768 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return -1;
      return 8712; /* sse4_1_dpps */

    case E_V4DFmode:
      if (pattern152 (x3, 
E_V4DFmode) != 0
          || !(
#line 23768 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8713; /* avx_dppd256 */

    case E_V2DFmode:
      if (pattern152 (x3, 
E_V2DFmode) != 0
          || !(
#line 23768 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 8714; /* sse4_1_dppd */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 51:
      return recog_248 (x1, insn, pnum_clobbers);

    case 59:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!cmpps_imm_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern61 (x2, 
E_V8SFmode) != 0
              || !(
#line 4096 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3231; /* avx_cmpv8sf3 */

        case E_V4SFmode:
          if (pattern61 (x2, 
E_V4SFmode) != 0
              || !
#line 4096 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3232; /* avx_cmpv4sf3 */

        case E_V4DFmode:
          if (pattern61 (x2, 
E_V4DFmode) != 0
              || !(
#line 4096 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3233; /* avx_cmpv4df3 */

        case E_V2DFmode:
          if (pattern61 (x2, 
E_V2DFmode) != 0
              || !(
#line 4096 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3234; /* avx_cmpv2df3 */

        default:
          return -1;
        }

    case 133:
      return recog_247 (x1, insn, pnum_clobbers);

    case 217:
      return recog_263 (x1, insn, pnum_clobbers);

    case 219:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern665 (x2))
        {
        case 0:
          if ((
#line 7160 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 4326; /* fma_fcmaddc_v32hf */
          break;

        case 1:
          if ((
#line 7160 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4334; /* fma_fcmaddc_v16hf */
          break;

        case 2:
          if ((
#line 7160 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4340; /* fma_fcmaddc_v8hf */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      switch (pattern591 (x2))
        {
        case 0:
          if (!(
#line 7266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4363; /* fma_v32hf_fcmaddc_bcst */

        case 1:
          if (!(
#line 7266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4364; /* fma_v16hf_fcmaddc_bcst */

        case 2:
          if (!(
#line 7266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4365; /* fma_v8hf_fcmaddc_bcst */

        default:
          return -1;
        }

    case 218:
      switch (pattern167 (x1))
        {
        case 0:
          if (!(
#line 7225 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4354; /* fma_fmaddc_v16sf_pair */

        case 1:
          if (!(
#line 7225 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4356; /* fma_fmaddc_v8sf_pair */

        case 2:
          if (!(
#line 7225 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4358; /* fma_fmaddc_v4sf_pair */

        default:
          return -1;
        }

    case 220:
      switch (pattern167 (x1))
        {
        case 0:
          if (!(
#line 7225 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4355; /* fma_fcmaddc_v16sf_pair */

        case 1:
          if (!(
#line 7225 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4357; /* fma_fcmaddc_v8sf_pair */

        case 2:
          if (!(
#line 7225 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4359; /* fma_fcmaddc_v4sf_pair */

        default:
          return -1;
        }

    case 50:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern967 (x2, 
E_V4SImode) != 0
              || !
#line 12243 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 5329; /* sse4_1_insertps_v4si */

        case E_V4SFmode:
          if (pattern967 (x2, 
E_V4SFmode) != 0
              || !
#line 12243 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 5330; /* sse4_1_insertps_v4sf */

        default:
          return -1;
        }

    case 167:
      return recog_255 (x1, insn, pnum_clobbers);

    case 155:
      return recog_250 (x1, insn, pnum_clobbers);

    case 47:
      return recog_246 (x1, insn, pnum_clobbers);

    case 121:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4TImode:
          if (pattern150 (x2, 
E_V4TImode) != 0
              || !(
#line 23254 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 725 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8641; /* avx512bw_palignrv4ti */

        case E_V2TImode:
          if (pattern150 (x2, 
E_V2TImode) != 0
              || !(
#line 23254 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 725 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8642; /* avx2_palignrv2ti */

        case E_V1TImode:
          if (pattern150 (x2, 
E_V1TImode) != 0
              || !
#line 23254 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8643; /* ssse3_palignrv1ti */

        default:
          return -1;
        }

    case 122:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_VOIDmode)
          || !
#line 23448 "../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 8673; /* sse4a_extrqi */

    case 126:
      return recog_261 (x1, insn, pnum_clobbers);

    case 128:
      return recog_262 (x1, insn, pnum_clobbers);

    case 53:
      if (pattern63 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!nonimmediate_operand (operands[3], E_V16QImode)
          || !
#line 26496 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 9026; /* xop_pperm */

    case 135:
      return recog_260 (x1, insn, pnum_clobbers);

    case 143:
      if (pattern158 (x1, 
E_V2DImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode)
          || !
#line 27209 "../../gcc/config/i386/sse.md"
(TARGET_PCLMUL))
        return -1;
      return 9085; /* pclmulqdq */

    case 152:
      if (pattern63 (x1, 
E_V4DImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode)
          || !
#line 27666 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
        return -1;
      return 9175; /* avx2_permv2ti */

    case 146:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern61 (x2, 
E_V8SImode) != 0
              || !
#line 28319 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9445; /* *avx_vperm2f128v8si_full */

        case E_V8SFmode:
          if (pattern61 (x2, 
E_V8SFmode) != 0
              || !
#line 28319 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9446; /* *avx_vperm2f128v8sf_full */

        case E_V4DFmode:
          if (pattern61 (x2, 
E_V4DFmode) != 0
              || !
#line 28319 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9447; /* *avx_vperm2f128v4df_full */

        default:
          return -1;
        }

    case 153:
      return recog_245 (x1, insn, pnum_clobbers);

    case 169:
      return recog_252 (x1, insn, pnum_clobbers);

    case 170:
      return recog_251 (x1, insn, pnum_clobbers);

    case 171:
      return recog_249 (x1, insn, pnum_clobbers);

    case 194:
      return recog_254 (x1, insn, pnum_clobbers);

    case 186:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern161 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 29937 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10051; /* *avx512bw_dbpsadbwv8hi */

        case E_V16HImode:
          if (pattern161 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 29937 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10053; /* *avx512bw_dbpsadbwv16hi */

        case E_V32HImode:
          if (pattern161 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 29937 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10055; /* *avx512bw_dbpsadbwv32hi */

        default:
          return -1;
        }

    case 182:
      if (pattern158 (x1, 
E_V4SImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_3_operand (operands[3], E_SImode)
          || !
#line 30005 "../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 10084; /* sha1rnds4 */

    case 185:
      if (pattern158 (x1, 
E_V4SImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 30040 "../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 10087; /* sha256rnds2 */

    case 224:
      if (pattern169 (x1) != 0
          || !
#line 30053 "../../gcc/config/i386/sse.md"
(TARGET_SM3))
        return -1;
      return 10088; /* vsm3msg1 */

    case 225:
      if (pattern169 (x1) != 0
          || !
#line 30065 "../../gcc/config/i386/sse.md"
(TARGET_SM3))
        return -1;
      return 10089; /* vsm3msg2 */

    case 241:
      if (pattern157 (x1, 
E_V4DImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V2DImode)
          || !
#line 30113 "../../gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 10093; /* vsha512rnds2 */

    case 195:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 30222 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA && TARGET_EVEX512))
            return -1;
          return 10106; /* vpmadd52luqv8di */

        case 1:
          if (!(
#line 30235 "../../gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10108; /* vpmadd52luqv4di */

        case 2:
          if (!
#line 30235 "../../gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)))
            return -1;
          return 10110; /* vpmadd52luqv2di */

        default:
          return -1;
        }

    case 196:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 30222 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA && TARGET_EVEX512))
            return -1;
          return 10107; /* vpmadd52huqv8di */

        case 1:
          if (!(
#line 30235 "../../gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10109; /* vpmadd52huqv4di */

        case 2:
          if (!
#line 30235 "../../gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)))
            return -1;
          return 10111; /* vpmadd52huqv2di */

        default:
          return -1;
        }

    case 198:
      switch (pattern172 (x1))
        {
        case 0:
          if (!(
#line 30359 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 10162; /* vgf2p8affineinvqb_v64qi */

        case 1:
          if (!(
#line 30359 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10164; /* vgf2p8affineinvqb_v32qi */

        case 2:
          if (!
#line 30359 "../../gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 10166; /* vgf2p8affineinvqb_v16qi */

        default:
          return -1;
        }

    case 199:
      switch (pattern172 (x1))
        {
        case 0:
          if (!(
#line 30376 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 10168; /* vgf2p8affineqb_v64qi */

        case 1:
          if (!(
#line 30376 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10170; /* vgf2p8affineqb_v32qi */

        case 2:
          if (!
#line 30376 "../../gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 10172; /* vgf2p8affineqb_v16qi */

        default:
          return -1;
        }

    case 202:
      return recog_259 (x1, insn, pnum_clobbers);

    case 201:
      return recog_257 (x1, insn, pnum_clobbers);

    case 203:
      return recog_258 (x1, insn, pnum_clobbers);

    case 204:
      return recog_256 (x1, insn, pnum_clobbers);

    case 205:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30593 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10270; /* vpdpbusd_v16si */

        case 1:
          if (!(
#line 30604 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10271; /* vpdpbusd_v8si */

        case 2:
          if (!
#line 30604 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10272; /* vpdpbusd_v4si */

        default:
          return -1;
        }

    case 206:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10279; /* vpdpbusds_v16si */

        case 1:
          if (!(
#line 30673 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10280; /* vpdpbusds_v8si */

        case 2:
          if (!
#line 30673 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10281; /* vpdpbusds_v4si */

        default:
          return -1;
        }

    case 207:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30731 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10288; /* vpdpwssd_v16si */

        case 1:
          if (!(
#line 30742 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10289; /* vpdpwssd_v8si */

        case 2:
          if (!
#line 30742 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10290; /* vpdpwssd_v4si */

        default:
          return -1;
        }

    case 208:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30800 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10297; /* vpdpwssds_v16si */

        case 1:
          if (!(
#line 30811 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10298; /* vpdpwssds_v8si */

        case 2:
          if (!
#line 30811 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10299; /* vpdpwssds_v4si */

        default:
          return -1;
        }

    case 213:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DImode:
          if (pattern150 (x2, 
E_V8DImode) != 0
              || !(
#line 30924 "../../gcc/config/i386/sse.md"
(TARGET_VPCLMULQDQ) && 
#line 620 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 10318; /* vpclmulqdq_v8di */

        case E_V4DImode:
          if (pattern150 (x2, 
E_V4DImode) != 0
              || !
#line 30924 "../../gcc/config/i386/sse.md"
(TARGET_VPCLMULQDQ))
            return -1;
          return 10319; /* vpclmulqdq_v4di */

        case E_V2DImode:
          if (pattern150 (x2, 
E_V2DImode) != 0
              || !(
#line 30924 "../../gcc/config/i386/sse.md"
(TARGET_VPCLMULQDQ) && 
#line 620 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10320; /* vpclmulqdq_v2di */

        default:
          return -1;
        }

    case 216:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern917 (x2, 
E_V32BFmode, 
E_V16SFmode) != 0
              || !(
#line 31203 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10348; /* avx512f_dpbf16ps_v16sf */

        case E_V8SFmode:
          if (pattern917 (x2, 
E_V16BFmode, 
E_V8SFmode) != 0
              || !(
#line 31203 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10350; /* avx512f_dpbf16ps_v8sf */

        case E_V4SFmode:
          if (pattern917 (x2, 
E_V8BFmode, 
E_V4SFmode) != 0
              || !(
#line 31203 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 539 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10352; /* avx512f_dpbf16ps_v4sf */

        default:
          return -1;
        }

    case 227:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10368; /* vpdpbssd_v8si */

        case 1:
          if (!
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10374; /* vpdpbssd_v4si */

        case 2:
          if (!
#line 31585 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10380; /* vpdpbssd_v16si */

        default:
          return -1;
        }

    case 228:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10369; /* vpdpbssds_v8si */

        case 1:
          if (!
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10375; /* vpdpbssds_v4si */

        case 2:
          if (!
#line 31585 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10381; /* vpdpbssds_v16si */

        default:
          return -1;
        }

    case 229:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10370; /* vpdpbsud_v8si */

        case 1:
          if (!
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10376; /* vpdpbsud_v4si */

        case 2:
          if (!
#line 31585 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10382; /* vpdpbsud_v16si */

        default:
          return -1;
        }

    case 230:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10371; /* vpdpbsuds_v8si */

        case 1:
          if (!
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10377; /* vpdpbsuds_v4si */

        case 2:
          if (!
#line 31585 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10383; /* vpdpbsuds_v16si */

        default:
          return -1;
        }

    case 231:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10372; /* vpdpbuud_v8si */

        case 1:
          if (!
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10378; /* vpdpbuud_v4si */

        case 2:
          if (!
#line 31585 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10384; /* vpdpbuud_v16si */

        default:
          return -1;
        }

    case 232:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10373; /* vpdpbuuds_v8si */

        case 1:
          if (!
#line 31574 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10379; /* vpdpbuuds_v4si */

        case 2:
          if (!
#line 31585 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10385; /* vpdpbuuds_v16si */

        default:
          return -1;
        }

    case 233:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10522; /* vpdpwusd_v8si */

        case 1:
          if (!
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10528; /* vpdpwusd_v4si */

        case 2:
          if (!
#line 31994 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10534; /* vpdpwusd_v16si */

        default:
          return -1;
        }

    case 234:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10523; /* vpdpwusds_v8si */

        case 1:
          if (!
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10529; /* vpdpwusds_v4si */

        case 2:
          if (!
#line 31994 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10535; /* vpdpwusds_v16si */

        default:
          return -1;
        }

    case 235:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10524; /* vpdpwsud_v8si */

        case 1:
          if (!
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10530; /* vpdpwsud_v4si */

        case 2:
          if (!
#line 31994 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10536; /* vpdpwsud_v16si */

        default:
          return -1;
        }

    case 236:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10525; /* vpdpwsuds_v8si */

        case 1:
          if (!
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10531; /* vpdpwsuds_v4si */

        case 2:
          if (!
#line 31994 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10537; /* vpdpwsuds_v16si */

        default:
          return -1;
        }

    case 237:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10526; /* vpdpwuud_v8si */

        case 1:
          if (!
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10532; /* vpdpwuud_v4si */

        case 2:
          if (!
#line 31994 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10538; /* vpdpwuud_v16si */

        default:
          return -1;
        }

    case 238:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10527; /* vpdpwuuds_v8si */

        case 1:
          if (!
#line 31983 "../../gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10533; /* vpdpwuuds_v4si */

        case 2:
          if (!
#line 31994 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10539; /* vpdpwuuds_v16si */

        default:
          return -1;
        }

    case 244:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern170 (x2, 
E_V16SFmode) != 0
              || !(
#line 32046 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10576; /* vdpphps_v16sf */

        case E_V8SFmode:
          if (pattern170 (x2, 
E_V8SFmode) != 0
              || !
#line 32046 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10577; /* vdpphps_v8sf */

        case E_V4SFmode:
          if (pattern170 (x2, 
E_V4SFmode) != 0
              || !
#line 32046 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10578; /* vdpphps_v4sf */

        default:
          return -1;
        }

    case 277:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1027 (x2, 
E_V32BFmode) != 0
              || !(
#line 32636 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10929; /* avx10_2_minmaxbf16_v32bf */

        case E_V16BFmode:
          if (pattern1027 (x2, 
E_V16BFmode) != 0
              || !
#line 32636 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10931; /* avx10_2_minmaxbf16_v16bf */

        case E_V8BFmode:
          if (pattern1027 (x2, 
E_V8BFmode) != 0
              || !
#line 32636 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10933; /* avx10_2_minmaxbf16_v8bf */

        default:
          return -1;
        }

    case 278:
      return recog_253 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  res = recog_286 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (XWINT (x5, 0) != 1L
          || XWINT (x6, 0) != 2L
          || XWINT (x7, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !nonimmediate_operand (operands[1], E_V8DFmode)
              || !(
#line 12650 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5345; /* vec_extract_lo_v8df */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !nonimmediate_operand (operands[1], E_V8DImode)
              || !(
#line 12650 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5346; /* vec_extract_lo_v8di */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V8SImode)
              || !
#line 12983 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5369; /* vec_extract_lo_v8si */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 12983 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5370; /* vec_extract_lo_v8sf */

        default:
          return -1;
        }

    case 4L:
      if (XWINT (x5, 0) != 5L
          || XWINT (x6, 0) != 6L
          || XWINT (x7, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !register_operand (operands[1], E_V8DFmode)
              || !(
#line 12686 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5349; /* vec_extract_hi_v8df */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_V8DImode)
              || !(
#line 12686 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5350; /* vec_extract_hi_v8di */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 13015 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5373; /* vec_extract_hi_v8si */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 13015 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5374; /* vec_extract_hi_v8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[6] = x4;
  res = recog_293 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 4L)
    return -1;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern1412 (x3) != 0
      || !register_operand (operands[0], E_V16HImode)
      || GET_MODE (x2) != E_V16HImode
      || !nonimmediate_operand (operands[1], E_V16HImode)
      || pattern672 (x3) != 0)
    return -1;
  x8 = XVECEXP (x3, 0, 8);
  operands[6] = x8;
  if (!const_8_to_11_operand (operands[6], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 9);
  operands[7] = x9;
  if (!const_8_to_11_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 10);
  operands[8] = x10;
  if (!const_8_to_11_operand (operands[8], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 11);
  operands[9] = x11;
  if (!const_8_to_11_operand (operands[9], E_VOIDmode)
      || !
#line 20793 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   && 1 && 1
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9])))
    return -1;
  return 8443; /* avx2_pshuflw_1 */
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode))
        {
          if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
              && 
#line 27373 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9152; /* *avx_vperm_broadcast_v4sf */
          if (
#line 27510 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4SFmode)))
            return 9159; /* *avx_vpermilpv4sf */
        }
      if (!register_operand (operands[1], E_V4SFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9457; /* *ssse3_palignrv4sf_perm */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27401 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 9153; /* *avx_vperm_broadcast_v8sf */
      if (!(
#line 27510 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8SFmode)) && 
#line 374 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 9157; /* *avx_vpermilpv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27401 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 9154; /* *avx_vperm_broadcast_v4df */
      if (!(
#line 27510 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4DFmode)) && 
#line 375 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 9163; /* *avx_vpermilpv4df */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 27510 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V16SFmode)) && 
#line 374 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9155; /* *avx512f_vpermilpv16sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 27510 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8DFmode)) && 
#line 375 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9161; /* *avx512f_vpermilpv8df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && (
#line 27510 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V2DFmode)) && 
#line 376 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 9165; /* *avx_vpermilpv2df */
      if (!register_operand (operands[1], E_V2DFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !(
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 342 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 9458; /* *ssse3_palignrv2df_perm */

    case E_V16QImode:
      if (pattern1141 (x2, 
E_V16QImode) != 0
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9451; /* *ssse3_palignrv16qi_perm */

    case E_V8HImode:
      if (pattern1141 (x2, 
E_V8HImode) != 0
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9452; /* *ssse3_palignrv8hi_perm */

    case E_V8HFmode:
      if (pattern1141 (x2, 
E_V8HFmode) != 0
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9453; /* *ssse3_palignrv8hf_perm */

    case E_V8BFmode:
      if (pattern1141 (x2, 
E_V8BFmode) != 0
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9454; /* *ssse3_palignrv8bf_perm */

    case E_V4SImode:
      if (pattern1141 (x2, 
E_V4SImode) != 0
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9455; /* *ssse3_palignrv4si_perm */

    case E_V2DImode:
      if (pattern1141 (x2, 
E_V2DImode) != 0
          || !
#line 28362 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9456; /* *ssse3_palignrv2di_perm */

    default:
      return -1;
    }
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5528; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5555; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5582; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5609; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5636; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5663; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5690; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5717; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5744; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5771; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5798; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5825; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5531; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5558; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5585; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5612; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5639; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5666; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5693; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5720; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5747; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5774; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5801; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5828; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5534; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5561; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5588; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5615; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5642; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5669; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5696; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5723; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5750; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5777; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5804; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5831; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6818; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6827; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6836; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6845; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6854; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6863; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6872; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6881; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6890; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6899; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6908; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6917; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern533 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6176; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6203; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6230; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6257; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6284; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6311; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6338; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6365; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6392; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6419; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6446; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6473; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern533 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6179; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6206; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6233; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6260; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6287; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6314; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6341; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6368; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6395; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6422; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6449; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6476; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern533 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6182; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6209; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6236; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6263; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6290; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6317; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6344; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6371; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6398; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6425; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6452; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6479; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 32
      || pattern1356 (x5, 
E_V32HImode) != 0)
    return -1;
  x6 = XVECEXP (x5, 0, 8);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 9);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x5, 0, 10);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x5, 0, 11);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x5, 0, 12);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x5, 0, 13);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x5, 0, 14);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x5, 0, 15);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x5, 0, 16);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x5, 0, 17);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x5, 0, 18);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x5, 0, 19);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x5, 0, 20);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x5, 0, 21);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x5, 0, 22);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x5, 0, 23);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x5, 0, 24);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x5, 0, 25);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x5, 0, 26);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x5, 0, 27);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x5, 0, 28);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x5, 0, 29);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x5, 0, 30);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x5, 0, 31);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32SImode
      || pattern1508 (x4, 
E_V32SImode) != 0)
    return -1;
  x30 = XEXP (x4, 0);
  x31 = XEXP (x30, 0);
  x32 = XEXP (x31, 1);
  if (GET_MODE (x32) != E_V32SImode)
    return -1;
  x33 = XEXP (x32, 0);
  operands[2] = x33;
  if (!nonimmediate_operand (operands[2], E_V32HImode)
      || !
#line 22840 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
    return -1;
  return 8610; /* avx512bw_umulhrswv32hi3 */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 177:
          return recog_216 (x1, insn, pnum_clobbers);

        case 118:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 1877 "../../gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          *pnum_clobbers = 1;
          return 2552; /* movdi_to_sse */

        case 119:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x2) != E_V32QImode
                  || !memory_operand (operands[1], E_V32QImode)
                  || !(
#line 1985 "../../gcc/config/i386/sse.md"
(TARGET_SSE3) && 
#line 600 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2553; /* avx_lddqu256 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !memory_operand (operands[1], E_V16QImode)
                  || !
#line 1985 "../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2554; /* sse3_lddqu */

            default:
              return -1;
            }

        case 117:
          return recog_211 (x1, insn, pnum_clobbers);

        case 54:
          return recog_214 (x1, insn, pnum_clobbers);

        case 161:
          switch (pattern319 (x2))
            {
            case 0:
              if (!(
#line 3003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2888; /* *rcp14v16sf */

            case 1:
              if (!(
#line 3003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2890; /* *rcp14v8sf */

            case 2:
              if (!(
#line 3003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2892; /* *rcp14v4sf */

            case 3:
              if (!(
#line 3003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2894; /* *rcp14v8df */

            case 4:
              if (!(
#line 3003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2896; /* *rcp14v4df */

            case 5:
              if (!(
#line 3003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2898; /* *rcp14v2df */

            default:
              return -1;
            }

        case 55:
          return recog_213 (x1, insn, pnum_clobbers);

        case 162:
          switch (pattern319 (x2))
            {
            case 0:
              if (!(
#line 3157 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2966; /* *rsqrt14v16sf */

            case 1:
              if (!(
#line 3157 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2968; /* *rsqrt14v8sf */

            case 2:
              if (!(
#line 3157 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2970; /* *rsqrt14v4sf */

            case 3:
              if (!(
#line 3157 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2972; /* *rsqrt14v8df */

            case 4:
              if (!(
#line 3157 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2974; /* *rsqrt14v4df */

            case 5:
              if (!(
#line 3157 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2976; /* *rsqrt14v2df */

            default:
              return -1;
            }

        case 156:
          return recog_209 (x1, insn, pnum_clobbers);

        case 46:
          return recog_206 (x1, insn, pnum_clobbers);

        case 172:
          return recog_210 (x1, insn, pnum_clobbers);

        case 173:
          return recog_212 (x1, insn, pnum_clobbers);

        case 165:
          return recog_208 (x1, insn, pnum_clobbers);

        case 127:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DImode:
              if (!register_operand (operands[0], E_V8DImode)
                  || GET_MODE (x2) != E_V8DImode
                  || !memory_operand (operands[1], E_V8DImode)
                  || !(
#line 23792 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 8715; /* avx512f_movntdqa */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x2) != E_V4DImode
                  || !memory_operand (operands[1], E_V4DImode)
                  || !(
#line 23792 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 8716; /* avx2_movntdqa */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !memory_operand (operands[1], E_V2DImode)
                  || !
#line 23792 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8717; /* sse4_1_movntdqa */

            default:
              return -1;
            }

        case 129:
          if (GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V8HImode)
              || !
#line 24117 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8750; /* sse4_1_phminposuw */

        case 136:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 27004 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9053; /* xop_frczv4sf2 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 27004 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9054; /* xop_frczv2df2 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8SFmode)
                  || !
#line 27004 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9055; /* xop_frczv8sf2 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x2) != E_V4DFmode
                  || !nonimmediate_operand (operands[1], E_V4DFmode)
                  || !
#line 27004 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9056; /* xop_frczv4df2 */

            default:
              return -1;
            }

        case 134:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              operands[1] = x4;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              x6 = XEXP (x4, 1);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1015 (x2, 
E_V16QImode) != 0
                      || !
#line 27067 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 9067; /* xop_maskcmp_uns2v16qi3 */

                case E_V8HImode:
                  if (pattern1015 (x2, 
E_V8HImode) != 0
                      || !
#line 27067 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 9068; /* xop_maskcmp_uns2v8hi3 */

                case E_V4SImode:
                  if (pattern1015 (x2, 
E_V4SImode) != 0
                      || !
#line 27067 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 9069; /* xop_maskcmp_uns2v4si3 */

                case E_V2DImode:
                  if (pattern1015 (x2, 
E_V2DImode) != 0
                      || !
#line 27067 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 9070; /* xop_maskcmp_uns2v2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 141:
          if (GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[0], E_V2DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V2DImode)
              || !
#line 27181 "../../gcc/config/i386/sse.md"
(TARGET_AES))
            return -1;
          return 9083; /* aesimc */

        case 149:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !memory_operand (operands[1], E_V4HImode)
                  || !
#line 29099 "../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 9646; /* *vcvtph2ps_load */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 29109 "../../gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL)
   && (!false || TARGET_AVX10_2_256)))
                return -1;
              return 9648; /* vcvtph2ps256 */

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x2) != E_V16SFmode
                  || !vector_operand (operands[1], E_V16HImode)
                  || !
#line 29122 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 9652; /* *avx512f_vcvtph2ps512 */

            default:
              return -1;
            }

        case 168:
          return recog_215 (x1, insn, pnum_clobbers);

        case 253:
          switch (pattern321 (x2))
            {
            case 0:
              if (!
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10500; /* vcvtph2bf8v16hf */

            case 1:
              if (!(
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31835 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10508; /* vcvtph2bf8v32hf */

            default:
              return -1;
            }

        case 254:
          switch (pattern321 (x2))
            {
            case 0:
              if (!
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10502; /* vcvtph2bf8sv16hf */

            case 1:
              if (!(
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31835 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10510; /* vcvtph2bf8sv32hf */

            default:
              return -1;
            }

        case 255:
          switch (pattern321 (x2))
            {
            case 0:
              if (!
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10504; /* vcvtph2hf8v16hf */

            case 1:
              if (!(
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31835 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10512; /* vcvtph2hf8v32hf */

            default:
              return -1;
            }

        case 256:
          switch (pattern321 (x2))
            {
            case 0:
              if (!
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10506; /* vcvtph2hf8sv16hf */

            case 1:
              if (!(
#line 31914 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31835 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10514; /* vcvtph2hf8sv32hf */

            default:
              return -1;
            }

        case 257:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x2) != E_V32HFmode
                  || !nonimmediate_operand (operands[1], E_V32QImode)
                  || !(
#line 31923 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10516; /* vcvthf82phv32hf */

            case E_V16HFmode:
              if (!register_operand (operands[0], E_V16HFmode)
                  || GET_MODE (x2) != E_V16HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31923 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10518; /* vcvthf82phv16hf */

            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31923 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10520; /* vcvthf82phv8hf */

            default:
              return -1;
            }

        case 263:
          switch (pattern322 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!(
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10729; /* avx10_2_cvtbf162ibsv32bf */

            case 1:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10737; /* avx10_2_cvtbf162ibsv16bf */

            case 2:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10745; /* avx10_2_cvtbf162ibsv8bf */

            default:
              return -1;
            }

        case 264:
          switch (pattern322 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!(
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10731; /* avx10_2_cvtbf162iubsv32bf */

            case 1:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10739; /* avx10_2_cvtbf162iubsv16bf */

            case 2:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10747; /* avx10_2_cvtbf162iubsv8bf */

            default:
              return -1;
            }

        case 269:
          switch (pattern322 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!(
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10733; /* avx10_2_cvttbf162ibsv32bf */

            case 1:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10741; /* avx10_2_cvttbf162ibsv16bf */

            case 2:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10749; /* avx10_2_cvttbf162ibsv8bf */

            default:
              return -1;
            }

        case 270:
          switch (pattern322 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!(
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10735; /* avx10_2_cvttbf162iubsv32bf */

            case 1:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10743; /* avx10_2_cvttbf162iubsv16bf */

            case 2:
              if (!
#line 32496 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10751; /* avx10_2_cvttbf162iubsv8bf */

            default:
              return -1;
            }

        case 265:
          switch (pattern322 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32511 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10753; /* avx10_2_cvtph2ibsv32hf */

            case 1:
              if (!
#line 32511 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10761; /* avx10_2_cvtph2ibsv16hf */

            case 2:
              if (!
#line 32511 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10769; /* avx10_2_cvtph2ibsv8hf */

            default:
              return -1;
            }

        case 266:
          switch (pattern322 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32511 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10757; /* avx10_2_cvtph2iubsv32hf */

            case 1:
              if (!
#line 32511 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10765; /* avx10_2_cvtph2iubsv16hf */

            case 2:
              if (!
#line 32511 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10771; /* avx10_2_cvtph2iubsv8hf */

            default:
              return -1;
            }

        case 271:
          switch (pattern322 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32526 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10773; /* avx10_2_cvttph2ibsv32hf */

            case 1:
              if (!
#line 32526 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10781; /* avx10_2_cvttph2ibsv16hf */

            case 2:
              if (!
#line 32526 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10789; /* avx10_2_cvttph2ibsv8hf */

            default:
              return -1;
            }

        case 272:
          switch (pattern322 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32526 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10777; /* avx10_2_cvttph2iubsv32hf */

            case 1:
              if (!
#line 32526 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10785; /* avx10_2_cvttph2iubsv16hf */

            case 2:
              if (!
#line 32526 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10791; /* avx10_2_cvttph2iubsv8hf */

            default:
              return -1;
            }

        case 267:
          switch (pattern323 (x2))
            {
            case 0:
              if (!(
#line 32541 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10793; /* avx10_2_cvtps2ibsv16sf */

            case 1:
              if (!
#line 32541 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10801; /* avx10_2_cvtps2ibsv8sf */

            case 2:
              if (!
#line 32541 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10809; /* avx10_2_cvtps2ibsv4sf */

            default:
              return -1;
            }

        case 268:
          switch (pattern323 (x2))
            {
            case 0:
              if (!(
#line 32541 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10797; /* avx10_2_cvtps2iubsv16sf */

            case 1:
              if (!
#line 32541 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10805; /* avx10_2_cvtps2iubsv8sf */

            case 2:
              if (!
#line 32541 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10811; /* avx10_2_cvtps2iubsv4sf */

            default:
              return -1;
            }

        case 273:
          switch (pattern323 (x2))
            {
            case 0:
              if (!(
#line 32556 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10813; /* avx10_2_cvttps2ibsv16sf */

            case 1:
              if (!
#line 32556 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10821; /* avx10_2_cvttps2ibsv8sf */

            case 2:
              if (!
#line 32556 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10829; /* avx10_2_cvttps2ibsv4sf */

            default:
              return -1;
            }

        case 274:
          switch (pattern323 (x2))
            {
            case 0:
              if (!(
#line 32556 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10817; /* avx10_2_cvttps2iubsv16sf */

            case 1:
              if (!
#line 32556 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10825; /* avx10_2_cvttps2iubsv8sf */

            case 2:
              if (!
#line 32556 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10831; /* avx10_2_cvttps2iubsv4sf */

            default:
              return -1;
            }

        case 275:
          switch (pattern324 (x2))
            {
            case 0:
              if (!(
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 385 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10833; /* avx10_2_vcvttps2dqsv16sf */

            case 1:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10841; /* avx10_2_vcvttps2dqsv8sf */

            case 2:
              if (!(
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 386 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10853; /* avx10_2_vcvttpd2dqsv8df */

            case 3:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10849; /* avx10_2_vcvttps2dqsv4sf */

            case 4:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10861; /* avx10_2_vcvttpd2dqsv4df */

            case 5:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10869; /* avx10_2_vcvttpd2dqsv2df */

            case 6:
              if (!(
#line 32586 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 450 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10873; /* avx10_2_vcvttpd2qqsv8df */

            case 7:
              if (!(
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 617 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10893; /* avx10_2_vcvttps2qqsv8di */

            case 8:
              if (!
#line 32586 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10881; /* avx10_2_vcvttpd2qqsv4df */

            case 9:
              if (!
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10901; /* avx10_2_vcvttps2qqsv4di */

            case 10:
              if (!
#line 32586 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10889; /* avx10_2_vcvttpd2qqsv2df */

            case 11:
              if (!
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10909; /* avx10_2_vcvttps2qqsv2di */

            default:
              return -1;
            }

        case 276:
          switch (pattern324 (x2))
            {
            case 0:
              if (!(
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 385 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10837; /* avx10_2_vcvttps2udqsv16sf */

            case 1:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10845; /* avx10_2_vcvttps2udqsv8sf */

            case 2:
              if (!(
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 386 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10857; /* avx10_2_vcvttpd2udqsv8df */

            case 3:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10851; /* avx10_2_vcvttps2udqsv4sf */

            case 4:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10865; /* avx10_2_vcvttpd2udqsv4df */

            case 5:
              if (!
#line 32575 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10871; /* avx10_2_vcvttpd2udqsv2df */

            case 6:
              if (!(
#line 32586 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 450 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10877; /* avx10_2_vcvttpd2uqqsv8df */

            case 7:
              if (!(
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 617 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10897; /* avx10_2_vcvttps2uqqsv8di */

            case 8:
              if (!
#line 32586 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10885; /* avx10_2_vcvttpd2uqqsv4df */

            case 9:
              if (!
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10905; /* avx10_2_vcvttps2uqqsv4di */

            case 10:
              if (!
#line 32586 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10891; /* avx10_2_vcvttpd2uqqsv2df */

            case 11:
              if (!
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10911; /* avx10_2_vcvttps2uqqsv2di */

            default:
              return -1;
            }

        case 279:
          return recog_207 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 2:
      return recog_266 (x1, insn, pnum_clobbers);

    case 3:
      return recog_265 (x1, insn, pnum_clobbers);

    case 4:
      return recog_264 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_299 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !nonimmediate_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 14899 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7216; /* vec_dupv2df */
          if (!(
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9285; /* *avx512vl_vec_dup_gprv2df */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27755 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9231; /* *avx512f_broadcastv16sf */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9275; /* *avx512f_vec_dup_gprv16sf */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 28075 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9331; /* *avx512dq_broadcastv16sf_1 */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 27755 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9233; /* *avx512f_broadcastv16si */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9263; /* *avx512f_vec_dup_gprv16si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 28075 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9333; /* *avx512dq_broadcastv16si_1 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 27767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9235; /* *avx512f_broadcastv8df */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9281; /* *avx512f_vec_dup_gprv8df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28086 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9337; /* *avx512dq_broadcastv8df_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 27767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9237; /* *avx512f_broadcastv8di */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9269; /* *avx512f_vec_dup_gprv8di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28086 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9335; /* *avx512dq_broadcastv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x3) != E_V64QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9239; /* *avx512bw_vec_dup_gprv64qi */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9241; /* *avx512vl_vec_dup_gprv16qi */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9296; /* *vec_dupv16qi */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9243; /* *avx512vl_vec_dup_gprv32qi */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9295; /* *vec_dupv32qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !nonimmediate_operand (operands[1], E_HImode)
              || !(
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9245; /* *avx512bw_vec_dup_gprv32hi */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9247; /* *avx512vl_vec_dup_gprv16hi */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9297; /* *vec_dupv16hi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9249; /* *avx512vl_vec_dup_gprv8hi */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9298; /* *vec_dupv8hi */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !(
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9251; /* *avx512bw_vec_dup_gprv32hf */

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x3) != E_V16HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9253; /* *avx512vl_vec_dup_gprv16hf */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9301; /* *vec_dupv16hf */

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9255; /* *avx512fp16_vec_dup_gprv8hf */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9302; /* *vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x3) != E_V32BFmode
              || !nonimmediate_operand (operands[1], E_BFmode)
              || !(
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9257; /* *avx512bw_vec_dup_gprv32bf */

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x3) != E_V16BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9259; /* *avx512vl_vec_dup_gprv16bf */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9303; /* *vec_dupv16bf */

        case E_V8BFmode:
          if (!register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27779 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9261; /* *avx512vl_vec_dup_gprv8bf */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9304; /* *vec_dupv8bf */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9265; /* *avx512vl_vec_dup_gprv8si */
              if (
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 9299; /* *vec_dupv8si */
              if (!
#line 27961 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9305; /* vec_dupv8si */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !
#line 28062 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 9327; /* *avx512vl_broadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9267; /* *avx512vl_vec_dup_gprv4si */
          if (
#line 27838 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 9288; /* *vec_dupv4si */
          if (!
#line 27941 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9300; /* *vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9271; /* *avx512vl_vec_dup_gprv4di */
              if (!
#line 27961 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9307; /* vec_dupv4di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28087 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9339; /* *avx512dq_broadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9273; /* *avx512vl_vec_dup_gprv2di */
          if (!
#line 27866 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 9289; /* *vec_dupv2di */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9277; /* *avx512vl_vec_dup_gprv8sf */
              if (!
#line 27961 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9306; /* vec_dupv8sf */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 28062 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 9329; /* *avx512vl_broadcastv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9279; /* *avx512vl_vec_dup_gprv4sf */
          if (!
#line 27806 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 9287; /* vec_dupv4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode))
                return -1;
              if ((
#line 27791 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9283; /* *avx512vl_vec_dup_gprv4df */
              if (!
#line 27961 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9308; /* vec_dupv4df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28087 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9341; /* *avx512dq_broadcastv4df_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          switch (pattern674 (x3, 
E_V8SFmode))
            {
            case 0:
              if (!(
#line 31635 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 10422; /* vbcstnebf162ps_v8sf */

            case 1:
              if (!(
#line 31646 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 10424; /* vbcstnesh2ps_v8sf */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern674 (x3, 
E_V4SFmode))
            {
            case 0:
              if (!
#line 31635 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 10423; /* vbcstnebf162ps_v4sf */

            case 1:
              if (!
#line 31646 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 10425; /* vbcstnesh2ps_v4sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern29 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17303 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7643; /* *lshrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17317 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 774 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7666; /* lshrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28947 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9598; /* avx512vl_lshrvv16hi */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17303 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7647; /* *lshrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17317 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7668; /* lshrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28947 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9594; /* avx512vl_lshrvv8hi */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17303 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7651; /* *lshrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17317 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 775 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7670; /* lshrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28936 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9574; /* avx2_lshrvv8si */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17303 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7655; /* *lshrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17317 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7672; /* lshrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28936 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9578; /* avx2_lshrvv4si */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17303 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7659; /* *lshrv4di3 */
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17317 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 776 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7674; /* lshrv4di3 */
      if (!nonimmediate_operand (operands[2], E_V4DImode)
          || !
#line 28936 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9586; /* avx2_lshrvv4di */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17303 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7663; /* *lshrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17317 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7676; /* lshrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !
#line 28936 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9590; /* avx2_lshrvv2di */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7683; /* lshrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28947 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9602; /* avx512bw_lshrvv32hi */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7687; /* lshrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28936 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 803 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9570; /* avx512f_lshrvv16si */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7691; /* lshrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28936 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 804 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9582; /* avx512f_lshrvv8di */

    case 9:
      if (register_operand (operands[1], E_V1TImode)
          && const_0_to_255_not_mul_8_operand (operands[2], E_SImode)
          && 
#line 17495 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return 7694; /* *lshrv1ti3_internal */
      if (!const_0_to_255_mul_8_operand (operands[2], E_SImode))
        return -1;
      if (nonimmediate_operand (operands[1], E_V1TImode)
          && (
#line 17610 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7703; /* avx512bw_lshrv1ti3 */
      if (!register_operand (operands[1], E_V1TImode)
          || !
#line 17625 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7707; /* sse2_lshrv1ti3 */

    case 10:
      if (!(
#line 17610 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7699; /* avx512bw_lshrv4ti3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V2TImode)
          && (
#line 17610 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7701; /* avx512bw_lshrv2ti3 */
      if (!register_operand (operands[1], E_V2TImode)
          || !(
#line 17625 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 732 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7705; /* avx2_lshrv2ti3 */

    default:
      return -1;
    }
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (!
#line 24130 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8753; /* avx2_zero_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24184 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8761; /* avx512bw_zero_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24254 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8773; /* *sse4_1_zero_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24379 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8785; /* *avx512f_zero_extendv16qiv16si2 */

    case 4:
      if (!
#line 24522 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8813; /* avx512f_zero_extendv16hiv16si2 */

    case 5:
      if (!
#line 24411 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8793; /* *avx2_zero_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24575 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8821; /* avx2_zero_extendv8hiv8si2 */

    case 7:
      if (!
#line 24472 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8805; /* *sse4_1_zero_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24645 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8833; /* *sse4_1_zero_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24776 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8849; /* *avx512f_zero_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24947 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8880; /* avx512f_zero_extendv8hiv8di2 */

    case 11:
      if (!
#line 25084 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8908; /* avx512f_zero_extendv8siv8di2 */

    case 12:
      if (!
#line 24834 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8861; /* *avx2_zero_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24977 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8888; /* *avx2_zero_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25135 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8914; /* avx2_zero_extendv4siv4di2 */

    case 15:
      if (!
#line 24896 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8873; /* *sse4_1_zero_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25035 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8900; /* *sse4_1_zero_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25201 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8924; /* *sse4_1_zero_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern539 (x2))
        {
        case 0:
          if (
#line 24242 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8769; /* sse4_1_zero_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24400 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8789; /* avx2_zero_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8845; /* avx512f_zero_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24460 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8801; /* sse4_1_zero_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24633 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8829; /* sse4_1_zero_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24823 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8857; /* avx2_zero_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24966 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8884; /* avx2_zero_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24884 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8869; /* sse4_1_zero_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25023 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8896; /* sse4_1_zero_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25189 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8920; /* sse4_1_zero_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_CONCAT:
          switch (pattern677 (x2))
            {
            case 0:
              if (!
#line 24278 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8777; /* *sse4_1_zero_extendv8qiv8hi2_2 */

            case 1:
              if (!
#line 24430 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8797; /* *avx2_zero_extendv8qiv8si2_2 */

            case 2:
              if (!
#line 24794 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 8853; /* *avx512f_zero_extendv8qiv8di2_2 */

            case 3:
              if (!
#line 24664 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8837; /* *sse4_1_zero_extendv4hiv4si2_2 */

            case 4:
              if (!
#line 24994 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8892; /* *avx2_zero_extendv4hiv4di2_2 */

            case 5:
              if (!
#line 25219 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8928; /* *sse4_1_zero_extendv2siv2di2_2 */

            default:
              return -1;
            }

        case VEC_MERGE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_DUPLICATE)
            return -1;
          if (GET_MODE (x6) == E_V4SImode)
            {
              switch (pattern1030 (x2))
                {
                case 0:
                  if (
#line 24495 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                    return 8809; /* *sse4_1_zero_extendv4qiv4si2_2 */
                  break;

                case 1:
                  if (
#line 24855 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                    return 8865; /* *avx2_zero_extendv4qiv4di2_2 */
                  break;

                case 2:
                  if (
#line 25057 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                    return 8904; /* *sse4_1_zero_extendv2hiv2di2_2 */
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern1031 (x2))
            {
            case 0:
              if (!
#line 24931 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8875; /* *sse4_1_zero_extendv2qiv2di2_2 */

            case 1:
              if (!
#line 24931 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8876; /* *sse4_1_zero_extendv2qiv2di2_2 */

            case 2:
              if (!
#line 24931 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8877; /* *sse4_1_zero_extendv2qiv2di2_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern26 (x1))
    {
    case 0:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2988; /* *smaxv32hf3 */

    case 1:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2996; /* *smaxv16hf3 */

    case 2:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3004; /* *smaxv8hf3 */

    case 3:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3008; /* *smaxv16sf3 */

    case 4:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3016; /* *smaxv8sf3 */

    case 5:
      if (!
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 3024; /* *smaxv4sf3 */

    case 6:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3028; /* *smaxv8df3 */

    case 7:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3036; /* *smaxv4df3 */

    case 8:
      if (!(
#line 3305 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3044; /* *smaxv2df3 */

    case 9:
      if (
#line 17680 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7756; /* *avx2_smaxv32qi3 */
      if (!(
#line 17732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7832; /* *avx512bw_smaxv32qi3 */

    case 10:
      if (
#line 17680 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7760; /* *avx2_smaxv16hi3 */
      if (!(
#line 17732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7848; /* *avx512bw_smaxv16hi3 */

    case 11:
      if (
#line 17680 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7764; /* *avx2_smaxv8si3 */
      if (!(
#line 17721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7776; /* *avx512f_smaxv8si3 */

    case 12:
      if (!(
#line 17721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7768; /* *avx512f_smaxv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7784; /* *avx512f_smaxv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17824 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7868; /* *sse4_1_smaxv4si3 */

    case 14:
      if (!(
#line 17721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7792; /* *avx512f_smaxv8di3 */

    case 15:
      if (!(
#line 17721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7800; /* *avx512f_smaxv4di3 */

    case 16:
      if (!(
#line 17721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7808; /* *avx512f_smaxv2di3 */

    case 17:
      if (!(
#line 17732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7816; /* *avx512bw_smaxv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7824; /* *avx512bw_smaxv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17824 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7864; /* *sse4_1_smaxv16qi3 */

    case 19:
      if (!(
#line 17732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7840; /* *avx512bw_smaxv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7856; /* *avx512bw_smaxv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17843 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7872; /* *smaxv8hi3 */

    case 21:
      if (!(
#line 32113 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10591; /* avx10_2_smaxbf16_v32bf */

    case 22:
      if (!
#line 32113 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10595; /* avx10_2_smaxbf16_v16bf */

    case 23:
      if (!
#line 32113 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10599; /* avx10_2_smaxbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 8125 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4734; /* avx512fp16_vcvtpd2ph_v8df */

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode)
              || !(
#line 8125 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4742; /* avx512fp16_vcvtps2ph_v8sf */

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 8125 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4738; /* avx512fp16_vcvtps2ph_v16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !
#line 10099 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 5172; /* *avx512f_cvtpd2ps512 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !
#line 10109 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!false || TARGET_AVX10_2_256)))
        return -1;
      return 5176; /* avx_cvtpd2ps256 */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (
#line 31142 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
        return 10343; /* vcvtneps2bf16_v8sf */
      if (!(
#line 31180 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31108 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10346; /* avx512f_cvtneps2bf16_v8sf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x3) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 31180 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31108 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10344; /* avx512f_cvtneps2bf16_v16sf */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern32 (x1))
    {
    case 0:
      if (!
#line 17566 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return -1;
      return 7696; /* *rotlv1ti3_internal */

    case 1:
      if (!(
#line 17662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7732; /* avx512f_rolv16si */

    case 2:
      if (!(
#line 17662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7736; /* avx512vl_rolv8si */

    case 3:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7740; /* avx512vl_rolv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26611 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9032; /* xop_rotlv4si3 */

    case 4:
      if (!(
#line 17662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7744; /* avx512f_rolv8di */

    case 5:
      if (!(
#line 17662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7748; /* avx512vl_rolv4di */

    case 6:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17662 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7752; /* avx512vl_rolv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26611 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9033; /* xop_rotlv2di3 */

    case 7:
      if (!
#line 26611 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9030; /* xop_rotlv16qi3 */

    case 8:
      if (!
#line 26611 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9031; /* xop_rotlv8hi3 */

    case 9:
      if (!(
#line 17652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7708; /* avx512f_rolvv16si */

    case 10:
      if (!(
#line 17652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7712; /* avx512vl_rolvv8si */

    case 11:
      if (!(
#line 17652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7716; /* avx512vl_rolvv4si */

    case 12:
      if (!(
#line 17652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7720; /* avx512f_rolvv8di */

    case 13:
      if (!(
#line 17652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7724; /* avx512vl_rolvv4di */

    case 14:
      if (!(
#line 17652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7728; /* avx512vl_rolvv2di */

    default:
      return -1;
    }
}

 int
recog_363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 39:
      if (GET_MODE (x3) != E_CCGZmode)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != LTU)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCGZmode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern1668 (x4, 
E_SImode) != 0
              || !
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 521; /* subsi3_carry_ccgz */

        case E_DImode:
          if (pattern1668 (x4, 
E_DImode) != 0
              || !
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 522; /* subdi3_carry_ccgz */

        default:
          return -1;
        }

    case 22:
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 7
          || pattern548 (x1) != 0)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1556 (x3, 
E_SImode) != 0
              || !(
#line 23200 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
            return -1;
          return 1663; /* *tls_dynamic_gnu2_call_64_si */

        case E_DImode:
          if (pattern1556 (x3, 
E_DImode) != 0
              || !(
#line 23200 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
            return -1;
          return 1664; /* *tls_dynamic_gnu2_call_64_di */

        default:
          return -1;
        }

    case 52:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (pattern934 (x1) != 0
          || !
#line 23163 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 8628; /* *ssse3_pshufbv8qi3 */

    case 132:
      if (pattern551 (x1, 
132, 
3) != 0)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      if (!nonimmediate_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      operands[3] = x4;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x8, 1);
      x13 = XVECEXP (x12, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XVECEXP (x12, 0, 2);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (pattern1764 (x3))
        {
        case 0:
          if (!
#line 26039 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8980; /* sse4_2_pcmpistri */

        case 1:
          if (!
#line 26063 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8981; /* sse4_2_pcmpistrm */

        default:
          return -1;
        }

    case 153:
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 154)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x16 = XVECEXP (x5, 0, 2);
      if (!const1248_operand (x16, E_SImode))
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x10 = XVECEXP (x3, 0, 1);
          operands[7] = x10;
          operands[6] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[4] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[3] = x18;
          operands[5] = x16;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (!register_operand (operands[0], E_V16SImode)
                  || GET_MODE (x3) != E_V16SImode
                  || !vsib_mem_operator (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode))
                    return -1;
                  switch (pattern1816 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9741; /* *avx512f_gathersiv16si */

                    case 1:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9753; /* *avx512f_gathersiv16si */

                    default:
                      return -1;
                    }

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1816 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9789; /* *avx512f_gatherdiv16si */

                    case 1:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9801; /* *avx512f_gatherdiv16si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x3) != E_V16SFmode
                  || !vsib_mem_operator (operands[6], E_SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode))
                    return -1;
                  switch (pattern1816 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9742; /* *avx512f_gathersiv16sf */

                    case 1:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9754; /* *avx512f_gathersiv16sf */

                    default:
                      return -1;
                    }

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1816 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9790; /* *avx512f_gatherdiv16sf */

                    case 1:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9802; /* *avx512f_gatherdiv16sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1737 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9743; /* *avx512f_gathersiv8di */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9791; /* *avx512f_gatherdiv8di */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9755; /* *avx512f_gathersiv8di */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9803; /* *avx512f_gatherdiv8di */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1737 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9744; /* *avx512f_gathersiv8df */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9792; /* *avx512f_gatherdiv8df */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9756; /* *avx512f_gathersiv8df */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9804; /* *avx512f_gatherdiv8df */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (pattern1738 (x3, 
E_SImode, 
E_V8SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1825 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9745; /* *avx512f_gathersiv8si */

                    case 1:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9757; /* *avx512f_gathersiv8si */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode))
                    return -1;
                  switch (pattern1825 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9793; /* *avx512f_gatherdiv8si */

                    case 1:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9805; /* *avx512f_gatherdiv8si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (pattern1738 (x3, 
E_SFmode, 
E_V8SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1825 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9746; /* *avx512f_gathersiv8sf */

                    case 1:
                      if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9758; /* *avx512f_gathersiv8sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode))
                    return -1;
                  switch (pattern1825 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9794; /* *avx512f_gatherdiv8sf */

                    case 1:
                      if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9806; /* *avx512f_gatherdiv8sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1740 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9747; /* *avx512f_gathersiv4di */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9795; /* *avx512f_gatherdiv4di */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9759; /* *avx512f_gathersiv4di */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9807; /* *avx512f_gatherdiv4di */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1740 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9748; /* *avx512f_gathersiv4df */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9796; /* *avx512f_gatherdiv4df */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9760; /* *avx512f_gathersiv4df */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9808; /* *avx512f_gatherdiv4df */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1742 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9749; /* *avx512f_gathersiv4si */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9797; /* *avx512f_gatherdiv4si */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9761; /* *avx512f_gathersiv4si */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9809; /* *avx512f_gatherdiv4si */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1742 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9750; /* *avx512f_gathersiv4sf */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9798; /* *avx512f_gatherdiv4sf */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9762; /* *avx512f_gathersiv4sf */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9810; /* *avx512f_gatherdiv4sf */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1742 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9751; /* *avx512f_gathersiv2di */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9799; /* *avx512f_gatherdiv2di */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9763; /* *avx512f_gathersiv2di */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9811; /* *avx512f_gatherdiv2di */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1742 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9752; /* *avx512f_gathersiv2df */

                case 1:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9800; /* *avx512f_gatherdiv2df */

                case 2:
                  if (!(
#line 29480 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9764; /* *avx512f_gathersiv2df */

                case 3:
                  if (!(
#line 29542 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9812; /* *avx512f_gatherdiv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PC:
          x10 = XVECEXP (x3, 0, 1);
          operands[6] = x10;
          operands[5] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[3] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[2] = x18;
          operands[4] = x16;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              switch (pattern1711 (x3, 
E_SImode, 
E_V16SImode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9765; /* *avx512f_gathersiv16si_2 */

                case 1:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9777; /* *avx512f_gathersiv16si_2 */

                case 2:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9813; /* *avx512f_gatherdiv16si_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9825; /* *avx512f_gatherdiv16si_2 */

                default:
                  return -1;
                }

            case E_V16SFmode:
              switch (pattern1711 (x3, 
E_SFmode, 
E_V16SFmode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9766; /* *avx512f_gathersiv16sf_2 */

                case 1:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9778; /* *avx512f_gathersiv16sf_2 */

                case 2:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9814; /* *avx512f_gatherdiv16sf_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9826; /* *avx512f_gatherdiv16sf_2 */

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1713 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9767; /* *avx512f_gathersiv8di_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9815; /* *avx512f_gatherdiv8di_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9779; /* *avx512f_gathersiv8di_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9827; /* *avx512f_gatherdiv8di_2 */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1713 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9768; /* *avx512f_gathersiv8df_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9816; /* *avx512f_gatherdiv8df_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9780; /* *avx512f_gathersiv8df_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9828; /* *avx512f_gatherdiv8df_2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern1715 (x3, 
E_SImode, 
E_V8SImode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9769; /* *avx512f_gathersiv8si_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9817; /* *avx512f_gatherdiv8si_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9781; /* *avx512f_gathersiv8si_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9829; /* *avx512f_gatherdiv8si_2 */

                default:
                  return -1;
                }

            case E_V8SFmode:
              switch (pattern1715 (x3, 
E_SFmode, 
E_V8SFmode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9770; /* *avx512f_gathersiv8sf_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9818; /* *avx512f_gatherdiv8sf_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9782; /* *avx512f_gathersiv8sf_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9830; /* *avx512f_gatherdiv8sf_2 */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1717 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9771; /* *avx512f_gathersiv4di_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9819; /* *avx512f_gatherdiv4di_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9783; /* *avx512f_gathersiv4di_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9831; /* *avx512f_gatherdiv4di_2 */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1717 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9772; /* *avx512f_gathersiv4df_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9820; /* *avx512f_gatherdiv4df_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9784; /* *avx512f_gathersiv4df_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9832; /* *avx512f_gatherdiv4df_2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1719 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9773; /* *avx512f_gathersiv4si_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9821; /* *avx512f_gatherdiv4si_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9785; /* *avx512f_gathersiv4si_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9833; /* *avx512f_gatherdiv4si_2 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1719 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9774; /* *avx512f_gathersiv4sf_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9822; /* *avx512f_gatherdiv4sf_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9786; /* *avx512f_gathersiv4sf_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9834; /* *avx512f_gatherdiv4sf_2 */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1719 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9775; /* *avx512f_gathersiv2di_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9823; /* *avx512f_gatherdiv2di_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9787; /* *avx512f_gathersiv2di_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9835; /* *avx512f_gatherdiv2di_2 */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1719 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9776; /* *avx512f_gathersiv2df_2 */

                case 1:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9824; /* *avx512f_gatherdiv2df_2 */

                case 2:
                  if (!(
#line 29501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9788; /* *avx512f_gathersiv2df_2 */

                case 3:
                  if (!(
#line 29563 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9836; /* *avx512f_gatherdiv2df_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern199 (x1))
        {
        case 0:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          switch (pattern699 (x1))
            {
            case 0:
              if ((
#line 15203 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1052; /* *ashldi3_doubleword_mask */
              break;

            case 1:
              if ((
#line 15203 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1053; /* *ashlti3_doubleword_mask */
              break;

            case 2:
              if ((
#line 2267 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return 2595; /* kashiftqi */
              break;

            case 3:
              if (
#line 2267 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return 2597; /* kashifthi */
              break;

            case 4:
              if ((
#line 2267 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 2599; /* kashiftsi */
              break;

            case 5:
              if ((
#line 2267 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 2601; /* kashiftdi */
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (pattern700 (x1))
            {
            case 0:
              operands[0] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (GET_MODE (x3) == E_DImode)
                    {
                      if (register_operand (operands[0], E_DImode)
                          && reg_or_pm1_operand (operands[1], E_DImode)
                          && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                        return 1056; /* ashldi3_doubleword */
                      if (nonimmediate_operand (operands[0], E_DImode)
                          && nonimmediate_operand (operands[1], E_DImode)
                          && (
#line 15909 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1091; /* *ashldi3_1 */
                    }
                  break;

                case E_TImode:
                  if (register_operand (operands[0], E_TImode)
                      && GET_MODE (x3) == E_TImode
                      && reg_or_pm1_operand (operands[1], E_TImode)
                      && 
#line 1196 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 1057; /* ashlti3_doubleword */
                  break;

                case E_SImode:
                  if (nonimmediate_operand (operands[0], E_SImode)
                      && GET_MODE (x3) == E_SImode
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 15909 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)
   && true))
                    return 1089; /* *ashlsi3_1 */
                  break;

                case E_HImode:
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && GET_MODE (x3) == E_HImode
                      && nonimmediate_operand (operands[1], E_HImode)
                      && 
#line 16095 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)
   && true))
                    return 1105; /* *ashlhi3_1 */
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[0], E_QImode)
                      && GET_MODE (x3) == E_QImode
                      && nonimmediate_operand (operands[1], E_QImode)
                      && 
#line 16154 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)
   && true))
                    return 1107; /* *ashlqi3_1 */
                  break;

                case E_V2QImode:
                  if (register_operand (operands[0], E_V2QImode)
                      && GET_MODE (x3) == E_V2QImode
                      && register_operand (operands[1], E_V2QImode)
                      && 
#line 4007 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                    return 2208; /* ashlv2qi3 */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              switch (pattern372 (x3))
                {
                case 0:
                  if (
#line 16233 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 1108; /* *ashlqi3_1_slp */
                  break;

                case 1:
                  if (
#line 16233 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 1109; /* *ashlhi3_1_slp */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x6) != SUBREG
              || maybe_ne (SUBREG_BYTE (x6), 0)
              || GET_MODE (x6) != E_QImode)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern405 (x8) != 0)
            return -1;
          switch (pattern1434 (x2))
            {
            case 0:
              if (!
#line 17840 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return -1;
              return 1244; /* *ashlsi3_mask */

            case 1:
              if (!(
#line 17840 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1247; /* *ashldi3_mask */

            case 2:
              if (!
#line 17888 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              return 1256; /* *ashlsi3_add */

            case 3:
              if (!(
#line 17888 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1259; /* *ashldi3_add */

            case 4:
              if (!
#line 17934 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              return 1268; /* *ashlsi3_sub */

            case 5:
              if (!(
#line 17934 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1271; /* *ashldi3_sub */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 15264 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 1054; /* *ashldi3_doubleword_mask_1 */
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17865 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1253; /* *ashldi3_mask_1 */

        case 2:
          if (!(
#line 15264 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1055; /* *ashlti3_doubleword_mask_1 */

        case 3:
          if (!
#line 17865 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          return 1250; /* *ashlsi3_mask_1 */

        case 4:
          if (!
#line 17912 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1262; /* *ashlsi3_add_1 */

        case 5:
          if (!(
#line 17912 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1265; /* *ashldi3_add_1 */

        case 6:
          if (!
#line 17964 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1274; /* *ashlsi3_sub_1 */

        case 7:
          if (!(
#line 17964 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1277; /* *ashldi3_sub_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern378 (x1))
        {
        case 0:
          if (!(
#line 15365 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 1058; /* *ashldi3_doubleword_highpart */

        case 1:
          if (!(
#line 15365 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 8 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 8 * BITS_PER_UNIT * 2) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1060; /* *ashlti3_doubleword_highpart */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern378 (x1))
        {
        case 0:
          if (!(
#line 15365 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 1059; /* *ashldi3_doubleword_highpart */

        case 1:
          if (!(
#line 15365 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 8 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 8 * BITS_PER_UNIT * 2) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1061; /* *ashlti3_doubleword_highpart */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 37)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !(
#line 20172 "../../gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return -1;
          return 1470; /* *sibcall_memory */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !(
#line 20172 "../../gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return -1;
          return 1471; /* *sibcall_memory */

        default:
          return -1;
        }

    case SET:
      x6 = XEXP (x4, 1);
      if (pattern819 (x6) != 0)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 7
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      if (call_insn_operand (operands[0], E_SImode)
          && 
#line 20223 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && !SIBLING_CALL_P (insn)))
        return 1472; /* *call_pop */
      if (!sibcall_insn_operand (operands[0], E_SImode)
          || !
#line 20233 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (insn)))
        return -1;
      return 1473; /* *sibcall_pop */

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      if (XINT (x5, 1) != 10
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 1);
      if (pattern811 (x7, 
E_DImode, 
10, 
1, 
UNSPEC_VOLATILE) != 0
          || pattern1170 (x1, 
E_SImode, 
10) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 28972 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 1894; /* rdtscp_rex64 */

    case 5:
      if (XINT (x5, 1) != 109)
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC_VOLATILE
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 109
          || pattern1170 (x1, 
E_CCZmode, 
109) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCZmode)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 2);
      operands[3] = x12;
      x13 = XVECEXP (x5, 0, 3);
      operands[4] = x13;
      x14 = XVECEXP (x5, 0, 4);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern1828 (x1, 
E_DImode, 
E_SImode) != 0
              || !(
#line 486 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG8B) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 11021; /* atomic_compare_and_swapdi_doubleword */

        case E_TImode:
          if (pattern1828 (x1, 
E_TImode, 
E_DImode) != 0
              || !(
#line 486 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG16B) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 11022; /* atomic_compare_and_swapti_doubleword */

        default:
          return -1;
        }

    case 4:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC_VOLATILE
          || XVECLEN (x7, 0) != 1)
        return -1;
      x15 = XVECEXP (x7, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 2);
      operands[3] = x12;
      x13 = XVECEXP (x5, 0, 3);
      operands[4] = x13;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 109:
          if (XINT (x7, 1) != 109)
            return -1;
          x16 = XEXP (x9, 1);
          if (pattern1169 (x16, 
E_CCZmode, 
109) != 0
              || !const_int_operand (operands[4], E_SImode)
              || GET_MODE (x10) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1818 (x1, 
E_QImode) != 0
                  || !
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 11023; /* atomic_compare_and_swapqi_1 */

            case E_HImode:
              if (pattern1818 (x1, 
E_HImode) != 0
                  || !
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 11024; /* atomic_compare_and_swaphi_1 */

            case E_SImode:
              if (pattern1818 (x1, 
E_SImode) != 0
                  || !
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 11025; /* atomic_compare_and_swapsi_1 */

            case E_DImode:
              if (pattern1818 (x1, 
E_DImode) != 0
                  || !(
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 11026; /* atomic_compare_and_swapdi_1 */

            default:
              return -1;
            }

        case 112:
          if (XINT (x7, 1) != 112)
            return -1;
          x16 = XEXP (x9, 1);
          if (GET_CODE (x16) != COMPARE
              || GET_MODE (x16) != E_CCmode
              || !const_0_to_15_operand (operands[4], E_SImode)
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XEXP (x16, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1818 (x1, 
E_SImode) != 0
                  || !
#line 1119 "../../gcc/config/i386/sync.md"
(TARGET_CMPCCXADD && TARGET_64BIT))
                return -1;
              return 11096; /* cmpccxadd_si */

            case E_DImode:
              if (pattern1818 (x1, 
E_DImode) != 0
                  || !
#line 1119 "../../gcc/config/i386/sync.md"
(TARGET_CMPCCXADD && TARGET_64BIT))
                return -1;
              return 11097; /* cmpccxadd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x5, 1) != 110)
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (pattern951 (x9, 
E_CCmode, 
17) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x7, 1);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      if (!rtx_equal_p (x20, operands[1]))
        return -1;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1566 (x1, 
E_QImode) != 0
              || !
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 11027; /* atomic_fetch_addqi */

        case E_HImode:
          if (pattern1566 (x1, 
E_HImode) != 0
              || !
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 11028; /* atomic_fetch_addhi */

        case E_SImode:
          if (pattern1566 (x1, 
E_SImode) != 0
              || !
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 11029; /* atomic_fetch_addsi */

        case E_DImode:
          if (pattern1566 (x1, 
E_DImode) != 0
              || !(
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 11030; /* atomic_fetch_adddi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 97)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x1;
      if (!vzeroall_operation (operands[0], E_VOIDmode)
          || !
#line 27244 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9086; /* *avx_vzeroall */

    case USE:
      operands[0] = x1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (save_multiple (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (symbol_operand (operands[1], E_SImode)
                  && (
#line 30306 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return 10142; /* *save_multiplesi */
              break;

            case E_DImode:
              if (symbol_operand (operands[1], E_DImode)
                  && (
#line 30306 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return 10143; /* *save_multipledi */
              break;

            default:
              break;
            }
        }
      if (!restore_multiple (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!symbol_operand (operands[1], E_SImode)
              || !(
#line 30313 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 10144; /* *restore_multiplesi */

        case E_DImode:
          if (!symbol_operand (operands[1], E_DImode)
              || !(
#line 30313 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 10145; /* *restore_multipledi */

        default:
          return -1;
        }

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          if (pattern392 (x5, 
107) != 0)
            return -1;
          operands[2] = x1;
          if (!encodekey128_operation (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 31282 "../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 10358; /* *encodekey128u32 */

        case 3:
          if (pattern392 (x5, 
108) != 0)
            return -1;
          x7 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          operands[2] = x1;
          if (!encodekey256_operation (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 31340 "../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 10359; /* *encodekey256u32 */

        case 1:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 17
              || GET_MODE (x4) != E_CCZmode)
            return -1;
          operands[1] = x1;
          if (!aeswidekl_operation (operands[1], E_VOIDmode)
              || GET_MODE (x5) != E_CCZmode)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          switch (XINT (x5, 1))
            {
            case 103:
              if (!
#line 31423 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10364; /* *aesdecwide128klu8 */

            case 105:
              if (!
#line 31423 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10365; /* *aesdecwide256klu8 */

            case 104:
              if (!
#line 31423 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10366; /* *aesencwide128klu8 */

            case 106:
              if (!
#line 31423 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10367; /* *aesencwide256klu8 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!push_operand (operands[0], E_DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DFmode
          || !fp_register_operand (operands[1], E_SFmode))
        return NULL;
      if ((
#line 5258 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
        return gen_split_64 (insn, operands);
      if (!(
#line 5258 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_65 (insn, operands);

    case E_XFmode:
      if (!push_operand (operands[0], E_XFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_XFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!fp_register_operand (operands[1], E_SFmode))
            return NULL;
          if ((
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_66 (insn, operands);
          if (!(
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_67 (insn, operands);

        case E_DFmode:
          if (!fp_register_operand (operands[1], E_DFmode))
            return NULL;
          if ((
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_68 (insn, operands);
          if (!(
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_69 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (pattern44 (x1, 
E_CCZmode) != 0)
        return NULL;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (pattern842 ())
        {
        case 0:
          if (!((
#line 1682 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 1684 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!((
#line 1682 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1684 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_2 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x3) != E_QImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != GEU
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return NULL;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LTU
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern44 (x1, 
E_CCCmode) != 0)
        return NULL;
      switch (GET_MODE (x6))
        {
        case E_CCmode:
          if (GET_MODE (x8) != E_CCmode
              || !(
#line 9873 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9875 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_193 (insn, operands);

        case E_CCCmode:
          if (GET_MODE (x8) != E_CCCmode
              || !(
#line 9873 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9875 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_194 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG)
        return NULL;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x5;
          if (register_operand (operands[0], E_TImode)
              && REGNO (x10) == 17
              && GET_MODE (x10) == E_CCZmode
              && GET_MODE (x2) == E_CCZmode
              && GET_MODE (x3) == E_TImode)
            {
              x11 = XEXP (x3, 1);
              operands[1] = x11;
              if (general_operand (operands[1], E_TImode)
                  && (
#line 12190 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 12193 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_271 (insn, operands);
            }
          operands[2] = x5;
          operands[0] = x10;
          if (!flags_reg_operand (operands[0], E_VOIDmode))
            return NULL;
          operands[1] = x2;
          if (!compare_operator (operands[1], E_VOIDmode))
            return NULL;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return NULL;
          if (QIreg_operand (operands[2], E_VOIDmode)
              && 
#line 12361 "../../gcc/config/i386/i386.md"
(reload_completed
    && GET_MODE (operands[2]) != QImode
    && ((ix86_match_ccmode (insn, CCZmode)
    	 && !(INTVAL (operands[3]) & ~(255 << 8)))
	|| (ix86_match_ccmode (insn, CCNOmode)
	    && !(INTVAL (operands[3]) & ~(127 << 8))))))
            return gen_split_281 (insn, operands);
          if (!nonimmediate_operand (operands[2], E_VOIDmode)
              || !
#line 12387 "../../gcc/config/i386/i386.md"
(reload_completed
    && GET_MODE (operands[2]) != QImode
    && (!REG_P (operands[2]) || ANY_QI_REG_P (operands[2]))
    && ((ix86_match_ccmode (insn, CCZmode)
	 && !(INTVAL (operands[3]) & ~255))
	|| (ix86_match_ccmode (insn, CCNOmode)
	    && !(INTVAL (operands[3]) & ~127)))))
            return NULL;
          return gen_split_282 (insn, operands);

        case NOT:
          if (REGNO (x10) != 17
              || GET_MODE (x10) != E_CCZmode
              || GET_MODE (x2) != E_CCZmode)
            return NULL;
          switch (pattern843 (x3))
            {
            case 0:
              if (!(
#line 12320 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 12323 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_275 (insn, operands);

            case 1:
              if (!(
#line 12320 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 12323 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_276 (insn, operands);

            case 2:
              if (!(
#line 12320 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 12323 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_277 (insn, operands);

            case 3:
              if (register_operand (operands[0], E_DImode)
                  && x86_64_szext_nonmemory_operand (operands[1], E_DImode)
                  && ((
#line 12320 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12323 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_278 (insn, operands);
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 12338 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 12340 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_279 (insn, operands);

            case 4:
              if (!((
#line 12338 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1196 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12340 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_280 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern46 (x1))
        {
        case 0:
          if (!(
#line 12212 "../../gcc/config/i386/i386.md"
(/* Ensure that resulting mask is zero or sign extended operand.  */
   INTVAL (operands[4]) >= 0
   && ((INTVAL (operands[3]) > 0
	&& INTVAL (operands[3]) + INTVAL (operands[4]) <= 32)
       || (HImode == DImode
	   && INTVAL (operands[3]) > 32
	   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
   && ix86_match_ccmode (insn,
			 /* If zero_extract mode precision is the same
			    as len, the SF of the zero_extract
			    comparison will be the most significant
			    extracted bit, but this could be matched
			    after splitting only for pos 0 len all bits
			    trivial extractions.  Require CCZmode.  */
			 (GET_MODE_PRECISION (HImode)
			  == INTVAL (operands[3]))
			 /* Otherwise, require CCZmode if we'd use a mask
			    with the most significant bit set and can't
			    widen it to wider mode.  *testdi_1 also
			    requires CCZmode if the mask has bit
			    31 set and all bits above it clear.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     >= 32)
			 /* We can't widen also if val is not a REG.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     == GET_MODE_PRECISION (GET_MODE (operands[2]))
			     && !register_operand (operands[2],
						   GET_MODE (operands[2])))
			 /* And we shouldn't widen if
			    TARGET_PARTIAL_REG_STALL.  */
			 || (TARGET_PARTIAL_REG_STALL
			     && (INTVAL (operands[3]) + INTVAL (operands[4])
				 >= (paradoxical_subreg_p (operands[2])
				     && (GET_MODE_CLASS
					  (GET_MODE (SUBREG_REG (operands[2])))
					 == MODE_INT)
				     ? GET_MODE_PRECISION
					 (GET_MODE (SUBREG_REG (operands[2])))
				     : GET_MODE_PRECISION
					 (GET_MODE (operands[2])))))
			 ? CCZmode : CCNOmode)) && 
#line 12254 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 1:
          if (!(
#line 12212 "../../gcc/config/i386/i386.md"
(/* Ensure that resulting mask is zero or sign extended operand.  */
   INTVAL (operands[4]) >= 0
   && ((INTVAL (operands[3]) > 0
	&& INTVAL (operands[3]) + INTVAL (operands[4]) <= 32)
       || (SImode == DImode
	   && INTVAL (operands[3]) > 32
	   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
   && ix86_match_ccmode (insn,
			 /* If zero_extract mode precision is the same
			    as len, the SF of the zero_extract
			    comparison will be the most significant
			    extracted bit, but this could be matched
			    after splitting only for pos 0 len all bits
			    trivial extractions.  Require CCZmode.  */
			 (GET_MODE_PRECISION (SImode)
			  == INTVAL (operands[3]))
			 /* Otherwise, require CCZmode if we'd use a mask
			    with the most significant bit set and can't
			    widen it to wider mode.  *testdi_1 also
			    requires CCZmode if the mask has bit
			    31 set and all bits above it clear.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     >= 32)
			 /* We can't widen also if val is not a REG.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     == GET_MODE_PRECISION (GET_MODE (operands[2]))
			     && !register_operand (operands[2],
						   GET_MODE (operands[2])))
			 /* And we shouldn't widen if
			    TARGET_PARTIAL_REG_STALL.  */
			 || (TARGET_PARTIAL_REG_STALL
			     && (INTVAL (operands[3]) + INTVAL (operands[4])
				 >= (paradoxical_subreg_p (operands[2])
				     && (GET_MODE_CLASS
					  (GET_MODE (SUBREG_REG (operands[2])))
					 == MODE_INT)
				     ? GET_MODE_PRECISION
					 (GET_MODE (SUBREG_REG (operands[2])))
				     : GET_MODE_PRECISION
					 (GET_MODE (operands[2])))))
			 ? CCZmode : CCNOmode)) && 
#line 12254 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_273 (insn, operands);

        case 2:
          if (!((
#line 12212 "../../gcc/config/i386/i386.md"
(/* Ensure that resulting mask is zero or sign extended operand.  */
   INTVAL (operands[4]) >= 0
   && ((INTVAL (operands[3]) > 0
	&& INTVAL (operands[3]) + INTVAL (operands[4]) <= 32)
       || (DImode == DImode
	   && INTVAL (operands[3]) > 32
	   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
   && ix86_match_ccmode (insn,
			 /* If zero_extract mode precision is the same
			    as len, the SF of the zero_extract
			    comparison will be the most significant
			    extracted bit, but this could be matched
			    after splitting only for pos 0 len all bits
			    trivial extractions.  Require CCZmode.  */
			 (GET_MODE_PRECISION (DImode)
			  == INTVAL (operands[3]))
			 /* Otherwise, require CCZmode if we'd use a mask
			    with the most significant bit set and can't
			    widen it to wider mode.  *testdi_1 also
			    requires CCZmode if the mask has bit
			    31 set and all bits above it clear.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     >= 32)
			 /* We can't widen also if val is not a REG.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     == GET_MODE_PRECISION (GET_MODE (operands[2]))
			     && !register_operand (operands[2],
						   GET_MODE (operands[2])))
			 /* And we shouldn't widen if
			    TARGET_PARTIAL_REG_STALL.  */
			 || (TARGET_PARTIAL_REG_STALL
			     && (INTVAL (operands[3]) + INTVAL (operands[4])
				 >= (paradoxical_subreg_p (operands[2])
				     && (GET_MODE_CLASS
					  (GET_MODE (SUBREG_REG (operands[2])))
					 == MODE_INT)
				     ? GET_MODE_PRECISION
					 (GET_MODE (SUBREG_REG (operands[2])))
				     : GET_MODE_PRECISION
					 (GET_MODE (operands[2])))))
			 ? CCZmode : CCNOmode)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12254 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_274 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return NULL;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x12 = XEXP (x4, 2);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return NULL;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != AND)
        return NULL;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCCmode
          || GET_MODE (x2) != E_CCCmode)
        return NULL;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      switch (pattern1448 (x4))
        {
        case 0:
          if (!(
#line 19166 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19171 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_814 (insn, operands);

        case 1:
          if (!(
#line 19166 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19171 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_816 (insn, operands);

        case 2:
          if (!((
#line 19166 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19171 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_818 (insn, operands);

        case 3:
          if (!((
#line 19166 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19171 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_815 (insn, operands);

        case 4:
          if (!((
#line 19166 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19171 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_817 (insn, operands);

        case 5:
          if (!((
#line 19166 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19171 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_819 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      switch (pattern1488 (x5))
        {
        case 0:
          return gen_split_20 (insn, operands);

        case 1:
          if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) == SUBREG)
        {
          switch (pattern1314 (x4))
            {
            case 0:
              if ((
#line 19324 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19326 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_836 (insn, operands);
              break;

            case 1:
              if (((
#line 19324 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19326 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_837 (insn, operands);
              break;

            default:
              break;
            }
        }
      x7 = XEXP (x5, 2);
      if (GET_CODE (x7) != SUBREG)
        return NULL;
      switch (pattern1316 (x4))
        {
        case 0:
          if (!(
#line 19405 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19410 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_844 (insn, operands);

        case 1:
          if (!((
#line 19405 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19410 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_845 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!x86_64_zext_immediate_operand (operands[2], E_DImode)
          || !
#line 12598 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return NULL;
      return gen_split_286 (insn, operands);

    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x9 = XEXP (x5, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_MODE (x3) != E_QImode
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x10 = XEXP (x5, 0);
      if (!int248_register_operand (x10, E_VOIDmode))
        return NULL;
      operands[2] = x10;
      switch (pattern1676 (x2))
        {
        case 0:
          if ((
#line 12768 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12772 "../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_293 (insn, operands);
          break;

        case 1:
          if ((
#line 12768 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12772 "../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_296 (insn, operands);
          break;

        case 2:
          if (((
#line 12768 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12772 "../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_299 (insn, operands);
          break;

        default:
          break;
        }
      operands[1] = x10;
      switch (pattern1677 (x2))
        {
        case 0:
          if (!(
#line 12801 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12803 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case 1:
          if (!(
#line 12801 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12803 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_305 (insn, operands);

        case 2:
          if (!((
#line 12801 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12803 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_308 (insn, operands);

        case 3:
          if (!
#line 13044 "../../gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_322 (insn, operands);

        case 4:
          if (!
#line 13044 "../../gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_325 (insn, operands);

        case 5:
          if (!(
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 13044 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_328 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x10 = XEXP (x5, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return NULL;
      switch (pattern1430 (x2))
        {
        case 0:
          if (!(
#line 18942 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 18944 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_808 (insn, operands);

        case 1:
          if (!(
#line 18942 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 18944 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_809 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern228 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      res = split_15 (x1, insn);
      if (res != NULL_RTX)
        return res;
      if (GET_CODE (x5) != SUBREG
          || pattern1175 (x4) != 0)
        return NULL;
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      switch (pattern1676 (x3))
        {
        case 0:
          if ((
#line 6995 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 6999 "../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_116 (insn, operands);
          break;

        case 1:
          if ((
#line 6995 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 6999 "../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_117 (insn, operands);
          break;

        case 2:
          if (((
#line 6995 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6999 "../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_118 (insn, operands);
          break;

        default:
          break;
        }
      operands[1] = x7;
      switch (pattern1677 (x3))
        {
        case 0:
          if (!(
#line 7028 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7030 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_119 (insn, operands);

        case 1:
          if (!(
#line 7028 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7030 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_120 (insn, operands);

        case 2:
          if (!((
#line 7028 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 7030 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_121 (insn, operands);

        case 3:
          if (!
#line 7483 "../../gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_134 (insn, operands);

        case 4:
          if (!
#line 7483 "../../gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_135 (insn, operands);

        case 5:
          if (!(
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 7483 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern938 (x3))
        {
        case 0:
          if (!((
#line 6511 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6513 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_100 (insn, operands);

        case 1:
          if (!((
#line 6511 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6513 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_101 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          switch (pattern1152 (x4))
            {
            case 0:
              if (!((
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6544 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!((
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6544 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_105 (insn, operands);

            case 2:
              if (!((
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6575 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_108 (insn, operands);

            case 3:
              if (!((
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6575 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_111 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern1155 (x4))
            {
            case 0:
              if (!(
#line 10136 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10139 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_202 (insn, operands);

            case 1:
              if (!(
#line 10136 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10139 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_203 (insn, operands);

            case 2:
              if (!(
#line 10136 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10139 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_204 (insn, operands);

            case 3:
              if (!((
#line 10136 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10139 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_205 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          switch (pattern1158 (x4))
            {
            case 0:
              if (!(
#line 10157 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10163 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_206 (insn, operands);

            case 1:
              if (!(
#line 10157 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10163 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_207 (insn, operands);

            case 2:
              if (!(
#line 10157 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10163 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_208 (insn, operands);

            case 3:
              if (!((
#line 10157 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10163 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_209 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      switch (pattern1054 (x3))
        {
        case 0:
          if (!((
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6544 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_103 (insn, operands);

        case 1:
          if (!((
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6544 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_106 (insn, operands);

        case 2:
          if (!((
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6575 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_109 (insn, operands);

        case 3:
          if (!((
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6575 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_112 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern1054 (x3))
        {
        case 0:
          if (!((
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6544 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_104 (insn, operands);

        case 1:
          if (!((
#line 6542 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6544 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_107 (insn, operands);

        case 2:
          if (!((
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6575 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_110 (insn, operands);

        case 3:
          if (!((
#line 6573 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6575 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_113 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern358 (x3))
        {
        case 0:
          if (!(
#line 10183 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10186 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (!(
#line 10183 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10186 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_211 (insn, operands);

        case 2:
          if (!(
#line 10183 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10186 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_212 (insn, operands);

        case 3:
          if (!((
#line 10183 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10186 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_213 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern358 (x3))
        {
        case 0:
          if (!(
#line 10204 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10207 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 1:
          if (!(
#line 10204 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10207 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_215 (insn, operands);

        case 2:
          if (!(
#line 10204 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10207 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 3:
          if (!((
#line 10204 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10207 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_217 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      switch (pattern942 (x3))
        {
        case 0:
          if (!(
#line 10252 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10258 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 1:
          if (!(
#line 10252 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10258 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_223 (insn, operands);

        case 2:
          if (!(
#line 10252 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10258 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_224 (insn, operands);

        case 3:
          if (!((
#line 10252 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10258 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_225 (insn, operands);

        case 4:
          if (!(
#line 10281 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10287 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 5:
          if (!(
#line 10281 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10287 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 6:
          if (!(
#line 10281 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10287 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_228 (insn, operands);

        case 7:
          if (!((
#line 10281 "../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10287 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_229 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (pattern946 (x3))
        {
        case 0:
          if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return NULL;
          return gen_split_910 (insn, operands);

        case 1:
          if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return NULL;
          return gen_split_911 (insn, operands);

        case 2:
          if (!(
#line 23158 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 23160 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_913 (insn, operands);

        case 3:
          if (!((
#line 23217 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode)) && 
#line 23219 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_914 (insn, operands);

        case 4:
          if (!((
#line 23217 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode)) && 
#line 23219 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_915 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17
              || GET_MODE (x7) != E_CCmode)
            return NULL;
          if (register_operand (operands[0], E_VOIDmode)
              && register_operand (operands[1], E_VOIDmode)
              && 
#line 27582 "../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && (GET_MODE (operands[0]) == HImode
       || (GET_MODE (operands[0]) == QImode && TARGET_PROMOTE_QImode))))
            return gen_split_976 (insn, operands);
          if (GET_MODE (x4) != E_V2QImode)
            return NULL;
          if (general_reg_operand (operands[0], E_V2QImode)
              && general_reg_operand (operands[1], E_V2QImode)
              && 
#line 3152 "../../gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
            return gen_split_1036 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2QImode)
              || !sse_reg_operand (operands[1], E_V2QImode)
              || !
#line 3179 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1037 (insn, operands);

        case USE:
          switch (pattern832 (x1))
            {
            case 0:
              if (!(
#line 683 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE) && 
#line 685 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1016 (insn, operands);

            case 1:
              if (!(
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1025 (insn, operands);

            case 2:
              if (!((
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1027 (insn, operands);

            case 3:
              if (!(
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1029 (insn, operands);

            case 4:
              if (!((
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1031 (insn, operands);

            case 5:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1248 (insn, operands);

            case 6:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1250 (insn, operands);

            case 7:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1252 (insn, operands);

            case 8:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 413 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1254 (insn, operands);

            case 9:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1256 (insn, operands);

            case 10:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1258 (insn, operands);

            case 11:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1260 (insn, operands);

            case 12:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1262 (insn, operands);

            case 13:
              if (!(
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1264 (insn, operands);

            case 14:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 416 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1266 (insn, operands);

            case 15:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1268 (insn, operands);

            case 16:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1270 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LTU:
    case UNLT:
      operands[1] = x5;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return NULL;
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17)
        return NULL;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern228 (x6, 
E_CCmode, 
17) != 0
          || !general_reg_operand (operands[0], E_VOIDmode)
          || !
#line 27612 "../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && (GET_MODE (operands[0]) == HImode
       || (GET_MODE (operands[0]) == QImode && TARGET_PROMOTE_QImode))))
        return NULL;
      return gen_split_978 (insn, operands);

    case ABS:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return NULL;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern1050 (x4) != 0
              || !(
#line 700 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE) && 
#line 702 "../../gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1017 (insn, operands);

        case E_V2BFmode:
          if (pattern1051 (x4, 
E_V2BFmode) != 0
              || !(
#line 2256 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2258 "../../gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1032 (insn, operands);

        case E_V4BFmode:
          if (pattern1051 (x4, 
E_V4BFmode) != 0
              || !((
#line 2256 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)) && 
#line 2258 "../../gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1033 (insn, operands);

        case E_V2HFmode:
          if (pattern1051 (x4, 
E_V2HFmode) != 0
              || !(
#line 2256 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2258 "../../gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1034 (insn, operands);

        case E_V4HFmode:
          if (pattern1051 (x4, 
E_V4HFmode) != 0
              || !((
#line 2256 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)) && 
#line 2258 "../../gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1035 (insn, operands);

        case E_V16SFmode:
          if (pattern1048 (x4, 
E_V16SFmode) != 0
              || !((
#line 2610 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2612 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_1271 (insn, operands);

        case E_V8SFmode:
          if (pattern1048 (x4, 
E_V8SFmode) != 0
              || !((
#line 2610 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2612 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_1272 (insn, operands);

        case E_V4SFmode:
          if (pattern1048 (x4, 
E_V4SFmode) != 0
              || !(
#line 2610 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 2612 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_1273 (insn, operands);

        case E_V8DFmode:
          if (pattern1048 (x4, 
E_V8DFmode) != 0
              || !((
#line 2610 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2612 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_1274 (insn, operands);

        case E_V4DFmode:
          if (pattern1048 (x4, 
E_V4DFmode) != 0
              || !((
#line 2610 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2612 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_1275 (insn, operands);

        case E_V2DFmode:
          if (pattern1048 (x4, 
E_V2DFmode) != 0
              || !((
#line 2610 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 376 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2612 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_1276 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern932 (x3, 
E_V4HImode) != 0
              || !
#line 3912 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_1044 (insn, operands);

        case E_V2SImode:
          if (pattern932 (x3, 
E_V2SImode) != 0
              || !
#line 3912 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_1045 (insn, operands);

        case E_V1DImode:
          if (pattern932 (x3, 
E_V1DImode) != 0
              || !
#line 3912 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_1046 (insn, operands);

        case E_V2HImode:
          if (pattern932 (x3, 
E_V2HImode) != 0
              || !
#line 3975 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_1048 (insn, operands);

        default:
          return NULL;
        }

    case REG:
      switch (pattern235 (x3))
        {
        case 0:
          if (!
#line 2114 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1173 (insn, operands);

        case 1:
          if (!
#line 2114 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1176 (insn, operands);

        case 2:
          if (!(
#line 2114 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1179 (insn, operands);

        case 3:
          if (!(
#line 2114 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1182 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SS_TRUNCATE)
    return NULL;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != SS_TRUNCATE)
    return NULL;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (pattern269 (x2))
    {
    case 0:
      if (!(
#line 4771 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4776 "../../gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
        return NULL;
      return gen_split_1092 (insn, operands);

    case 1:
      if (!(
#line 4812 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4817 "../../gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
        return NULL;
      return gen_split_1094 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_52 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_DUPLICATE)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern1059 (x2, 
E_V4HFmode, 
E_HFmode) != 0
          || !
#line 5331 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && TARGET_SSE4_1 && reload_completed
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4HFmode))))
        return NULL;
      return gen_split_1104 (insn, operands);

    case E_V4BFmode:
      if (pattern1059 (x2, 
E_V4BFmode, 
E_BFmode) != 0
          || !
#line 5331 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && TARGET_SSE4_1 && reload_completed
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4BFmode))))
        return NULL;
      return gen_split_1105 (insn, operands);

    case E_V4HImode:
      if (pattern1059 (x2, 
E_V4HImode, 
E_HImode) != 0
          || !
#line 5331 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && TARGET_SSE4_1 && reload_completed
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4HImode))))
        return NULL;
      return gen_split_1106 (insn, operands);

    case E_V2HFmode:
      if (pattern1059 (x2, 
E_V2HFmode, 
E_HFmode) != 0
          || !
#line 5996 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2HFmode))))
        return NULL;
      return gen_split_1112 (insn, operands);

    case E_V2BFmode:
      if (pattern1059 (x2, 
E_V2BFmode, 
E_BFmode) != 0
          || !
#line 5996 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2BFmode))))
        return NULL;
      return gen_split_1113 (insn, operands);

    case E_V2HImode:
      if (pattern1059 (x2, 
E_V2HImode, 
E_HImode) != 0
          || !
#line 5996 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2HImode))))
        return NULL;
      return gen_split_1114 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 49
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x5 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x5))
    {
    case LT:
      switch (pattern989 (x5))
        {
        case 0:
          if (!((
#line 22016 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22018 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3402 (insn, operands);

        case 1:
          if (!(
#line 22016 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 22018 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3404 (insn, operands);

        case 2:
          if (!((
#line 22016 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22018 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3406 (insn, operands);

        case 3:
          if (!((
#line 22016 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22018 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3408 (insn, operands);

        case 4:
          if (!(
#line 22328 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 22330 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3444 (insn, operands);

        default:
          return NULL;
        }

    case SUBREG:
      switch (pattern1080 (x5))
        {
        case 0:
          if (!((
#line 22041 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22043 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3410 (insn, operands);

        case 1:
          if (!(
#line 22041 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 22043 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3412 (insn, operands);

        case 2:
          if (!((
#line 22041 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22043 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3414 (insn, operands);

        case 3:
          if (!((
#line 22041 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22043 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3416 (insn, operands);

        case 4:
          if (!((
#line 22080 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22082 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3422 (insn, operands);

        case 5:
          if (!(
#line 22080 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 22082 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3424 (insn, operands);

        case 6:
          if (!((
#line 22080 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22082 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3426 (insn, operands);

        case 7:
          if (!((
#line 22080 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22082 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3428 (insn, operands);

        default:
          return NULL;
        }

    case VEC_MERGE:
      switch (pattern981 (x5))
        {
        case 0:
          if (!((
#line 22357 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22359 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3445 (insn, operands);

        case 1:
          if (!(
#line 22357 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 22359 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3446 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 59)
    return NULL;
  switch (pattern1010 (x2))
    {
    case 0:
      x5 = XVECEXP (x4, 0, 0);
      operands[3] = x5;
      switch (pattern1463 (x2))
        {
        case 0:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1277 (insn, operands);
          break;

        case 1:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1278 (insn, operands);
          break;

        case 2:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1279 (insn, operands);
          break;

        case 3:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1280 (insn, operands);
          break;

        case 4:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1281 (insn, operands);
          break;

        case 5:
          if ((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1282 (insn, operands);
          break;

        case 6:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1283 (insn, operands);
          break;

        case 7:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1284 (insn, operands);
          break;

        case 8:
          if (((
#line 3328 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 3335 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1285 (insn, operands);
          break;

        case 9:
          if (((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4217 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1322 (insn, operands);
          break;

        case 10:
          if ((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4217 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1323 (insn, operands);
          break;

        case 11:
          if (((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4217 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1324 (insn, operands);
          break;

        case 12:
          if (((
#line 4213 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4217 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1325 (insn, operands);
          break;

        case 13:
          if ((
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4246 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1326 (insn, operands);
          break;

        case 14:
          if ((
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4246 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1327 (insn, operands);
          break;

        case 15:
          if (((
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4246 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1328 (insn, operands);
          break;

        case 16:
          if (((
#line 4242 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4246 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_1329 (insn, operands);
          break;

        case 17:
          if (((
#line 18040 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 18045 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3280 (insn, operands);
          break;

        case 18:
          if ((
#line 18040 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 18045 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3281 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return NULL;
      switch (pattern1466 (x2))
        {
        case 0:
          if (!(
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4281 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1330 (insn, operands);

        case 1:
          if (!(
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4281 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1331 (insn, operands);

        case 2:
          if (!((
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4281 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1332 (insn, operands);

        case 3:
          if (!((
#line 4277 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4281 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1333 (insn, operands);

        case 4:
          if (!((
#line 18069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 18076 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3282 (insn, operands);

        case 5:
          if (!(
#line 18069 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 18076 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3283 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!((
#line 18101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 18106 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3284 (insn, operands);

    case 2:
      if (!(
#line 18101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 18106 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3285 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_68 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1651 (insn, operands);

        case 1:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1678 (insn, operands);

        case 2:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1705 (insn, operands);

        case 3:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1732 (insn, operands);

        case 4:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1759 (insn, operands);

        case 5:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1786 (insn, operands);

        case 6:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1813 (insn, operands);

        case 7:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1840 (insn, operands);

        case 8:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1867 (insn, operands);

        case 9:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1894 (insn, operands);

        case 10:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1921 (insn, operands);

        case 11:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1948 (insn, operands);

        case 12:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1654 (insn, operands);

        case 13:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1681 (insn, operands);

        case 14:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1708 (insn, operands);

        case 15:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1735 (insn, operands);

        case 16:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1762 (insn, operands);

        case 17:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1789 (insn, operands);

        case 18:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1816 (insn, operands);

        case 19:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 20:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 21:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1897 (insn, operands);

        case 22:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1924 (insn, operands);

        case 23:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1951 (insn, operands);

        case 24:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1657 (insn, operands);

        case 25:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1684 (insn, operands);

        case 26:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1711 (insn, operands);

        case 27:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1738 (insn, operands);

        case 28:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1765 (insn, operands);

        case 29:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1792 (insn, operands);

        case 30:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1819 (insn, operands);

        case 31:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1846 (insn, operands);

        case 32:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1873 (insn, operands);

        case 33:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1900 (insn, operands);

        case 34:
          if (!((
#line 13790 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1927 (insn, operands);

        case 35:
          if (!(
#line 13790 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1954 (insn, operands);

        case 36:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2947 (insn, operands);

        case 37:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2956 (insn, operands);

        case 38:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2965 (insn, operands);

        case 39:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2974 (insn, operands);

        case 40:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2983 (insn, operands);

        case 41:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2992 (insn, operands);

        case 42:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3001 (insn, operands);

        case 43:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3010 (insn, operands);

        case 44:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3019 (insn, operands);

        case 45:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3028 (insn, operands);

        case 46:
          if (!((
#line 13959 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3037 (insn, operands);

        case 47:
          if (!(
#line 13959 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3046 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2299 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2326 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2353 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2380 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2407 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2434 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2461 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2488 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2515 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2542 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2569 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2596 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2302 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2329 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2356 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2383 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2410 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2437 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2464 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2491 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2518 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2545 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2572 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2599 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern1185 (x2, 
E_V64QImode) != 0
              || !((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2305 (insn, operands);

        case E_V32QImode:
          if (pattern1000 (x2, 
E_V32QImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V32QImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V32QImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V32QImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V32QImode)
                  && ((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2332 (insn, operands);
            }
          if (!register_operand (operands[1], E_V32QImode)
              || !register_operand (operands[2], E_V32QImode)
              || !nonimmediate_operand (operands[3], E_V32QImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3682 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3698 (insn, operands);

        case E_V16QImode:
          if (pattern1000 (x2, 
E_V16QImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16QImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16QImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16QImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16QImode)
                  && (
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2359 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !nonimmediate_operand (operands[3], E_V16QImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3683 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3699 (insn, operands);

        case E_V32HImode:
          if (pattern1185 (x2, 
E_V32HImode) != 0
              || !((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2386 (insn, operands);

        case E_V16HImode:
          if (pattern1000 (x2, 
E_V16HImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16HImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16HImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16HImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16HImode)
                  && ((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2413 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16HImode)
              || !register_operand (operands[2], E_V16HImode)
              || !nonimmediate_operand (operands[3], E_V16HImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3684 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3700 (insn, operands);

        case E_V8HImode:
          if (pattern1000 (x2, 
E_V8HImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8HImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8HImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8HImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8HImode)
                  && (
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2440 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !nonimmediate_operand (operands[3], E_V8HImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3685 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3701 (insn, operands);

        case E_V16SImode:
          if (pattern1185 (x2, 
E_V16SImode) != 0
              || !((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2467 (insn, operands);

        case E_V8SImode:
          if (pattern1000 (x2, 
E_V8SImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8SImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8SImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8SImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8SImode)
                  && ((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2494 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8SImode)
              || !register_operand (operands[2], E_V8SImode)
              || !nonimmediate_operand (operands[3], E_V8SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3686 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3702 (insn, operands);

        case E_V4SImode:
          if (pattern1000 (x2, 
E_V4SImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4SImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4SImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4SImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4SImode)
                  && (
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2521 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !nonimmediate_operand (operands[3], E_V4SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3687 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3703 (insn, operands);

        case E_V8DImode:
          if (pattern1185 (x2, 
E_V8DImode) != 0
              || !((
#line 13875 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2548 (insn, operands);

        case E_V4DImode:
          if (pattern1000 (x2, 
E_V4DImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4DImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4DImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4DImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4DImode)
                  && ((
#line 13875 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2575 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4DImode)
              || !register_operand (operands[2], E_V4DImode)
              || !nonimmediate_operand (operands[3], E_V4DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3688 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3704 (insn, operands);

        case E_V2DImode:
          if (pattern1000 (x2, 
E_V2DImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V2DImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V2DImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V2DImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V2DImode)
                  && (
#line 13875 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2602 (insn, operands);
            }
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !nonimmediate_operand (operands[3], E_V2DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3689 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3705 (insn, operands);

        case E_V2TImode:
          if (pattern1186 (x2, 
E_V2TImode) != 0)
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3690 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3706 (insn, operands);

        case E_V1TImode:
          if (pattern1186 (x2, 
E_V1TImode) != 0)
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26238 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3691 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26250 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3707 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_81 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V64QImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 282 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1119 (insn, operands);
      if (!ternlog_operand (operands[1], E_V64QImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1625 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V32QImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 282 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1120 (insn, operands);
      if (!ternlog_operand (operands[1], E_V32QImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V16QImode)
          && 
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return gen_split_1121 (insn, operands);
      if (!ternlog_operand (operands[1], E_V16QImode)
          || !(
#line 13760 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V32HImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 283 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1122 (insn, operands);
      if (!ternlog_operand (operands[1], E_V32HImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1628 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V16HImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 283 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1123 (insn, operands);
      if (!ternlog_operand (operands[1], E_V16HImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V8HImode)
          && 
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return gen_split_1124 (insn, operands);
      if (!ternlog_operand (operands[1], E_V8HImode)
          || !(
#line 13760 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V16SImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 284 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1125 (insn, operands);
      if (!ternlog_operand (operands[1], E_V16SImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1631 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V8SImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 284 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1126 (insn, operands);
      if (!ternlog_operand (operands[1], E_V8SImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V4SImode)
          && 
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return gen_split_1127 (insn, operands);
      if (!ternlog_operand (operands[1], E_V4SImode)
          || !(
#line 13760 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V8DImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1128 (insn, operands);
      if (!ternlog_operand (operands[1], E_V8DImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1634 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V4DImode)
          && (
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 285 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1129 (insn, operands);
      if (!ternlog_operand (operands[1], E_V4DImode)
          || !((
#line 13760 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1635 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V2DImode)
          && 
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return gen_split_1130 (insn, operands);
      if (!ternlog_operand (operands[1], E_V2DImode)
          || !(
#line 13760 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_1636 (insn, operands);

    case E_V4TImode:
      if (!register_operand (operands[0], E_V4TImode)
          || !int_float_vector_all_ones_operand (operands[1], E_V4TImode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 286 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1131 (insn, operands);

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !int_float_vector_all_ones_operand (operands[1], E_V2TImode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 286 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1132 (insn, operands);

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !int_float_vector_all_ones_operand (operands[1], E_V1TImode)
          || !
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_1133 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V32HFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 287 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1134 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V16HFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 287 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1135 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V8HFmode)
          || !
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_1136 (insn, operands);

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V32BFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 288 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1137 (insn, operands);

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V16BFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 288 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1138 (insn, operands);

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V8BFmode)
          || !
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_1139 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V16SFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 289 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1140 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V8SFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 289 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1141 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V4SFmode)
          && 
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return gen_split_1142 (insn, operands);
      if (!zero_extended_scalar_load_operand (operands[1], E_V4SFmode)
          || !
#line 1912 "../../gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_1171 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V8DFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (64 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 290 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1143 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !int_float_vector_all_ones_operand (operands[1], E_V4DFmode)
          || !(
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (32 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()) && 
#line 290 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1144 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return NULL;
      if (int_float_vector_all_ones_operand (operands[1], E_V2DFmode)
          && 
#line 1558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed
  && (16 == 64 || EXT_REX_SSE_REG_P (operands[0]))
  && optimize_insn_for_speed_p ()))
        return gen_split_1145 (insn, operands);
      if (!zero_extended_scalar_load_operand (operands[1], E_V2DFmode)
          || !
#line 1926 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_1172 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          switch (XVECLEN (x3, 0))
            {
            case 1:
              x6 = XVECEXP (x3, 0, 0);
              operands[1] = x6;
              switch (XINT (x3, 1))
                {
                case 74:
                  if (pattern1057 (x1) != 0
                      || !(
#line 25064 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()) && 
#line 25068 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_917 (insn, operands);

                case 75:
                  if (pattern1057 (x1) != 0
                      || !(
#line 25064 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()) && 
#line 25068 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_918 (insn, operands);

                case 76:
                  if (pattern1057 (x1) != 0
                      || !(
#line 25064 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()) && 
#line 25068 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_919 (insn, operands);

                case 77:
                  if (pattern1057 (x1) != 0
                      || !(
#line 25064 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()) && 
#line 25068 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_920 (insn, operands);

                case 78:
                  switch (pattern1058 (x1))
                    {
                    case 0:
                      if (!(
#line 25181 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()) && 
#line 25185 "../../gcc/config/i386/i386.md"
( 1)))
                        return NULL;
                      return gen_split_921 (insn, operands);

                    case 1:
                      if (!(
#line 25181 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()) && 
#line 25185 "../../gcc/config/i386/i386.md"
( 1)))
                        return NULL;
                      return gen_split_923 (insn, operands);

                    case 2:
                      if (!(
#line 25181 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()) && 
#line 25185 "../../gcc/config/i386/i386.md"
( 1)))
                        return NULL;
                      return gen_split_925 (insn, operands);

                    default:
                      return NULL;
                    }

                case 79:
                  switch (pattern1058 (x1))
                    {
                    case 0:
                      if (!(
#line 25181 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()) && 
#line 25185 "../../gcc/config/i386/i386.md"
( 1)))
                        return NULL;
                      return gen_split_922 (insn, operands);

                    case 1:
                      if (!(
#line 25181 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()) && 
#line 25185 "../../gcc/config/i386/i386.md"
( 1)))
                        return NULL;
                      return gen_split_924 (insn, operands);

                    case 2:
                      if (!(
#line 25181 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()) && 
#line 25185 "../../gcc/config/i386/i386.md"
( 1)))
                        return NULL;
                      return gen_split_926 (insn, operands);

                    default:
                      return NULL;
                    }

                case 118:
                  if (GET_MODE (x3) != E_V4SImode
                      || !register_operand (operands[0], E_V4SImode)
                      || !nonimmediate_operand (operands[1], E_DImode))
                    return NULL;
                  x7 = XEXP (x4, 0);
                  operands[2] = x7;
                  if (!scratch_operand (operands[2], E_V4SImode)
                      || !(
#line 1877 "../../gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC) && 
#line 1879 "../../gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1170 (insn, operands);

                default:
                  return NULL;
                }

            case 3:
              if (XINT (x3, 1) != 52
                  || GET_MODE (x3) != E_V8QImode
                  || pattern934 (x1) != 0
                  || !
#line 23168 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
                return NULL;
              return gen_split_3461 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          switch (pattern213 (x1))
            {
            case 0:
              if (((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_949 (insn, operands);
              if (!((
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_969 (insn, operands);

            case 1:
              if (!((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_953 (insn, operands);

            case 2:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_957 (insn, operands);

            case 3:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_961 (insn, operands);

            case 4:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_965 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern213 (x1))
            {
            case 0:
              if (((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_950 (insn, operands);
              if (!((
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_970 (insn, operands);

            case 1:
              if (!((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_954 (insn, operands);

            case 2:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_958 (insn, operands);

            case 3:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_962 (insn, operands);

            case 4:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_966 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern213 (x1))
            {
            case 0:
              if (((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_951 (insn, operands);
              if (!((
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_971 (insn, operands);

            case 1:
              if (!((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_955 (insn, operands);

            case 2:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_959 (insn, operands);

            case 3:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_963 (insn, operands);

            case 4:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_967 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern213 (x1))
            {
            case 0:
              if (((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_952 (insn, operands);
              if (!((
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_972 (insn, operands);

            case 1:
              if (!((
#line 26752 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 26755 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_956 (insn, operands);

            case 2:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_960 (insn, operands);

            case 3:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_964 (insn, operands);

            case 4:
              if (!(
#line 26810 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 26814 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_968 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case IOR:
        case XOR:
        case ASHIFT:
          return split_36 (x1, insn);

        case COMPARE:
          operands[2] = x3;
          if (!compare_operator (operands[2], E_VOIDmode))
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != AND)
            return NULL;
          x9 = XEXP (x3, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != AND)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!flags_reg_operand (operands[0], E_VOIDmode))
            return NULL;
          x11 = XEXP (x8, 0);
          operands[3] = x11;
          if (!aligned_operand (operands[3], E_VOIDmode))
            return NULL;
          x12 = XEXP (x8, 1);
          operands[4] = x12;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[3]))
            return NULL;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[4])
              || !
#line 27534 "../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && optimize_insn_for_speed_p ()
   && ((GET_MODE (operands[1]) == HImode && ! TARGET_FAST_PREFIX)
       || (GET_MODE (operands[1]) == QImode && TARGET_PROMOTE_QImode))
   /* Ensure that the operand will remain sign-extended immediate.  */
   && ix86_match_ccmode (insn, INTVAL (operands[4]) >= 0 ? CCNOmode : CCZmode)))
            return NULL;
          return gen_split_974 (insn, operands);

        case NEG:
          return split_38 (x1, insn);

        case ABS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x8 = XEXP (x3, 0);
          operands[1] = x8;
          switch (pattern832 (x1))
            {
            case 0:
              if (!(
#line 683 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE) && 
#line 685 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1015 (insn, operands);

            case 1:
              if (!(
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1024 (insn, operands);

            case 2:
              if (!((
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1026 (insn, operands);

            case 3:
              if (!(
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1028 (insn, operands);

            case 4:
              if (!((
#line 2239 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)) && 
#line 2241 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1030 (insn, operands);

            case 5:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1247 (insn, operands);

            case 6:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1249 (insn, operands);

            case 7:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1251 (insn, operands);

            case 8:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 413 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1253 (insn, operands);

            case 9:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1255 (insn, operands);

            case 10:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1257 (insn, operands);

            case 11:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1259 (insn, operands);

            case 12:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1261 (insn, operands);

            case 13:
              if (!(
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1263 (insn, operands);

            case 14:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 416 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1265 (insn, operands);

            case 15:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1267 (insn, operands);

            case 16:
              if (!((
#line 2585 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 2587 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1269 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          x4 = XVECEXP (x1, 0, 1);
          if (pattern405 (x4) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x8 = XEXP (x3, 0);
          operands[1] = x8;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern1247 (x3, 
E_V2QImode) != 0
                  || !
#line 4009 "../../gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return NULL;
              return gen_split_1050 (insn, operands);

            case E_QImode:
              if (pattern1337 (x3, 
E_QImode) != 0
                  || !
#line 2292 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_1215 (insn, operands);

            case E_HImode:
              if (pattern1337 (x3, 
E_HImode) != 0
                  || !
#line 2292 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_1217 (insn, operands);

            case E_SImode:
              if (pattern1337 (x3, 
E_SImode) != 0
                  || !(
#line 2292 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_1219 (insn, operands);

            case E_DImode:
              if (pattern1337 (x3, 
E_DImode) != 0
                  || !(
#line 2292 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_1221 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          if (GET_MODE (x3) != E_V2QImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern350 (x4) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_V2QImode))
            return NULL;
          x8 = XEXP (x3, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V2QImode))
            return NULL;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!nonmemory_operand (operands[2], E_QImode)
              || !
#line 4009 "../../gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
            return NULL;
          return gen_split_1051 (insn, operands);

        case ZERO_EXTEND:
          return split_37 (x1, insn);

        case NE:
        case EQ:
          operands[1] = x3;
          switch (pattern558 (x1))
            {
            case 0:
              if (!((
#line 2383 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)) && 
#line 2385 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1223 (insn, operands);

            case 1:
              if (!(
#line 2383 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 2385 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1224 (insn, operands);

            case 2:
              if (!(
#line 2383 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 2385 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1225 (insn, operands);

            case 3:
              if (!((
#line 2383 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)) && 
#line 2385 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1226 (insn, operands);

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          x8 = XEXP (x3, 0);
          if (!bt_comparison_operator (x8, E_VOIDmode))
            return NULL;
          x12 = XEXP (x8, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern228 (x4, 
E_CCmode, 
17) != 0)
            return NULL;
          switch (pattern1181 (x2))
            {
            case 0:
              if (!((
#line 2418 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)) && 
#line 2420 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1227 (insn, operands);

            case 1:
              if (!(
#line 2418 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 2420 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1228 (insn, operands);

            case 2:
              if (!(
#line 2418 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 2420 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1229 (insn, operands);

            case 3:
              if (!((
#line 2418 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)) && 
#line 2420 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1230 (insn, operands);

            case 4:
              if (!((
#line 2454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)) && 
#line 2456 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1231 (insn, operands);

            case 5:
              if (!(
#line 2454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 2456 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1232 (insn, operands);

            case 6:
              if (!((
#line 2454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW)) && 
#line 2456 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1233 (insn, operands);

            case 7:
              if (!((
#line 2454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)) && 
#line 2456 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1234 (insn, operands);

            case 8:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1235 (insn, operands);

            case 9:
              if (!(
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1238 (insn, operands);

            case 10:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1241 (insn, operands);

            case 11:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1244 (insn, operands);

            case 12:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1236 (insn, operands);

            case 13:
              if (!(
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1239 (insn, operands);

            case 14:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1242 (insn, operands);

            case 15:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1245 (insn, operands);

            case 16:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && ((((
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1237 (insn, operands);

            case 17:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1240 (insn, operands);

            case 18:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && ((((
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1243 (insn, operands);

            case 19:
              if (!((
#line 2497 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && ((((
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))) && 
#line 2500 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_1246 (insn, operands);

            default:
              return NULL;
            }

        case VEC_MERGE:
          if (pattern214 (x1) != 0
              || !
#line 8380 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed
   && SSE_REG_P (operands[2])))
            return NULL;
          return gen_split_1508 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (pattern721 (x1, 
131, 
5) != 0
              || pattern1720 (x1) != 0
              || !(
#line 25855 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2
   && ix86_pre_reload_split ()) && 
#line 25858 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3680 (insn, operands);

        case 3:
          if (pattern721 (x1, 
132, 
3) != 0
              || pattern1721 (x1) != 0
              || !(
#line 25992 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2
   && ix86_pre_reload_split ()) && 
#line 25995 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3681 (insn, operands);

        case 1:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x15) != CLOBBER
              || GET_MODE (x3) != E_DImode)
            return NULL;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!memory_operand (operands[2], E_DImode))
            return NULL;
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          if (!scratch_operand (operands[3], E_DFmode))
            return NULL;
          switch (XINT (x3, 1))
            {
            case 287:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !memory_operand (operands[1], E_DImode)
                  || !(
#line 196 "../../gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)) && 
#line 198 "../../gcc/config/i386/sync.md"
( reload_completed)))
                return NULL;
              return gen_split_3809 (insn, operands);

            case 288:
              if (!memory_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 295 "../../gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)) && 
#line 297 "../../gcc/config/i386/sync.md"
( reload_completed)))
                return NULL;
              return gen_split_3810 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = peephole2_12 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  if (peep2_current_count < 2)
    return NULL;
  if (peep2_current_count >= 3
      && peep2_current_count >= 4)
    {
      if (general_reg_operand (x2, E_SImode))
        {
          res = peephole2_13 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count >= 5
          && pattern596 (x1, 
E_SImode) == 0
          && 
#line 26924 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INSN_UID (peep2_next_insn (0)) == ix86_last_zero_store_uid))
        {
          *pmatch_len_ = 4;
          res = gen_peephole2_223 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  operands[3] = x2;
  if (peep2_current_count >= 3)
    {
      x3 = XEXP (x1, 1);
      if (pattern409 (x3, 
E_SImode) == 0
          && 
#line 26942 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INSN_UID (peep2_next_insn (0)) == ix86_last_zero_store_uid))
        {
          *pmatch_len_ = 2;
          res = gen_peephole2_225 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (general_reg_operand (operands[3], E_SImode))
    {
      x3 = XEXP (x1, 1);
      switch (pattern410 (x3, 
E_SImode))
        {
        case 0:
          if ((
#line 27367 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (2, operands[2])
   && !reg_mentioned_p (operands[3], operands[0])
   && !reg_mentioned_p (operands[3], operands[1])) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_239 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if ((
#line 27367 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (2, operands[2])
   && !reg_mentioned_p (operands[3], operands[0])
   && !reg_mentioned_p (operands[3], operands[1])) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_241 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  operands[2] = x2;
  if (memory_operand (operands[2], E_SImode))
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (general_reg_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x4, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (memory_operand (operands[1], E_SImode)
                  && 
#line 26957 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INSN_UID (peep2_next_insn (0)) == ix86_last_zero_store_uid))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_227 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
    }
  operands[0] = x2;
  if (!general_reg_operand (operands[0], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!x86_64_general_operand (operands[1], E_SImode))
    return NULL;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!general_reg_operand (operands[2], E_SImode))
    return NULL;
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0])
      || !
#line 26974 "../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_231 (insn, operands);
}

 rtx_insn *
peephole2_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  if (!general_reg_operand (x3, E_DImode))
    return NULL;
  operands[8] = x3;
  switch (pattern959 (x1, 
E_DImode, 
E_TImode))
    {
    case 0:
      if ((
#line 9660 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_101 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    case 1:
      if ((
#line 9715 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (6, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && !reg_overlap_mentioned_p (operands[0], operands[10])
   && !reg_overlap_mentioned_p (operands[10], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[11])
   && !reg_overlap_mentioned_p (operands[11], operands[1])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 5;
          res = gen_peephole2_103 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (pattern962 (x1, 
E_DImode) != 0
      || !(
#line 26377 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_208 (insn, operands);
}

 rtx_insn *
peephole2_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (!binary_fp_operator (x3, E_VOIDmode))
    return NULL;
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return NULL;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!memory_operand (operands[3], E_VOIDmode)
          || !
#line 26685 "../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_211 (insn, operands);

    case SUBREG:
    case MEM:
      operands[3] = x5;
      if (!memory_operand (operands[3], E_VOIDmode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (!rtx_equal_p (x6, operands[0])
          || !
#line 26707 "../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_212 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 3)
    {
      res = peephole2_20 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (fp_register_operand (operands[1], E_VOIDmode)
      && fp_register_operand (operands[0], E_VOIDmode))
    {
      res = peephole2_21 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (general_reg_operand (operands[1], E_QImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern411 (x4, 
E_QImode) == 0
          && 
#line 27832 "../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (QImode != QImode
       || any_QIreg_operand (operands[1], QImode))))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_279 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (general_reg_operand (operands[1], E_HImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern411 (x4, 
E_HImode) == 0
          && 
#line 27832 "../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (HImode != QImode
       || any_QIreg_operand (operands[1], QImode))))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_280 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (general_reg_operand (operands[1], E_DImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern411 (x4, 
E_DImode) == 0
          && (
#line 27832 "../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (DImode != QImode
       || any_QIreg_operand (operands[1], QImode))) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_282 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4)
    return NULL;
  if (memory_operand (operands[1], E_QImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern726 (x4, 
E_QImode) == 0)
        {
          x5 = PATTERN (peep2_next_insn (2));
          x6 = XEXP (x5, 0);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = PATTERN (peep2_next_insn (3));
              if (pattern1794 (x7) == 0
                  && 
#line 27923 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
                {
                  *pmatch_len_ = 3;
                  res = gen_peephole2_293 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 5
              && pattern1795 (x6, 
E_QImode) == 0
              && 
#line 28121 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (5, operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[4], operands[1])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (4),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
            {
              *pmatch_len_ = 4;
              res = gen_peephole2_315 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (memory_operand (operands[1], E_HImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern726 (x4, 
E_HImode) == 0)
        {
          x5 = PATTERN (peep2_next_insn (2));
          x6 = XEXP (x5, 0);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = PATTERN (peep2_next_insn (3));
              if (pattern1794 (x7) == 0
                  && 
#line 27923 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
                {
                  *pmatch_len_ = 3;
                  res = gen_peephole2_294 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 5
              && pattern1795 (x6, 
E_HImode) == 0
              && 
#line 28121 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (5, operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[4], operands[1])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (4),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
            {
              *pmatch_len_ = 4;
              res = gen_peephole2_316 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (!memory_operand (operands[1], E_DImode)
      || !register_operand (operands[0], E_DImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return NULL;
  x8 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = XEXP (x8, 1);
  if (!plusminuslogic_operator (x9, E_DImode))
    return NULL;
  operands[3] = x9;
  x10 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x10) != CLOBBER)
    return NULL;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode)
    return NULL;
  x12 = XEXP (x9, 1);
  operands[2] = x12;
  if (!x86_64_nonmemory_operand (operands[2], E_DImode)
      || pattern725 (x8) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (2));
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[1]))
    {
      x7 = PATTERN (peep2_next_insn (3));
      if (pattern1794 (x7) == 0
          && (
#line 27923 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (DImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_296 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (peep2_current_count < 5
      || pattern1795 (x6, 
E_DImode) != 0
      || !(
#line 28121 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (5, operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[4], operands[1])
   && (DImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (4),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
    return NULL;
  *pmatch_len_ = 4;
  return gen_peephole2_318 (insn, operands);
}

 rtx_insn *
peephole2_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_QImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (pattern412 (x3, 
UNSPEC_VOLATILE, 
3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) == 4
      && XINT (x5, 1) == 109
      && GET_MODE (x5) == E_QImode)
    {
      res = peephole2_34 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 110
      || GET_MODE (x5) != E_QImode)
    return NULL;
  x6 = XEXP (x1, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  x7 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_QImode
      || pattern1505 (x3) != 0
      || !memory_operand (operands[1], E_QImode)
      || pattern1684 (x3) != 0)
    return NULL;
  x9 = PATTERN (peep2_next_insn (2));
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 1);
  operands[3] = x11;
  if (!const_int_operand (operands[3], E_QImode))
    return NULL;
  x12 = XEXP (x10, 0);
  if (!rtx_equal_p (x12, operands[0])
      || !
#line 724 "../../gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_415 (insn, operands);
}

 rtx_insn *
peephole2_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_CCCmode)
    return NULL;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_CCCmode)
    return NULL;
  x7 = XEXP (x6, 1);
  if (!rtx_equal_p (x7, operands[0]))
    return NULL;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return NULL;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return NULL;
  x10 = XEXP (x6, 0);
  switch (GET_MODE (x10))
    {
    case E_QImode:
      if (!general_reg_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !
#line 9968 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_104 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !
#line 9968 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_105 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !
#line 9968 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_106 (insn, operands);

    case E_DImode:
      if (!general_reg_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !(
#line 9968 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_107 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMUL_HIGHPART)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return NULL;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  x14 = XEXP (x12, 1);
  operands[5] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1572 (x1, 
E_SImode) != 0
          || !(
#line 10970 "../../gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_112 (insn, operands);

    case E_DImode:
      if (pattern1572 (x1, 
E_DImode) != 0
          || !(
#line 10970 "../../gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_113 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!arith_or_logical_operator (operands[3], E_QImode))
        return NULL;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_QImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27802 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_271 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_QImode)
              && rtx_equal_p (x5, operands[0])
              && 
#line 27815 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_275 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (nonmemory_operand (operands[1], E_QImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && 
#line 27890 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_285 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_QImode)
          || !rtx_equal_p (x5, operands[0])
          || !
#line 27904 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_289 (insn, operands);

    case E_HImode:
      if (!arith_or_logical_operator (operands[3], E_HImode))
        return NULL;
      if (register_operand (operands[0], E_HImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_HImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27802 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_272 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_HImode)
              && rtx_equal_p (x5, operands[0])
              && 
#line 27815 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_276 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (nonmemory_operand (operands[1], E_HImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && 
#line 27890 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_286 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_HImode)
          || !rtx_equal_p (x5, operands[0])
          || !
#line 27904 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_290 (insn, operands);

    case E_SImode:
      if (!arith_or_logical_operator (operands[3], E_SImode))
        return NULL;
      if (register_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27802 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_273 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_SImode)
              && rtx_equal_p (x5, operands[0])
              && 
#line 27815 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_277 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (x86_64_nonmemory_operand (operands[1], E_SImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && 
#line 27890 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_287 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!x86_64_nonmemory_operand (operands[1], E_SImode)
          || !rtx_equal_p (x5, operands[0])
          || !
#line 27904 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_291 (insn, operands);

    case E_DImode:
      if (!arith_or_logical_operator (operands[3], E_DImode))
        return NULL;
      if (register_operand (operands[0], E_DImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_DImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && (
#line 27802 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_274 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_DImode)
              && rtx_equal_p (x5, operands[0])
              && (
#line 27815 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_278 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (x86_64_nonmemory_operand (operands[1], E_DImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && (
#line 27890 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_288 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!x86_64_nonmemory_operand (operands[1], E_DImode)
          || !rtx_equal_p (x5, operands[0])
          || !(
#line 27904 "../../gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_292 (insn, operands);

    default:
      return NULL;
    }
}
